﻿// *********** Kap. 3 Lösungen Kapitel 3. Elementare Datentypen



#include <cstdlib>
#include <random>
#include <ctime>
#include <string>
          
namespace N_Loesungen_Elementare_Datentypen
{
  using namespace System::Windows::Forms;


// *********** Kap. 3 Aufgaben 3.1 Syntaxregeln

  /*
  "zulässige Zeichenfolgen: 1, 11, 112"
  "unzulässige Zeichenfolgen: 0, 01, 011"
  "Ein Dezimalliteral ist eine beliebige Folge der Ziffern 0..9"
  "die nicht mit einer 0 beginnt. "
  */


// *********** Kap. 3 Aufgaben 3.2 Variablen und Bezeichner


  // --------------- Aufgabe 1. -------------------------

  int
    /*
    Preis_in_$,    // unzulässig wegen Sonderzeichen $
    x kleiner y,   // unzulässig wegen der Leerzeichen " "
    Zinssatz_in_%, // unzulässig wegen Sonderzeichen %
    x/y,           // unzulässig wegen Sonderzeichen /
    this,          // unzulässig, da Schlüsselwort
    */
    // Der nächste Name enthalten länderspezifische Buchstaben ("ü"), 
    // die bei vielen ältern Compilern nicht zulässig waren. 
    // In modernen C++-Compilern sind sie zulässig.
    Einwohner_von_Tübingen; // zulässig in Visual C++, aber nicht in gcc


  // --------------- Aufgabe 2. -------------------------

  int i = 0;
  int j;

  void Lsg_Variablen(TextBox^ textBox1)
  {
    using namespace System;
    int k = 1;
    textBox1->AppendText(String::Format("i={0}\r\n", i)); // 0
    textBox1->AppendText(String::Format("j={0}\r\n", j)); // 0: globale Variablen werden 
                                                          //    immer initialisiert
    textBox1->AppendText(String::Format("k={0}\r\n", k)); // 1
    int i;
    textBox1->AppendText(String::Format("i={0}\r\n", i)); // ein unbestimmter Wert
  }



// *********** Kap. 3 Aufgabe 3.3.2 Ganzzahlliterale

  // --------------- Aufgabe 1. -----------------------

  void Lsg_GanzzahlLiterale_1(TextBox^ tb)
  {
    // 1. a)

    // 37 im Binärsystem:
    // 37dez = 1*2^5 + 0*2^4 + 0*2^3 + 1*2^2 + 0*2^1 + 1*2^0 = 0010 0101bin

    //    b)

    // -37 im Zweierkomplement: Einerkomplement(37) +1
    // 1101 1010 + 1 = 1101 1011bin = -37dez

    //    c)
    // 37dez = 2*16^1 + 5*16^0 = 25hex,
    // Alternativ - Die Blöcke aus der Binärdarstellung sind die hex-Ziffern:
    //            0010bin = 2hex, 0101bin = 5hex

    //            37dez  = 0010 0101bin = 25 hex
    //            -37dez = 1101 1011bin = db hex
    using namespace System;
    tb->AppendText("Aufgabe Binärsystem:" + System::Environment::NewLine);
    int i1 = 37;
    // Mit der Format-Angabe {0:X} wird ein Wert hexadezimal angezeigt:
    tb->AppendText(String::Format("1.c) dez: {0} hex: {0:X} \r\n", i1));
    int j1 = -37;
    tb->AppendText(String::Format("1.c) dez: {0} hex: {0:X} \r\n", j1));
    //    d) 37 + (-25)

    //       37: 00100101bin
    //      -25: 11100111bin
    //           -----------
    //          100001100bin, mit 8 bits: 00001100bin = 12dez


    //    e) 25 + (-37)

    //       25: 00011001bin
    //      -37: 11011011bin
    //           -----------
    //           11110100bin --> Zweierkomplement: 00001100bin
  }

  // --------------- Aufgabe 2. -----------------------

  void Lsg_GanzzahlLiterale_2(TextBox^ tb)
  {
    using namespace System;
    // 2. a)

    // Zweierkomplement von ab=1010 1011: 0101 0101 bin = 55 hex = 85 dez,
    // also -85

    tb->AppendText("Aufgabe 3.3.2:\r\n");
    signed char i2 = 0xab;
    tb->AppendText(String::Format("2.a) dez: {0} hex: {0:X} \r\n", i2));

    //    b)

    // ab = 10*16 + 11 = 171

    unsigned char j2 = 0xab;
    tb->AppendText(String::Format("2.b) dez: {0} hex: {0:X} \r\n", j2));
  }

  // --------------- Aufgabe 3. -----------------------

  void Lsg_GanzzahlLiterale_3(TextBox^ tb)
  {
    using namespace System;
    tb->AppendText(String::Format("3.3.2, 3.: 030={0}\r\n", 030));
    // Vorwahl Berlin // 24,
    // da wegen der führenden 0 ein Oktalliteral
    tb->AppendText(String::Format("017+15={0}\r\n", 017 + 15)); // 30
    tb->AppendText(String::Format("0x12+10={0}\r\n", 0x12 + 10)); // 30
  }


// *********** Kap. 3 Aufgabe 3.3.4 Operatoren und die üblichen Konversionen

  void Lsg_Ganzzahl_Operatoren(TextBox^ tb)
  {
    using namespace System;
    {
      // --------------- Aufgabe 1. -----------------------
      // a)
      unsigned char b = 255;
      unsigned char c = 0;
      short i = 1234567898;
      b = b + 1;      // 0
      c = c - 1;      // 255
      int d = i / 100;
      int e = i % 100;
      int f = i + i;

      tb->AppendText(String::Format("b={0} c={1} d={2} e={3} f={4} \r\n",
        b, c, d, e, f));
    }
    {
      // b) nicht zulässige Zeilen wurden auskommentiert:
      unsigned char b = { 255 };
      unsigned char c = { 0 };
      // short i = { 1234567898 };
      // b = { b + 1 };      
      // c = { c - 1 };      
      int d = { i / 100 };
      int e = { i % 100 };
      int f = { i + i };

      tb->AppendText(String::Format("b={0} c={1} d={2} e={3} f={4} \r\n",
        b, c, d, e, f));
    }
  }
    // --------------- Aufgabe 2. -----------------------
    /*
      Falls die beiden Zahlen i und j verschieden sind, ist immer einer der
      beiden Faktoren in (i/j)*(j/i) Null (Ganzzahldivision). Wenn i und j
      dagegen gleich sind, ist das Produkt immer Eins.
    */


    // --------------- Aufgabe 3. -----------------------
    // a)
    // int a=x^x;

    // a erhält immer den Wert 0, da die bitweise Verknüpfung von zwei
    // Operanden mit xor immer den Wert 0 hat.

    // b)
    // int b=x&1;

    // b ist genau dann 1, wenn x ungerade ist.

  // --------------- Aufgabe 4. -----------------------

  // Im Bitmuster von x und y darf nicht an derselben Stelle eine 1 stehen.



// *********** Kap. 3 Aufgabe 3.3.5

  void Lsg_char()
  {
    // Die Variablen in dieser Aufgabe sind mit willkürlichen Werten 
    // initialisiert, was natürlich keinen Sinn macht. Allerdings macht 
    // es auch wenig Sinn, diese Anweisungen isoliert auszuführen. Es 
    // wäre angemessener,diese Anweisungen als Funktionen zu formulieren, 
    // und die Variablenals Parameter zu übergeben. Dann werden sie beim 
    // Aufruf initialisiert.

    // --------------- Aufgabe 1. -----------------------
    // a)
    char c = 'x'; // Initialisierung nur, damit das kompiliert wird
    bool Grossbuchstabe = (c >= 'A') && (c <= 'Z');

    // b)
    bool Buchstabe = ((c >= 'A') && (c <= 'Z')) || ((c >= 'a') && (c <= 'z'));

    // c)
    bool alphanumerisch = ((c >= 'A') && (c <= 'Z')) || ((c >= 'a') && (c <= 'z')) ||
      ((c >= '0') && (c <= '9'));

    // --------------- Aufgabe 2. -----------------------
    int Jahr = 2017;
    bool Schaltjahr = ((Jahr % 4 == 0) && (Jahr % 100 != 0)) || (Jahr % 400 == 0);

    // --------------- Aufgabe 3. -----------------------

    int j1 = 2016, j2 = 2017, m1 = 4, m2 = 5, t1 = 10, t2 = 11;
    bool vorher = (j1 < j2) || ((j1 == j2) && ((m1 < m2) || ((m1 == m2) && (t1 < t2))));

    // --------------- Aufgabe 4. -----------------------

      /*
      bool:
      x y     x&&y       x&y
      f f      f         0000&0000 == 0000 (f)
      f t      f         0000&0001 == 0000 (f)
      t f      f         0001&0000 == 0000 (f)
      t t      t         0001&0001 == 0001 (t)

      int:
      x  y     x&&y            x&y
      0  0    f && f ==f     0&0 == 0 (f)
      0 !0    f && t ==f     0&0 == 0 (f)
      !0 0    t && f ==f     0&0 == 0 (f)
      !0 !0   t && t ==t

      Für bool Operanden x und y ist das Ergebnis von x&&y immer identisch
      mit dem von x&y.

      Für int Operanden ist das Ergebnis in den ersten drei Zeilen gleich.
      In der letzten Zeile erhält man bei !0&!0 nur dann den Wert true,
      wenn sich die bits der Operanden nicht auslöschen. Z.B. erhält man
      mit 1&2 den Wert false, während 1&&2 true ist.
      */

      // --------------- Aufgabe 5. -----------------------
      /*
        In !0 wird der int-Ausdruck 0 in den booleschen Wert false konvertiert.
        Deshalb stellt !0 den Wert true dar.
        Als Operand des binären Operators == wird der boolesche Wert true in
        einer ganzzahligen Typangleichung  in den Wert 1 konvertiert. Deshalb
        entspricht die Bedingung

        if (x==!0) ... // gemeint war if (x!=0) ...

        der Bedingung

        if (x==1) ...
        */
  }

// *********** Kap. 3 Aufgabe 3.4 Kontrollstrukturen und Funktionen

  void initInConstructor(TextBox^ textBox2, TextBox^ textBox3)
  { // 
    // Damit es keine Konversionsfehler gibt, wenn man vergisst, einen
    // ganzzahligen Wert in das Eingabefenster einzugeben.
    // Diese Funktion im Form1-Konstruktor aufrufen.

    textBox2->Text = "10";
    textBox3->Text = "50";
  }


// *********** Kap. 3 Aufgabe 3.4.1 Die if- und die Verbundanweisung

  void Lsg_if(TextBox^ tb)
  {
    { // --------------- Aufgabe 1 -------------------------------

      int x = 0, Punkte = 0, i = 0; // Die Werte 0 wurden nur angegeben, damit 
      // das Programm kompiliert wird. Sie sind für diese Aufgabe ohne Bedeutung.

      // a)
      if (x = 17) tb->AppendText("Volltreffer\r\n");
      // "x=17" ist eine Zuweisung und keine Prüfungen auf Gleichheit
      // Syntaktisch zulässig, aber semantisch wird der Ausdruck x=17
      // in den int-Wert 17 konvertiert, und den in den bool-Wert true.

      // b)
      if (i >= 1 && i <= 10)
        tb->AppendText("Volltreffer\r\n");
      // Syntaktisch und semantisch korrekt. Verknüpfte Bedingungen müssen 
      // nicht geklammert werden.

      // c)
      // if b && (i=j*x) tb->AppendText("Volltreffer\r\n");
      // Syntaxfehler: Die Bedingung in einer if-Anweisung muss in einer Klammer
      // stehen. "=" ist ein Zuweisung und keine Prüfung auf Gleichheit.

      // d)
      if (Punkte >= 0) tb->Text = "Extremes Pech";
      else if (Punkte >= 20) tb->Text = "Ziemliches Pech";
      else if (Punkte >= 40) tb->Text = "Ein wenig Glück gehabt";

      // Syntaktisch korrekt, aber der zweite und dritte else-Zweig werden nie
      // erreicht. Vermutlich „<" mit „>" verwechselt.
    }

    { // --------------- Aufgabe 2 -------------------------------

      /* Hier werden meist zuerst die folgenden beiden Lösungen vorgeschlagen:

        if (Bewegungsart=='+') Kontostand = Kontostand+Betrag;
        else Kontostand = Kontostand-Betrag;

      oder

        if (Bewegungsart=='+') Kontostand = Kontostand+Betrag;
        if (Bewegungsart=='-') Kontostand = Kontostand-Betrag;

      Beide Lösungen haben aber den Nachteil, dass eine unzulässige Bewegungsart
      zu einer falschen Verbuchung des Betrages führt: Im ersten Fall kommt es
      zu einer Abbuchung (so würde ich das machen, wenn die Bank mir gehört),
      und im zweiten Fall fällt jede falsche Kontobewegung unter den Tisch.
      Bei einer größeren Anzahl von Datensätzen bliebe ein solcher Fehler
      vermutlich sogar unentdeckt.

      Fügt man diesen Anweisungen eine weitere hinzu, um eine falsche
      Bewegungsart abzufangen, muss man schon etwas nachdenken, um die richtige
      Bedingung zu finden (hier werden relativ oft && und || verwechselt): Ist

      if ((Bewegungsart != '+') && (Bewegungsart != '-'))
        Fehlermeldung();

      oder || anstelle von && richtig? Falls das Programm dann später auf noch
      andere Bewegungsarten erweitert wird, erhält man zunächst eine falsche
      Fehlermeldung, weil meist vergessen wurde, die Bedingung für die
      Fehlermeldung zu ändern.

      Das Problem bei Aufgaben wie dieser liegt darin, dass die Aufgabenstellung
      zwar die Auswahl einer von zwei Bedingungen nahe legt. Tatsächlich ist aber
      eine Bedingung mehr zu berücksichtigen, nämlich die Fehlerbehandlung.
      Deshalb ist in diesem Beispiel eine von drei Anweisungen auszuwählen:

      if (Bewegungsart=='+') Kontostand = Kontostand + Betrag;
      else if (Bewegungsart=='-') Kontostand = Kontostand - Betrag;
      else Fehlermeldung();
      */
    }
    { // --------------- Aufgabe 3 -------------------------------

      int LA_Summe = 0, LB_Summe = 0, MA_Summe = 0, MB_Summe = 0, MC_Summe = 0, Summe = 0;
      char Lagergruppe = 'A', Materialgruppe = 'B';
      if (Lagergruppe == 'A')
      {
        if (Materialgruppe == 'A')
        {
          LA_Summe = LA_Summe + Summe;
          MA_Summe = MA_Summe + Summe;
        }
        else if (Materialgruppe == 'B')
        {
          LA_Summe = LA_Summe + Summe;
          MB_Summe = MB_Summe + Summe;
        }
        else if (Materialgruppe == 'C')
        {
          LA_Summe = LA_Summe + Summe;
          MC_Summe = MC_Summe + Summe;
        }
        else MessageBox::Show("Unzulässige Materialgruppe in Lager A");
      }
      else if (Lagergruppe == 'B')
      {
        if (Materialgruppe == 'A')
        {
          LB_Summe = LB_Summe + Summe;
          MA_Summe = MA_Summe + Summe;
        }
        else if (Materialgruppe == 'B')
        {
          LB_Summe = LB_Summe + Summe;
          MB_Summe = MB_Summe + Summe;
        }
        else MessageBox::Show("Unzulässige Materialgruppe in Lager B");
      }
      else MessageBox::Show("Unzulässige Lagergruppe");
    }
  { // --------------- Aufgabe 4 -------------------------------

    int t1 = 10, m1 = 2, j1 = 2017; // Datum 1
    // Initialisierung mit beliebigen Werten, damit das kompiliert wird
    int t2 = 2, m2 = 10, j2 = 2017; // Datum 2
    bool vorher;
    if (j1 != j2) vorher = j1 < j2;
    else /* j1==j2 */ if (m1 != m2)
      vorher = m1 < m2;
    else // (j1==j2) and (m1==m2)
      vorher = t1 < t2;

    // Falls die boolesche Variable vorher_oder_gleich genau dann den
    // Wert true erhalten soll, wenn das erste Datum zeitlich vor dem
    // zweiten liegt oder gleich dem zweiten ist, muss lediglich die
    // letzte Zeile auf <= geändert werden zu:
    //
    //   return t1<=t2;
  }
  }

// *********** Kap. 3 Aufgabe 3.4.4 Ganzzahl-Funktionen

// --------------- Aufgabe 1 -------------------------------

// a)
int plus1(int n)
{
  return n + 1;
}

// b) plus1 kann dann in Form1.h wie in Abschnitt ???? aufgerufen werden.

// --------------- Aufgabe 2 -------------------------------
/*
Falls Sie die Lösung dieser Aufgabe nicht sofort finden, können Sie
versuchen, diese zunächst für einfache Spezialfälle zu finden, und
diese Spezialfälle dann zu verallgemeinern.

Erster Spezialfall: n einstellig

  int Quersumme(int n)
  {
  int s = 0;
  s = s + n;
  return s;
  }

Zweiter Spezialfall: n zweistellig

  int Quersumme(int n)
  {
  int s = 0;
  s = s + n/10 + n%10;
  return s;
  }

Berechnet man die Quersumme von n=123 als Summe 3 + 2 + 1 (und nicht als
Summe 1 + 2 + 3), erhält man die erste Ziffer 3 mit n%10. Nachdem man
diese zu einer Summe s addiert hat, kann man diese "abschneiden", indem
man n durch n/10 (12) ersetzt. Diese Schritte wiederholt man in einer
Schleife, bis n==0 ist.
*/
int Quersumme(int n)
{
  if (n < 0) n = -n; // berücksichtige negative n
                     // % ist für negative Operanden compilerabhängig
  int s = 0;
  while (n > 0)
  {
    s = s + n % 10;
    n = n / 10;
  }
  return s;
}

// b), c) Diese Funktion kann dann in Form1.h wie in Abschnitt ???? aufgerufen werden. 




// --------------- Aufgabe 3 -------------------------------
/*
Falls Sie die Lösung dieser Aufgabe nicht sofort finden, können Sie
versuchen, diese zunächst für einfache Spezialfälle zu finden, und
diese Spezialfälle dann zu verallgemeinern.

Erster Spezialfall: n=2

Mit den Anfangswerten

  x = 0, y = 1

erhält man die nächste Fibonacci-Zahl durch

  f = x + y;

Die nächste Fibonacci-Zahl f erhält man dann mit den Werten

  x = y;
  y = f;
  f = x + y;

Diese Schritte wiederholt man in einer Schleife.

*/
// a)
int Fibonacci(int n)
{
  int f = 0, x = 0, y = 1;
  for (int i = 0; i < n; i++)
  {
    x = y;
    y = f;
    f = x + y;
  }
  return f;
}

// b) Diese Funktion kann dann in Form1.h wie in Abschnitt ???? aufgerufen werden. 


// --------------- Aufgabe 4 -------------------------------

void for_Schleife_kleiner_gleich(TextBox^ tb, int n)
{
  for (unsigned int u = 0; u <= n - 1; u++) // warning: Konflikt zwischen 
    tb->AppendText(u.ToString() +
      System::Environment::NewLine);        // signed und unsigned

    // a), b)
    // Da u den Datentyp unsigned int hat, wird der Datentyp von n-1 im
    // Ausdruck u<=n-1 ebenfalls in unsigned int konvertiert. Für n=0 führt
    // das zu einer Endlosschleife. Für Werte n>=1 erhält man das erwartete
    // Ergebnis.

    // c) Mit der Bedingung u<n gibt es auch mit n=0 keine Endlosschleife.
  for (unsigned int u = 0; u < n; u++) // warning: Konflikt zwischen signed
    tb->AppendText(u.ToString() + System::Environment::NewLine); // unsigned
}

// b) Diese Funktion kann dann in Form1.h wie in Abschnitt ???? aufgerufen werden. 



// --------------- Aufgabe 5 -------------------------------
// a)
bool istPrim(int n)
{
  if (n < 2) return false;
  else if (n == 2) return true; // dieser Zweig ist überflüssig
  else
  {
    for (int i = 2; i*i <= n; i++)
      if (n%i == 0) return false;
    return true;
  }
}

bool istPrim_Variante_2(int n) // gleichwertige Alternative
{
  if (n < 2) return false;
  else if (n == 2) return true;
  else
  {
    int i = 2;
    while (i*i <= n)
    {
      if (n%i == 0) return false;
      i++;
    }
    return true;
  }
}

// b)
void zeigePrimzahlen(TextBox^ tb, int n)
{ // Diese Funktion kann dann in Form1.h wie in Abschnitt ???? aufgerufen werden. 
  tb->AppendText("Primzahlen:" + System::Environment::NewLine);
  for (int i = 1; i < n; i++)
    if (istPrim(i))
      tb->AppendText(i.ToString() + " ");
  tb->AppendText(System::Environment::NewLine);
}

// c)
int Goldbach(int n)
{
  if ((n < 4) || (n % 2 == 1)) return -1;
  else
  {
    int k = 0;
    for (int i = 2; i <= n / 2; i++)
      if (istPrim(i) && istPrim(n - i)) k++;
    return k;
  }
}

void zeigeGoldbachPaare(TextBox^ tb, int n)
{ // Diese Funktion kann dann in Form1.h wie in Abschnitt ???? aufgerufen werden. 
  using namespace System;
  tb->AppendText("Goldbach'sche Vermutung:" + System::Environment::NewLine);
  for (int i = 6; i < n; i = i + 2)
    tb->AppendText(String::Format("Goldbach({0})={1}\r\n", i, Goldbach(i)));
}


// --------------- Aufgabe 6 -------------------------------

int zeigePythagTripel(TextBox^ tb, int n, bool show = false)
{ // Diese Funktion kann dann in Form1.h wie in Abschnitt ???? aufgerufen werden.
  using namespace System;
  int nt = 0; // Anzahl der gefundenen Tripel
  for (int a = 1; a < n; a++)
    for (int b = a; b < n; b++)
      for (int c = b; c*c <= a*a + b*b; c++) // "for (int c=1; ..." geht auch
        if (a*a + b*b == c*c)
        {
          if (show)
            tb->AppendText(String::Format(
              "a={0} b={1} c={2}\r\n", a, b, c));
          nt++;
        }
  return nt;
}


// --------------- Aufgabe 7 -------------------------------

int f3nplus1(TextBox^ tb, int n, bool show = false)
{
  if (n <= 0) return -1;
  int m = 0;
  while (n != 1)
  {
    m++;
    if (n % 2 == 1) n = 3 * n + 1;
    else n = n / 2;
    if (show)
      tb->AppendText(" n=" + n.ToString() + System::Environment::NewLine);
  }
  return m;
}

void zeige3nplus1(TextBox^ tb, int n)
{
  for (int i = 0; i < n; i++)
  {
    int k = f3nplus1(tb, i);
    tb->AppendText("i=" + i.ToString() + " k=" + k.ToString() +
      System::Environment::NewLine);
  }
} // Diese Funktion kann dann in Form1.h wie in Abschnitt ???? aufgerufen werden. 


// --------------- Aufgabe 8 -------------------------------
std::string Osterdatum(int J)
{
  int M = -1, N = -1;
  std::string s;
  if (J < 1583) s = " Formel gilt nicht ";

  else if (J < 1700) { M = 22; N = 2; }
  else if (J < 1800) { M = 23; N = 3; }
  else if (J < 1900) { M = 23; N = 4; }
  else if (J < 2100) { M = 24; N = 5; }
  else if (J < 2200) { M = 24; N = 6; }
  else if (J < 2300) { M = 25; N = 0; }
  else s = " Formel gilt nicht ";

  int A = J % 19;
  int B = J % 4;
  int C = J % 7;
  int D = (19 * A + M) % 30;
  int E = (2 * B + 4 * C + 6 * D + N) % 7;
  if ((22 + D + E >= 1) && (22 + D + E <= 31)) // in [1..31])
  {
    int OTag = 22 + D + E;
    int PTag = OTag + 49;
    s = s + std::to_string(J) + " Ostern: " + std::to_string(OTag) + ". März Pfingsten: ";
    if (PTag > 31 + 30 + 31) //  Tage im März + April + Mai
      s = s + std::to_string(PTag - 92) + ". Juni";
    else if (PTag > 30 + 31) // Tage im April + Mai
      s = s + std::to_string(PTag - 61) + ". Mai";
    else s = s + " unmöglich"; // Wegen OTag >= 22 ist PTag >= 71
  }
  else
  {
    int OTag = D + E - 9;
    int PTag = OTag + 49;
    if (OTag == 26) OTag = 19;
    else if ((OTag == 25) && (D == 28) && (E == 6) && (A > 10)) OTag = 18;
    s = s + std::to_string(J) + " Ostern: " + std::to_string(OTag) + ". April Pfingsten: ";
    if (PTag > 30 + 31) // Tage im April + Mai
      s = s + std::to_string(PTag - 61) + ". Juni";
    else if (PTag > 30) // Tage im April
      s = s + std::to_string(PTag - 30) + ". Mai";
    else s = s + " unmöglich"; // wegen OTag >= -9 ist PTag >= 40
  }
  return s;
}

void zeigeOsterdatum(TextBox^ tb, int von, int bis)
{
  for (int J = von; J <= bis; J++)
    tb->AppendText(rk1::to_String(Osterdatum(J)) +
      System::Environment::NewLine);
} // Diese Funktion kann dann in Form1.h wie in Abschnitt ???? aufgerufen werden. 


// --------------- Aufgabe 9 -------------------------------

/*
1. plus1:

   Es wird immer ein Wert zurückgegeben.

2. Quersumme:

   Es wird immer (unabhängig vom Argument n) der Wert von s
   zurückgegeben. s wird für jeden Wert von n mit 0 initialisiert und
   eventuell in der Schleife verändert.

   Wenn man die Funktion dagegen so formuliert hätte
*/
int Quersumme_1(int n)
{
  if (n >= 0)
  {
    int s = 0;
    while (n > 0)
    {
      s = s + n % 10;
      n = n / 10;
    }
    return s;
  }
}

/*
wäre der Funktionswert für Argumente < 0 nicht definiert.

4. Fibonacci

   Es wird immer (unabhängig vom Argument n) der Wert von f
   zurückgegeben. f wird für jeden Wert von n mit 0 initialisiert und
   eventuell in der Schleife verändert.

5. bool prim(int n)
   int Goldbach(int n)

   Da in jedem Zweig der if-Anweisung ein Wert zurückgegeben wird,
   ist der Funktionswert immer definiert.

6. int zeige_PythagZahlentripel(int n): wie 1.

7. int f3nplus1(int n, bool show): gibt entweder -1 oder m zurück,
     falls das keine Endlosschleife ist.

8. Osterdatum(int J): wie 1.
*/


// *********** Kap. 3 Aufgabe 3.4.7 Zufallszahlen


// --------------- Aufgabe 1. -----------------------

void zeigeZufallszahlen(TextBox^ tb)
{
  // Nach 
  //   using std::rand;
  // kann man statt std::rand einfach nur rand verwenden

  tb->AppendText("rand ohne srand" + System::Environment::NewLine);
  for (int i = 0; i < 5; i++)
  {
    tb->AppendText(std::rand().ToString() + System::Environment::NewLine);
  }

  tb->AppendText("rand mit srand(std::time(0))" +
    System::Environment::NewLine);

  srand(std::time(0));
  for (int i = 0; i < 5; i++)
  {
    tb->AppendText(std::rand().ToString() + System::Environment::NewLine);
  }

  tb->AppendText("minstd_rand ohne init" + System::Environment::NewLine);
  std::minstd_rand rnd;
  for (int i = 0; i < 5; i++)
  {
    int r = rnd();
    tb->AppendText(r.ToString() + System::Environment::NewLine);
  }

  tb->AppendText("5 aus 49 mit init std::time(0)" +
    System::Environment::NewLine);
  rnd.seed(std::time(0)); // oder: std::minstd_rand rnd(std::time(0));
  for (int i = 0; i < 5; i++)
  {
    int r = 1 + rnd() % 49;
    tb->AppendText(r.ToString() + System::Environment::NewLine);
  }
} // Diese Funktion kann dann in Form1.h wie in Abschnitt ???? aufgerufen werden. 


// *********** Kap. 3 Aufgabe 3.4.8 Default-Argumente

// --------------- Aufgabe 1. -----------------------

// Nur nach der ersten Variante.


// *********** Kap. 3 Aufgabe 3.4.9 Programmierstil
// --------------- Aufgabe 1. -----------------------

// Diese Funktion führt offsichtlich viele verschiedene Aufgaben aus.
// Deshalb gibt es keinen passenden Namen für sie.

// --------------- Aufgabe 2. -----------------------
/* Ein Beispiel dafür, wie verwirrend falsche Namen sein können.
int x = Plus(1, Product(Minus(3, 4), Plus(5, 6)));
      = Plus(1, Product(    12,       -1))
      = Plus(1,11)
      = 10
*/

// *********** Kap. 3 Aufgabe 3.4.10 rekursive Funktionen
// --------------- Aufgabe 1 -------------------------------

// a)
int rek_Fak(int n)
{ // Fakultät rekursiv berechnen
  if (n <= 0) return 1;
  else return n*rek_Fak(n - 1);
}

// b)
int rek_Fib(int n)
{ // Fibonacci rekursiv berechnen
  if (n <= 0) return 0;
  else if (n == 1) return 1;
  else return rek_Fib(n - 1) + rek_Fib(n - 2);
}

// c)
int rek_ggT(int m, int n)
{ // ggT rekursiv berechnen
  if (n == 0) return m;
  else return rek_ggT(n, m%n);
}

// a)
int it_Fak(int n)
{
  int f = 1;
  for (int i = 2; i <= n; i++)
    f = f*i;
  return f;
}

// b)
int it_Fib(int n)
{ // Fibonacci iterativ berechnen
  int fib = 0, f0 = 0, f1 = 1;
  for (int i = 0; i < n; i++)
  {
    fib = f0 + f1;
    f1 = f0;
    f0 = fib;
  }
  return fib;
}

// c)
int it_ggT(int x, int y)
{
  // x=x0, y=y0, ggT(x,y) = ggT(x0,y0)
  while (y != 0) //            Ablaufprot. für den Schleifenkörper
  {               //                        x        y        r
                  // ggT(x,y)=ggT(x0,y0)                 x0        y0        r0
    int r = x % y;//                                        x0 mod y0    +
    x = y;       //                               y0
    y = r;       //                                x0 mod y0
                 // ggT(x,y) = ggT(y0,x0 mod y0) = ggT(x0,y0)
                 // ggT(x,y)=ggT(x0,y0)
  }
  // ggT(x,y) = ggT(x0,y0) und y=0
  return x;
};

void zeige_rek(TextBox^ tb)
{
  tb->AppendText("Rekursion: No news are good news" +
    System::Environment::NewLine);

  for (int i = 1; i < 50; i++)
    if (rek_Fak(i) != it_Fak(i))
      tb->AppendText(i.ToString() + System::Environment::NewLine);

  for (int i = 1; i < 50; i++)
    for (int j = 1; j < 50; j++)
      if (rek_ggT(i, j) != it_ggT(i, j))
        tb->AppendText(i.ToString() + " " + j.ToString() +
          System::Environment::NewLine);

  for (int i = 1; i < 30; i++)
    if (rek_Fib(i) != it_Fib(i))
      tb->AppendText(i.ToString() + System::Environment::NewLine);
}

#ifdef SIMPLEUNITTESTS_H__ 
// Dieses Makro wird durch ein #include "SimpleUnitTests.h" definiert
void Unittests_rekursive_Funktionen()
{
  for (int i = 1; i < 50; i++)
    rk1::Assert::AreEqual(rek_Fak(i), it_Fak(i), "rek_Fak/it_Fak, i=" +
      std::to_string(i));

  for (int i = 1; i < 30; i++)
    rk1::Assert::AreEqual(rek_Fib(i), it_Fib(i), "rek_Fib/it_Fib, i=" +
      std::to_string(i));

  for (int i = 1; i < 50; i++)
    for (int j = 1; j < 50; j++)
      rk1::Assert::AreEqual(rek_ggT(i, j), it_ggT(i, j),
        "ggT(" + std::to_string(i) + "," + std::to_string(j) + ")");
}
#endif

// --------------- Aufgabe 2 -------------------------------
int Ackermann(int n, int m)
{ // Ackermann-Funktion 
  if (n == 0) return m + 1;
  else if (m == 0) return Ackermann(n - 1, 1);
  else return Ackermann(n - 1, Ackermann(n, m - 1));
}

void zeige_Ackermann(TextBox^ tb)
{
  /*
  Ackermann(0,m) = m+1
  Ackermann(1,m) = m+2
  Ackermann(2,m) = 2*m+3
  Ackermann(3,m) = 2^(m+3)+1
  */
  tb->AppendText("Ackermann: No news are good news" +
    System::Environment::NewLine);

  for (int m = 0; m < 50; m++)
    if (Ackermann(0, m) != m + 1)
      tb->AppendText("Unterschied für ack(0," + m.ToString() + ")\r\n");

  for (int m = 0; m < 50; m++)
    if (Ackermann(1, m) != m + 2)
      tb->AppendText("Unterschied für ack(1," + m.ToString() + ")\r\n");

  for (int m = 0; m < 50; m++)
    if (Ackermann(2, m) != 2 * m + 3)
      tb->AppendText("Unterschied für ack(2," + m.ToString() + ")\r\n");

  // für m>10 dauert das recht lange:
  for (int m = 0; m < 9; m++)
  {
    int a = Ackermann(3, m);
    int e = std::pow(double(2), m + 3) - 3;
    if (a != e)
      tb->AppendText("Unterschied für ack(3," + m.ToString() + ")\r\n");
  }
}

#ifdef SIMPLEUNITTESTS_H__ 
// Dieses Makro wird durch ein #include "SimpleUnitTests.h" definiert
void Unittests_Ackermann(int max)
{
  /*
  Ackermann(0,m) = m+1
  Ackermann(1,m) = m+2
  Ackermann(2,m) = 2*m+3
  Ackermann(3,m) = 2^(m+3)+1
  */
  for (int m = 0; m < max; m++)
    rk1::Assert::AreEqual(m + 1, Ackermann(0, m), "ack(0," +
      std::to_string(m) + ")");

  for (int m = 0; m < max; m++)
    rk1::Assert::AreEqual(m + 2, Ackermann(1, m), "ack(1," +
      std::to_string(m) + ")");

  for (int m = 0; m < max; m++)
    rk1::Assert::AreEqual(2 * m + 3, Ackermann(2, m), "ack(2," +
      std::to_string(m) + ")");

  // für m>10 dauert das recht lange:
  for (int m = 0; m < 10; m++)
  {
    int a = Ackermann(3, m);
    int e = std::pow(double(2), m + 3) - 3;
    rk1::Assert::AreEqual(e, a, "Ackermann(3," + std::to_string(m) + ")");
  }
}
#endif


#ifdef SIMPLEUNITTESTS_H__ 
// Dieses Makro wird durch ein #include "SimpleUnitTests.h" definiert
void Unittests_Rekursion()
{
  rk1::Assert::Init("Unittests_Rekursion");
  Unittests_rekursive_Funktionen();
  Unittests_Ackermann(30);
  rk1::Assert::Summary();
}
#endif

// *********** Kap. 3 Aufgabe 3.4.11 switch
// --------------- Aufgabe 1 -------------------------------

int LA_Summe, LB_Summe, MA_Summe, MB_Summe, MC_Summe, Summe;

void LagMatSwitch(char Lagergruppe, char Materialgruppe)
{
  switch (Lagergruppe)
  {
  case 'A':
    switch (Materialgruppe)
    {
    case 'A': LA_Summe = LA_Summe + Summe;
      MA_Summe = MA_Summe + Summe;
      break;
    case 'B': LA_Summe = LA_Summe + Summe;
      MB_Summe = MB_Summe + Summe;
      break;
    case 'C': LA_Summe = LA_Summe + Summe;
      MC_Summe = MC_Summe + Summe;
      break;
    default:  MessageBox::Show("Unzulässige Materialgruppe in Lager A");
    }
  case 'B':
    switch (Materialgruppe)
    {
    case 'A': LB_Summe = LB_Summe + Summe;
      MA_Summe = MA_Summe + Summe;
      break;
    case 'B': LB_Summe = LB_Summe + Summe;
      MB_Summe = MB_Summe + Summe;
      break;
    default:  MessageBox::Show("Unzulässige Materialgruppe in Lager B");
    }
  default: MessageBox::Show("Unzulässige Lagergruppe");
  }
}

// --------------- Aufgabe 2 -------------------------------

  // Da die Bedingungen nicht durch eine Prüfung auf Gleichheit mit einer
  // Konstanten gebildet werden, ist eine Lösung mit switch nicht möglich.



// *********** Kap. 3 Aufgabe 3.5 Gleitkommadatentypen
#define _USE_MATH_DEFINES
// --------------- Aufgabe 1. ------------------------------

void GleitkommaSyntax(TextBox^ tb)
{
  int j = 10, k = 6;
  double x = j, y = 3.14, z = 10;

  double d1 = j / k;        // 1
  double d2 = x / k;        // 1.666..
  int i1 = j / k;           // 1
  int i2 = x / k;           // 1
  // int i3 = 3(j+k);       // i3 = 3*(j+k) würde gehen
  int i4 = j / k / k;       // 0, wird von links nach rechts ausgewertet
  int i5 = j / (z / y);     // 3
  int i6 = j / (y - j / k); // 4

  using namespace System;
  tb->AppendText(String::Format("d1={0} d2={1} \r\n", d1, d2));
  tb->AppendText(String::Format("i1={0} i2={1} \r\n", i1, i2));
  tb->AppendText(String::Format("i4={0} i5={1} i6={2} \r\n", i4, i5, i6));
}

// --------------- Aufgabe 2. ------------------------------

double RegentropfenPi(int n)
{
  int Treffer = 0;
  for (int i = 0; i < n; i++)
  {
    double x = (0.0 + rand()) / RAND_MAX; // für rand: #include <cstdlib>
    double y = (0.0 + rand()) / RAND_MAX;
    if (x*x + y*y < 1) Treffer++;
  }
  return 4.0*Treffer / n;
}

void zeigeRegentropfenPi(TextBox^ tb, int n)
{
  tb->AppendText(RegentropfenPi(n).ToString() + System::Environment::NewLine);
}

// --------------- Aufgabe 3. ------------------------------

int Fakultaet(int n)
{
  int f = 1;
  for (int i = 2; i <= n; i++)
    f = f*i;
  return f;
}

double doubleFakulaet(int n)
{
  double f = 1;
  for (int i = 2; i <= n; i++)
    f = f*i;
  return f;
}

void zeigeFakultaet(TextBox^ tb)
{
  using namespace System;
  for (int i = 1; i < 30; i++)
    tb->AppendText(String::Format("Fakultaet({0})={1} \r\n", i, Fakultaet(i)));

  for (int i = 1; i < 30; i++)
  {
    double f = doubleFakulaet(i);
    double Sekunden = f / 1000000.0;
    double Jahre = Sekunden / (60.0 * 60 * 24 * 365);
    tb->AppendText(String::Format("Fakultät({0})={1} Sek={2} Jahre={3}\r\n",
      i, Fakultaet(i), Sekunden, Jahre));
  }
}

// --------------- Aufgabe 4. ------------------------------

void HypothekenRestschuld(TextBox^ tb, double Betrag, double Zinssatz, double Tilgungsrate)
{
  using namespace System;
  // Die Ergebnisse stimmen mit denen von Tilgungsrechnern im Internet überein (z.B. 
  // http://www.interhyp.de/interhyp/servlet/interhyp?cmd=showPartnerTilgungsrechnerContent&LAF_PARTNER=sueddeutsche).
  double Restschuld = Betrag;
  double Annuitaet = Restschuld*(Zinssatz + Tilgungsrate) / 100;
  int Jahre = 0;

  String^ s = String::Format("Hypothek: {0} Annuitaet: {1}", Restschuld, Annuitaet);
  tb->AppendText(s);
  while (Restschuld > 0)
  {
    double Zinsen = Restschuld*Zinssatz / 100;
    Restschuld = Restschuld - (Annuitaet - Zinsen);
    Jahre++;
    s = String::Format("Ende {0}. Jahr: Restschuld={1:f2}  Zinsen={2:f2} Tilgung={3:f2}",
      Jahre, Restschuld, Zinsen, Annuitaet - Zinsen);
    tb->AppendText(s + System::Environment::NewLine);
  }
};

// --------------- Aufgabe 5. ------------------------------

// #include <cmath> für fabs, cmath ist etwas C++-spezifischer als <math.h> 

double TrapezSumme(double a, double b, int n)
{
  double s = (std::sqrt(1 - a*a) + std::sqrt(1 - b*b)) / 2;
  double h = (b - a) / n;
  for (int i = 1; i < n; i++)
    s = s + std::sqrt(1 - (a + i*h)*(a + i*h));
  return s*h;
}

void zeigeTrapezsumme(TextBox^ tb, int n)
{
  double t = TrapezSumme(0, 1, n);
  tb->AppendText("Trapezsumme=" + (4 * t).ToString() +
    System::Environment::NewLine);
}

// --------------- Aufgabe 6. ------------------------------

double Mises(int n)
{
  double q = 1;
  for (int i = 0; i < n - 1; i++)
    q = q*(364 - i) / 365;
  return 1 - q; // 0 für n<=1
}

void zeigeMises(TextBox^ tb)
{
  for (int i = 1; i < 50; i++)
    //    if (i%5 == 0)
    tb->AppendText("n=" + i.ToString() + "  p=" + Mises(i).ToString() +
      System::Environment::NewLine);
}

// --------------- Aufgabe 7. ------------------------------

int RoundToInt(double x)
{
  if (x >= 0)
    return x + 0.5;
  else
    return x - 0.5;
}

void zeigeRoundToInt(TextBox^ tb)
{
  for (double x = -2; x < 2; x = x + 0.1)
    tb->AppendText(x.ToString() + ": " + RoundToInt(x).ToString() +
      System::Environment::NewLine);
}



// --------------- Aufgabe 8. -----------------------------

void HowLongDouble()
{
  double x = 1e8;
  while (x > 0)
    --x;
}

void HowLongFloat()
{
  float x = 1e8;
  while (x > 0)
    --x;
  // Diese Schleife (mit float anstelle double) ist eine Endlosschleife.
  // Da float nur 6 signifikante Stellen hat, ist 100000000 - 1 == 100000000.
}



// *********** Kap. 3 Aufgabe ??? 3.6.4 Systematisches Testen

// --------------- Aufgabe 1 -------------------------------

/*
Falls Sie Ihre Sollwerte aus den Quelltexten oder aus der Ausführung
Ihres Programms zur Lösung dieser Aufgaben abgeleitet haben, sind Ihre
Tests wertlos.
Die Sollwerte für einen Test müssen immer aus der Spezifikation
abgeleitet werden. Das sind in diesem Fall die Aufgaben aus
Abschnitt 3.4.

Die folgenden Test erfüllen die Mindestanforderung, jeden
Schleifenkörper nie, einmal und mindestens einmal auszuführen. Außerdem
wird jeder if-Zweig einmal ausgeführt:

a) if-Zweig: mit n<0;
   Schleife 0 mal: n==0; 1 mal: 1<=n<=9; 2 mal: 10<=n<=99

   Das wird mit den folgenden Testfällen erreicht:
   {n=-1;Quersumme=1 | n=0;Quersumme=0 | n=12;Quersumme=3 }

b) Schleife 0 mal: n<=0; 1 mal: n==1; 2 mal: n==2

   Das wird mit den folgenden Testfällen erreicht:
   {n=-1;Fibonacci=0 | n=0;Fibonacci=0 | n=1;Fibonacci=1 |
    n=2;Fibonacci=1 }

c) if-Zweig I:  mit n<2;
   if-Zweig II: mit n==2;
   if-Zweig III: mit n>2;
                 Schleife 0 mal: n==3
                 1 mal: 4<=n<=8,   if nie: n==5,7;   if ja: n==4,6,8
                 2 mal: 9<=n<=15,  if nie: n==11,13; if ja: 9,10,12,14,15

   Das wird mit den folgenden Testfällen erreicht:
   {n=1;istPrim=false | n=2;istPrim=true | n=3;istPrim=true | n=4;istPrim=false|
    n=5;istPrim=true | n=9;istPrim=false | n=11;istPrim=true }

d) if: n<4, n gerade;   n==2
   n<4, n ungerade: n==3
   n==4:            n==4
   n>4, n ungerade: n==5
   n>4, n gerade,
        Schleife 0 mal: geht nicht
        Schleife 1 mal: n==4
        Schleife 2 mal: n==6

   Das wird mit den folgenden Testfällen erreicht:
   {n=2;Goldbach=-1 | n=3;Goldbach=-1 | n=4;Goldbach=1 |
    n=5;Goldbach=-1 | n=6;Goldbach=1 | n=100;Goldbach=6 |
    n=1000;Goldbach=28}

e) Schleife 0 mal: n<=1
   1 mal: n==2 for a: 1 mal
   for b: 1 mal
   for c: 1 mal
   Prüfe mit n=5, ob das Tripel {3,4,5} entdeckt wird

   {n=0;Pythag=0 | n=1;Pythag=0 | n=5;Pythag=1 | n=50;Pythag=26}

f) if: n<=1           n==1
   Schleife 0 mal: geht nicht mit n>1
   1 mal: n==2
   2 mal: n==4
   ungerades n für if in der Schleife: n==3

   Das wird mit den folgenden Testfällen erreicht:
   {n=1;f3nplus1=0 | n=2;f3nplus1=1 | n=3;f3nplus1=7 |
    n=4;f3nplus1=2 }

g) Anzahl Pfadtests

   MAX=2.147.483.648

   a) 1+Stellenzahl(MAX)=11 Tests (1: für n<0, 1: für n=0,
      1: für jede Stellenzahl)
   b) MAX Tests
   c) 2+2^sqrt(MAX)=2+2^65536 Tests
   d) 1+2^((MAX-4)/2) Tests

*/

// --------------- Aufgabe 2. ------------------------------
/*
-  Funktionen, deren Ergebnis sehr aufwendig zu berechnen ist, wie
   z.B. Wettervorhersagen.

-  Funktionen mit Zufallszahlen (wie z.B. RegentropfenPi) sind oft schwer
   zu testen. Zwar muss bei dieser Aufgabe ein Wert in der Nähe von 3.14
   zurückgegeben werden. Aber ein Fehler wie

      for (int i = 1; i<n; i++) anstelle von
      for (int i = 0; i<n; i++)

    mit einer anschließenden Division durch n

      return 4.0*Treffer/n;

    ist mit Tests nur schwer zu finden.

- Das Ergebnis der Funktion

     HypothekenRestschuld(double Betrag, double Zinssatz, double Tilgungsrate)

   besteht aus vielen Werten, die nicht wie bei den meisten der bisherigen
   Aufgaben als Funktionswert zurückgegeben werden können.
   Die manuelle Berechnung der Ergebnisse ist recht mühsam:

   Hypothek: 100: Zinsen=5, Tilgung=10, Annuität 15
   Restschuld   Zinsen     Tilgung
   Ende 1.Jahr:    90          5          10
   Ende 2.Jahr:    79.5        4.5        10.5
   Ende 3.Jahr:    68.475      3.975      11.025
   Ende 4.Jahr:    56.8987     3.4237     11.5763
   Ende 5.Jahr:    44.7436     2.8449     12.1551
   Ende 6.Jahr:    31.9807     2.2371     12.7629
   Ende 7.Jahr:    18.5797     1.599      13.401
   Ende 8.Jahr:     4.5086     0.9289     14.0711
   Ende 9.Jahr:                0.2254     Schlusszahlung 14.30

- Trapezsumme

   Hier ist zwar klar, dass ein Wert in der Nähe von 3.14 zurückgegeben
   werden muss. Aber kleine, systematische Fehler können mit Tests nur
   schwer entdeckt werden (siehe die Anmerkungen zu Aufgabe 2. oben).
   Für größere Werte von n sind Tests zeitaufwendig.

   Eine Alternative können Tests sein, bei denen die Fläche unter
   solchen Funktionen berechnet wird, bei denen man die Fläche auch exakt
   über das Integral berechnen kann. Z.B. ist die Fläche von a bis b unter
   Funktion x^2 durch (b^3 - a^3)/3 gegeben.

*/


// *********** Kap. 3 Aufgabe 3.6.5 Unittests

#ifdef SIMPLEUNITTESTS_H__ 
// Dieses Makro wird durch ein #include "SimpleUnitTests.h" definiert

// --------------- Aufgabe 1 -------------------------------

void Unittests_QuerSumme()
{// ein einfacher Test für die Funktion QuerSumme
 // a) {n=-1;Quersumme=1 | n=0;Quersumme=0 | n=12;Quersumme=3 }
  rk1::Assert::AreEqual(Quersumme(-1), 1, "Quersumme(-1)");
  rk1::Assert::AreEqual(Quersumme(0), 0, "Quersumme( 0)");
  rk1::Assert::AreEqual(Quersumme(12), 3, "Quersumme(12)");
}

void Unittests_Fibonacci()
{ // b) {n=-1,Fibonacci=0 | n=0,Fibonacci=0 | n=1,Fibonacci=1 |
  //     n=2,Fibonacci=1 }
  rk1::Assert::AreEqual(Fibonacci(-1), 0, "Fibonacci(-1)");
  rk1::Assert::AreEqual(Fibonacci(0), 0, "Fibonacci(0)");
  rk1::Assert::AreEqual(Fibonacci(1), 1, "Fibonacci(1)");
  rk1::Assert::AreEqual(Fibonacci(2), 1, "Fibonacci(2)");
}

void Unittests_prim()
{// c) {n=1;prim=false | n=2;prim=true | n=3;prim=true | n=4;prim=false |
 //     n=5;prim=true | n=9;prim=false | n=11;prim=true }
  rk1::Assert::AreEqual(istPrim(1), false, "istPrim(1)");
  rk1::Assert::AreEqual(istPrim(2), true, "istPrim(2)");
  rk1::Assert::AreEqual(istPrim(3), true, "istPrim(3)");
  rk1::Assert::AreEqual(istPrim(4), false, "istPrim(4)");
  rk1::Assert::AreEqual(istPrim(5), true, "istPrim(5)");
  rk1::Assert::AreEqual(istPrim(9), false, "istPrim(9)");
  rk1::Assert::AreEqual(istPrim(11), true, "istPrim(11)");
}

void Unittests_Goldbach()
{ // d) {n=2;Goldbach=-1 | n=3;Goldbach=-1 | n=4;Goldbach=1 |
  //     n=5;Goldbach=-1 | n=5;Goldbach=-1 | n=100;Goldbach=6 |
  //     n=1000;Goldbach=28 }
  rk1::Assert::AreEqual(Goldbach(2), -1, "Goldbach(2)");
  rk1::Assert::AreEqual(Goldbach(3), -1, "Goldbach(3)");
  rk1::Assert::AreEqual(Goldbach(4), 1, "Goldbach(4)");
  rk1::Assert::AreEqual(Goldbach(5), -1, "Goldbach(5)");
  rk1::Assert::AreEqual(Goldbach(6), 1, "Goldbach(6)");
  rk1::Assert::AreEqual(Goldbach(100), 6, "Goldbach(100)");
  rk1::Assert::AreEqual(Goldbach(1000), 28, "Goldbach(1000)");
}

void Unittests_PythagTripel(TextBox^ tb)
{ // e) {n=0;Pythag=0 | n=1;Pythag=0 | n=5;Pythag=1 | n=50;Pythag=26}
  rk1::Assert::AreEqual(zeigePythagTripel(tb, 0, false), 0, "zeige_PythagTripel(0)");
  rk1::Assert::AreEqual(zeigePythagTripel(tb, 1, false), 0, "zeige_PythagTripel(1)");
  rk1::Assert::AreEqual(zeigePythagTripel(tb, 5, false), 1, "zeige_PythagTripel(5)");
  rk1::Assert::AreEqual(zeigePythagTripel(tb, 50, false), 26, "zeige_PythagTripel(26)");
}


void Unittests_f3nplus1(TextBox^ tb)
{ // f) {n=1;f3nplus1=0 | n=2;f3nplus1=1 | n=3;f3nplus1=7 |
  //     n=4;f3nplus1=2 }
  rk1::Assert::AreEqual(f3nplus1(tb, 1, false), 0, "f3nplus1(1)");
  rk1::Assert::AreEqual(f3nplus1(tb, 2, false), 1, "f3nplus1(2)");
  rk1::Assert::AreEqual(f3nplus1(tb, 3, false), 7, "f3nplus1(3)");
  rk1::Assert::AreEqual(f3nplus1(tb, 4, false), 2, "f3nplus1(4)");
}


// ???
void Unittests_Fakultaet()
{// 3. {n=0,Fakultaet=1 | n=1,Fakultaet=1 | n=2,Fakultaet=2 |
 //     n=3,Fakultaet=6 }
  bool result = true;
  rk1::Assert::AreEqual(Fakultaet(0), 1, "Fakultaet(0)");
  rk1::Assert::AreEqual(Fakultaet(1), 1, "Fakultaet(1)");
  rk1::Assert::AreEqual(Fakultaet(2), 2, "Fakultaet(2)");
  rk1::Assert::AreEqual(Fakultaet(3), 6, "Fakultaet(3)");

  // 3. {n=0,doubleFakulaet=1 | n=1,doubleFakulaet=1 |
  //     n=2,doubleFakulaet=2 | n=3,doubleFakulaet=6 }
  rk1::Assert::AreEqual(doubleFakulaet(0), 1, "doubleFakulaet(0)");
  rk1::Assert::AreEqual(doubleFakulaet(1), 1, "doubleFakulaet(1)");
  rk1::Assert::AreEqual(doubleFakulaet(2), 2, "doubleFakulaet(2)");
  rk1::Assert::AreEqual(doubleFakulaet(3), 6, "doubleFakulaet(3)");
}

// 4. Mit den bisher vorgestellten Sprachelementen sind keine
//    automatischen Tests möglich

// 5. Mit den bisher vorgestellten Sprachelementen sind keine
//    automatischen Tests möglich


void Unittests_Mises()
{// 6. {n=1,Mises=0 | n=1,Mises=1-364.0/365 |
 //     n=2,Mises=1-(364.0*363)/(365.0*365) |
 //     n=3,Mises=1-(364.0*363*362)/(365.0*365*365) }
  rk1::Assert::AreEqual(Mises(1), 0, "Mises(1)");
  rk1::Assert::AreEqual(Mises(2), 1 - 364.0 / 365, "Mises(2)");
  rk1::Assert::AreEqual(Mises(3), 1 - (364.0 * 363) / (365.0 * 365), "Mises(3)");
  rk1::Assert::AreEqual(Mises(4), 1 - (364.0 * 363 * 362) / (365.0 * 365 * 365),
    "Mises(4)");
}

void Unittests_RoundToInt()
{ // 7.  {n=3.64,RoundToInt=4 | n=3.14,RoundToInt=3 |
  //     n=-3.14,RoundToInt=-3 | n=-3.64,RoundToInt=-4 }
  rk1::Assert::AreEqual(RoundToInt(3.64), 4, "RoundToInt(3.64)");
  rk1::Assert::AreEqual(RoundToInt(3.14), 3, "RoundToInt(3.14)");
  rk1::Assert::AreEqual(RoundToInt(-3.14), -3, "RoundToInt(-3.14)");
  rk1::Assert::AreEqual(RoundToInt(-3.64), -4, "RoundToInt(-3.64)");
}


void Unittests_3_6(TextBox^ tb)
{
  rk1::Assert::Init("Unittests_3_6"); // Tests initialisieren
    Unittests_QuerSumme();
    Unittests_Fibonacci();
    Unittests_prim();
    Unittests_Goldbach();
    Unittests_PythagTripel(tb);
    Unittests_f3nplus1(tb);

    Unittests_Fakultaet();
    Unittests_RoundToInt();
    Unittests_Mises();
    rk1::Assert::Summary(); // Testzusammenfassung ausgeben
  }
#endif // #ifdef SIMPLEUNITTESTS_H__ 
// *********** Kap. 3 Aufgabe 3.6.6 ??? Ablaufprotokolle

// *********** Kap. 3 Aufgabe 3.9 Exception-Handling
  int throwException(int n)
  {
    if (n < 0)
      throw std::invalid_argument("throwException: negatives Argument nicht zulässig");
    return n;
  }

  int verschachtelterAufruf(int n)
  {
    return throwException(n);
  }

    void Aufruf_throwException(TextBox^ textBox1, int Aufgabe)
  {
    int result = 0;
    if (Aufgabe == 1) // a)
    {
      try
      {
        result = throwException(-1);
      }
      catch (std::exception& e)
      {
        System::String^ msg = gcnew System::String(e.what());
        textBox1->AppendText(msg + "\r\n");
      }
    }
    else if (Aufgabe == 2) // b)
    {
      result = throwException(-1);
    }
    else // c)
    {
      try
      {
        result = verschachtelterAufruf(-1);
      }
      catch (std::exception& e)
      {
        System::String^ msg = gcnew System::String(e.what());
        textBox1->AppendText(msg + "\r\n");
      }
    }
  }

// *********** Kap. 3 Aufgabe 3.10 Namensbereiche
  // Die Lösung dieser Aufgabe sind die Namensbereiche
  // in dieser Quelltextdatei.

// *********** Kap. 3 Aufgabe 3.11 Präprozessoranweisungen
#include "a.h"  // int i = 0;
#include "b.h"  // #include "a.h"
                // int j = i + 1;


// a): Durch diese #include-Anweisungen wird die Definition von i 
//     zirkulär (rekursiv) in die aktuelle Datei aufgenommen

// b): Das kann man mit einem #pragma once oder mit einem Include-Guard
//     unterbinden:
//     Entweder in die Dateien 

//       #pragma once

//     aufnehmen, oder
//     a.h:
//         #ifndef _A_INCLUDE_GUARD 
//         #define _A_INCLUDE_GUARD

//         int a = 0;

//         #endif  /* _A_INCLUDE_GUARD */ 

//     b.h:
//         #ifndef _B_INCLUDE_GUARD 
//         #define _B_INCLUDE_GUARD

//         #include "a.h"
//         int b = a + 1;

//         #endif  /* _B_INCLUDE_GUARD */ 




#ifdef SIMPLEUNITTESTS_H__ 

  void Unittests_Kap_3(TextBox^ tb)
  {
    rk1::OpenConsole(); /// ???

    rk1::Assert::Init("Unittests Kapitel 3"); // Tests initialisieren
    Unittests_3_6(tb);
    Unittests_Rekursion();
    rk1::Assert::Summary();// Testzusammenfassung ausgeben
  }
#endif // #ifdef SIMPLEUNITTESTS_H__ 



  void zeige_Ergebnisse(TextBox^ tb)
  { // ??? reichen da nicht die ButtonClicks?
    Lsg_Variablen(tb);
    Lsg_Ganzzahl_Operatoren(tb);
    Lsg_char();
    Lsg_if(tb);
  }

} // end of namespace N_Aufgaben_Elementare_Datentypen
