﻿// *********** Kap. 4 Lösungen Kapitel 4. String


#include <string>
#include <regex>

namespace N_Loesungen_Strings {

// *********** Kap. 4 Aufgabe 4.3 Elementfunktionen

  using namespace System;
  using namespace System::Windows::Forms;

  // --------------- Aufgabe 1 -------------------------------


  // a) 

  int AnzahlZeichen(const std::string& s, char c)
  {
    int n = 0;
    for (int i = 0; i < s.length(); i++)
    {
      if (s[i] == c)
        n++;
    }
    return n;
  }

#ifdef SIMPLEUNITTESTS_H__ 
  // Dieses Makro wird durch ein #include "SimpleUnitTests.h" definiert
  void Unittests_AnzahlZeichen()
  {
    rk1::Assert::WriteLine("Unittests_AnzahlZeichen");
    rk1::Assert::AreEqual(0, AnzahlZeichen("", 'x'), "AnzahlZeichen 0");
    rk1::Assert::AreEqual(0, AnzahlZeichen(" ", 'e'), "AnzahlZeichen  1");
    rk1::Assert::AreEqual(1, AnzahlZeichen(" ", ' '), "AnzahlZeichen  2");
    rk1::Assert::AreEqual(4, AnzahlZeichen("Alle meine Entchen", 'e'), "AnzahlZeichen 3");
  }
#endif // #ifdef SIMPLEUNITTESTS_H__ 

  // b) 

  bool Contains(const std::string& s, const std::string& c)
  {
    bool result = (s.find(c) != std::string::npos);
    return result;
  }

#ifdef SIMPLEUNITTESTS_H__ 
  // Dieses Makro wird durch ein #include "SimpleUnitTests.h" definiert
  void Unittests_Contains()
  {
    rk1::Assert::WriteLine("Unittests_Contains");
    rk1::Assert::AreEqual(true, Contains("", ""), "Contains 0");
    rk1::Assert::AreEqual(true, Contains("x", "x"), "Contains 1");
    rk1::Assert::AreEqual(true, Contains("Maxl", "x"), "Contains 2");
    rk1::Assert::AreEqual(true, Contains("Maxxl", "xx"), "Contains 3");
    rk1::Assert::AreEqual(true, Contains("Maxxyz", "z"), "Contains 4");
    rk1::Assert::AreEqual(false, Contains("xyz", "a"), "Contains 5");
  }
#endif // #ifdef SIMPLEUNITTESTS_H__ 

  // c) 

  bool Split3(std::string s, std::string& s1, std::string& s2, std::string& s3)
  {
    bool success = false;
    int p1 = s.find('.');
    if (p1 >= 1)
    {
      s1 = s.substr(0, p1);
      int p2 = s.find('.', p1 + 1);
      if (p2 >= p1 + 1)
      {
        s2 = s.substr(p1 + 1, p2 - p1 - 1);
        s3 = s.substr(p2 + 1);
        success = true; // 2 Punkte gefunden
      }
    }
    return success;
  }

#ifdef SIMPLEUNITTESTS_H__ 
  // Dieses Makro wird durch ein #include "SimpleUnitTests.h" definiert

  void assertEqual(std::string s1_exp, std::string  s2_exp, std::string  s3_exp,
    bool res_exp,
    std::string  s1_act, std::string  s2_act, std::string  s3_act,
    bool res_act, std::string msg)
  {
    rk1::Assert::AreEqual(s1_exp, s1_act, "s1 " + msg);
    rk1::Assert::AreEqual(s2_exp, s2_act, "s2 " + msg);
    rk1::Assert::AreEqual(s3_exp, s3_act, "s3 " + msg);
    rk1::Assert::AreEqual(res_exp, res_act, "result " + msg);
  }

  void test_Split3(std::string s, std::string s1_exp, std::string s2_exp, std::string s3_exp, bool res_exp)
  {
    std::string  t, m, j;
    bool result = Split3(s, t, m, j);
    assertEqual(t, m, j, result, s1_exp, s2_exp, s3_exp, res_exp, "test_Split3: " + s);
  }

  void Unittests_Split3()
  {
    rk1::Assert::WriteLine("Unittests_Split3");
    bool result = true;
    // teste alle üblichen Kombinationen
    // Jahr zweistellig, Tag und Monat einstellig und zweistellig
    test_Split3("1.2.07", "1", "2", "07", true);
    test_Split3("12.3.07", "12", "3", "07", true);
    test_Split3("1.12.07", "1", "12", "07", true);
    test_Split3("17.18.07", "17", "18", "07", true);

    // Jahr vierstellig, Tag und Monat einstellig und zweistellig
    test_Split3("1.2.1920", "1", "2", "1920", true);
    test_Split3("12.3.1920", "12", "3", "1920", true);
    test_Split3("1.12.1920", "1", "12", "1920", true);
    test_Split3("17.18.1920", "17", "18", "1920", true);

    // Teste unzulässige Formate. Das Programm sollte nicht abstürzen:
    test_Split3("", "", "", "", false);
    test_Split3(".", "", "", "", false);
    test_Split3("1", "", "", "", false);
    test_Split3("1.", "1", "", "", false);
    test_Split3("1.2", "1", "", "", false);
    test_Split3("..", "", "", "", false);
    test_Split3("...", "", "", "", false);
    test_Split3("abc", "", "", "", false);
    test_Split3("1. Dezember ", "1", "", "", false);
  }
#endif // #ifdef SIMPLEUNITTESTS_H__ 


  // d) 

  std::string TrimLeft(const std::string& str)
  {
    size_t first = str.find_first_not_of(' ');
    if (std::string::npos == first)
    { // alle Zeichen sind ' '
      return ""; // str;
    }
    else // 0<=first<str.length()
    { // bis zur Position first alles weglassen
      return str.substr(first);
    }
  }

  std::string TrimRight(const std::string& str)
  {
    size_t first = str.find_last_not_of(' ');
    if (std::string::npos == first)
    { // alle Zeichen sind ' '
      return "";
    }
    else
    {
      return str.substr(0, first + 1);
    }
  }

#ifdef SIMPLEUNITTESTS_H__ 
  // Dieses Makro wird durch ein #include "SimpleUnitTests.h" definiert
  void Unittests_Trim()
  {
    std::string s = TrimLeft("   abc  "); // s = "abc  "
    rk1::Assert::WriteLine("Unittests_Trim");
    rk1::Assert::AreEqual("", TrimLeft(""), "TrimLeft 0");
    rk1::Assert::AreEqual("x", TrimLeft("x"), "TrimLeft 1");
    rk1::Assert::AreEqual("x", TrimLeft(" x"), "TrimLeft 2");
    rk1::Assert::AreEqual("x ", TrimLeft(" x "), "TrimLeft 3");
    rk1::Assert::AreEqual("x y", TrimLeft(" x y"), "TrimLeft 4");
    rk1::Assert::AreEqual("x y ", TrimLeft(" x y "), "TrimLeft 5");
    rk1::Assert::AreEqual("", TrimLeft(" "), "TrimLeft 6");
    rk1::Assert::AreEqual("", TrimLeft("  "), "TrimLeft 7");

    rk1::Assert::AreEqual("", TrimRight(""), "TrimRight 0");
    rk1::Assert::AreEqual("x", TrimRight("x"), "TrimRight 1");
    rk1::Assert::AreEqual(" x", TrimRight(" x"), "TrimRight 2");
    rk1::Assert::AreEqual(" x", TrimRight(" x "), "TrimRight 3");
    rk1::Assert::AreEqual(" x y", TrimRight(" x y"), "TrimRight 4");
    rk1::Assert::AreEqual(" x y", TrimRight(" x y "), "TrimRight 5");
    rk1::Assert::AreEqual("", TrimRight(" "), "TrimRight 6");
    rk1::Assert::AreEqual("", TrimRight("  "), "TrimRight 7");
  }
#endif // #ifdef SIMPLEUNITTESTS_H__ 

  // e) 

  int ReplaceAll(std::string& str, const std::string& from, const std::string& to)
  {
    int n = 0;
    if (from == "")
      return 0;
    size_t pos = pos = str.find(from);
    while (pos != std::string::npos)
    {
      str.replace(pos, from.length(), to);
      n++;
      pos += to.length();
      pos = str.find(from, pos);
    }
    return n;
  }

#ifdef SIMPLEUNITTESTS_H__ 
  // Dieses Makro wird durch ein #include "SimpleUnitTests.h" definiert
  void Unittests_ReplaceAll()
  {
    rk1::Assert::WriteLine("Unittests_ReplaceAll");
    std::string s = "";
    rk1::Assert::AreEqual(0, ReplaceAll(s, "", "x"), "ReplaceAll 0");
    rk1::Assert::AreEqual("", s, "ReplaceAll 0s");
    s = "a";
    rk1::Assert::AreEqual(1, ReplaceAll(s, "a", "x"), "ReplaceAll 1");
    rk1::Assert::AreEqual("x", s, "ReplaceAll 1s");
    s = "aa";
    rk1::Assert::AreEqual(2, ReplaceAll(s, "a", "x"), "ReplaceAll 2");
    rk1::Assert::AreEqual("xx", s, "ReplaceAll 2s");
    s = "baa";
    rk1::Assert::AreEqual(2, ReplaceAll(s, "a", "x"), "ReplaceAll 3");
    rk1::Assert::AreEqual("bxx", s, "ReplaceAll 3s");
    s = "baab";
    rk1::Assert::AreEqual(2, ReplaceAll(s, "a", "x"), "ReplaceAll 4");
    rk1::Assert::AreEqual("bxxb", s, "ReplaceAll 4s");

    s = "baabaa";
    rk1::Assert::AreEqual(2, ReplaceAll(s, "ba", "x"), "ReplaceAll 10");
    rk1::Assert::AreEqual("xaxa", s, "ReplaceAll 10s");

    s = "baabaa";
    rk1::Assert::AreEqual(2, ReplaceAll(s, "aa", "xyz"), "ReplaceAll 11");
    rk1::Assert::AreEqual("bxyzbxyz", s, "ReplaceAll 11s");
  }
#endif // #ifdef SIMPLEUNITTESTS_H__ 


  // --------------- Aufgabe 2. -------------------------
  // a)
  void tokenize_0(TextBox^ tb, const std::string& s, std::string separators = ";.,- ")
  { // ";.,- " ist ein Default Argument für den Parameter separators
  // Damit kann tokenize ohne Argument für den zweiten Parameter aufgerufen
  // werden. separators kann auch als lokale Variable definiert werden.
    using std::string;
    tb->AppendText("tokenize string: " + rk1::to_String(s) + "\r\n");
    string::size_type pos_tok = s.find_first_not_of(separators);
    while (pos_tok != string::npos)
    { // token gefunden ab Position pos_tok
      string::size_type pos_sep = s.find_first_of(separators, pos_tok);
      if (pos_sep == string::npos)
        pos_sep = s.length();
      string token = s.substr(pos_tok, pos_sep - pos_tok);
      tb->AppendText("token: '" + rk1::to_String(token) + "'\r\n");
      pos_tok = s.find_first_not_of(separators, pos_sep + 1);
    }
  }

  void zeigeTokenize_0(TextBox^ tb)
  {
    tokenize_0(tb, ""); // leerer String , keine Ausgabe
    tokenize_0(tb, " "); // nur Separator, keine Ausgabe
    tokenize_0(tb, "123"); // nur ein token, Ausgabe "123"
    tokenize_0(tb, ";123"); // Separator am Anfang, ein token, Ausgabe "123"
    tokenize_0(tb, "123;"); // Separator am Ende, ein token, Ausgabe "123"
    tokenize_0(tb, ";123;"); // Separator am Anfang und Ende, ein token, Ausgabe "123"
    tokenize_0(tb, "456 ab.xy"); // Ausgabe "456", "ab", "xy"
    tokenize_0(tb, " 456 ab.xy"); // Separator am Anfang, Ausgabe "456","ab","xy"
    tokenize_0(tb, "456 ab.xy;"); // Separator am Ende, Ausgabe "456","ab","xy"
    tokenize_0(tb, " 456 ab.xy;"); // Separator am Anfang und am Ende, Ausgabe
             // "456", "ab", "xy"
  }

  void zeigeTokenize_0(TextBox^ tbin, TextBox^ tbout)
  {
    std::string in = rk1::to_string(tbin->Text);
    tokenize_0(tbout, in);
  }



  // --------------- Aufgabe 3. ------------------------

  std::string generatePassword(int n)
  {  // sehr einfach
    srand(std::time(0)); // #include <ctime>
    std::string result;
    // for (int i = 0; i < n; i++) // kann zu result.length()<n führen
    while (result.length() < n)
    {
      char c = rand() % 127;
      if (c > ' ' && c < 'z')
        result += c;
    }
    return result;
  }

#ifdef SIMPLEUNITTESTS_H__ 
  // Dieses Makro wird durch ein #include "SimpleUnitTests.h" definiert
  void Unittests_generatePassword()
  {
    rk1::Assert::WriteLine("Unittests_generatePassword");
    // Ohne (int) ist der Aufruf mehrdeutig, da i den Datentyp int
    // und length den Datentyp size_t hat.
    for (int i = 0; i < 10; i++)
      rk1::Assert::AreEqual(i, (int)generatePassword(i).length(),
        "generatePassword(" + std::to_string(i) + ")");
    // Da die erzeugten Passwörter zufällig sind,
    // nur die Länge prüfen.
  }
#endif // #ifdef SIMPLEUNITTESTS_H__ 


  // --------------- Aufgabe 4. ------------------------

  std::string uintToBinaryString(unsigned int n)
  {
    std::string s;
    for (int i = 1; i <= 8 * sizeof(n); i++)
    {
      if (n % 2 == 1) s = "1" + s;
      else s = "0" + s;
      n = n / 2;
      // Mit den folgenden Anweisungen funktioniert das auch für negative 
      // int-Argumente:
      //   if (n & 1 == 1) s = "1" + s;
      //   else s = "0" + s;
      //   n = n >> 1;
    }
    return s;
  }

#ifdef SIMPLEUNITTESTS_H__ 
  // Dieses Makro wird durch ein #include "SimpleUnitTests.h" definiert
  void Unittests_uintToBinaryString()
  {
    rk1::Assert::WriteLine("Unittests_uintToBinaryString");
    std::string s = "00000000000000000000000000000000";
    rk1::Assert::AreEqual(uintToBinaryString(0), s, "toBinStr 0");
    s = "00000000000000000000000000000001";
    rk1::Assert::AreEqual(uintToBinaryString(1), s, "toBinStr 1");
    s = "00000000000000000000000000000010";
    rk1::Assert::AreEqual(uintToBinaryString(2), s, "toBinStr 2");
    s = "00000000000000000000000000000011";
    rk1::Assert::AreEqual(uintToBinaryString(3), s, "toBinStr 3");
    s = "11111111111111111111111111111111";
    rk1::Assert::AreEqual(uintToBinaryString(-1), s, "toBinStr -1");
  }
#endif // #ifdef SIMPLEUNITTESTS_H__ 


  void show_uintToBinaryString(TextBox^ tb, String^ s)
  {
    for (int i = 0; i <= 8; i++)
      tb->AppendText(rk1::to_String(uintToBinaryString(i)) + "\r\n");

    int x;
    if (int::TryParse(s, x))
    {
      std::string result = uintToBinaryString(x);
      tb->AppendText(rk1::to_String(result) + "\r\n");
    }
    else
    {
      MessageBox::Show("int-Wert eingeben");
    }
  }

  // --------------- Aufgabe 5. ------------------------

  int Max(int a, int b)
  {
    if (a > b) return a;
    else return b;
  }

  std::string BigIntAdd(std::string a, std::string b)
  {
    std::string s;
    int m;
    m = Max(a.length(), b.length());
    int ue = 0;
    for (int i = 0; i < m; i++)
    {
      int ai, bi;
      if (i < a.length())
        ai = a[a.length() - i - 1] - '0';
      else
        ai = 0;
      if (i < b.length())
        bi = b[b.length() - i - 1] - '0';
      else
        bi = 0;
      int r = (ai + bi + ue) % 10;
      ue = (ai + bi + ue) / 10;
      std::string
        ziffer[] = { "0", "1", "2", "3", "4", "5", "6", "7", "8", "9" };
      s = ziffer[r] + s;
    }
    if (ue > 0) s = "1" + s;
    return s;
  }

  void showBigIntAdd(TextBox^ tb, String^ a, String^ b)
  { // Diese Funktion kann bei einem ButtonClick aufgerufen werden:
  // showBigIntAdd(textBox1, textBox2->Text, textBox3->Text);
    int x, y;
    if (int::TryParse(a, x) && int::TryParse(b, y))
    {
      std::string sa = rk1::to_string(a);
      std::string sb = rk1::to_string(b);
      tb->AppendText(a + "+" + b + "=" + rk1::to_String(BigIntAdd(sa, sb)) + "\r\n");
    }
    else
      MessageBox::Show("int-Werte eingeben");

    return;
    // oder
    std::string s = "1";
    for (int i = 1; i <= 100; i++)
    {
      s = BigIntAdd(s, s);
      tb->AppendText("2^" + i.ToString() + "=" + rk1::to_String(s) + "\r\n");
    }
  }

#ifdef SIMPLEUNITTESTS_H__ 
  // Dieses Makro wird durch ein #include "SimpleUnitTests.h" definiert
  void Unittests_BigIntAdd(int n)
  {
    rk1::Assert::WriteLine("Unittests_BigIntAdd");
    std::string s = "0";
    rk1::Assert::AreEqual(BigIntAdd("0", "0"), s, "BigIntAdd: 0+0==0");
    s = "2";
    rk1::Assert::AreEqual(BigIntAdd("1", "1"), s, "BigIntAdd: 1+1==2");
    s = "3";
    rk1::Assert::AreEqual(BigIntAdd("1", "2"), s, "BigIntAdd: 1+2==3");
    s = "10";
    rk1::Assert::AreEqual(BigIntAdd("1", "9"), s, "BigIntAdd: 1+9==10");
    // Check random numbers:
    for (int i = 0; i < n; i++)
    {
      int op1 = rand();
      int op2 = rand();
      std::string op1s = std::to_string(op1);
      std::string op2s = std::to_string(op2);
      std::string s = std::to_string(op1 + op2);
      rk1::Assert::AreEqual(BigIntAdd(op1s, op2s), s,
        "BigIntAdd: " + op1s + "+" + op2s + "=" + s);
    }
  }
#endif // #ifdef SIMPLEUNITTESTS_H__ 


// *********** Kap. 4 Aufgabe 4.4 Konversionen zwischen string und elementaren Datentypen

  // --------------- Aufgabe 1 -------------------------------

  bool stringToDate(std::string date, int& Tag, int& Monat, int& Jahr)
  {
    bool success = false;
    Tag = -1;
    Monat = -1;
    Jahr = -1;
    std::string dstr, mstr, ystr;
    if (Split3(date, dstr, mstr, ystr))
    {
      success = true; // 2 Punkte gefunden
      try { // oder mit try_parse aus dem Buchmanuskript
        Tag = std::stoi(dstr);
        Monat = std::stoi(mstr);
        Jahr = std::stoi(ystr);
      }
      catch (...)
      {
        success = false;
      }
    }
    return success;
  }

  void showStringToDate(TextBox^ tb, std::string s)
  {
    int Tag = 0, Monat = 0, Jahr = 0;
    if (stringToDate(s, Tag, Monat, Jahr))
      tb->AppendText(rk1::to_String(s) + ": Tag=" + Tag.ToString() + " Monat=" + Monat.ToString() +
        " Jahr=" + Jahr.ToString() + "\r\n");
    else
      tb->AppendText(rk1::to_String(s) + "kann nicht konvertiert werden");
  }

#ifdef SIMPLEUNITTESTS_H__ 
  // Dieses Makro wird durch ein #include "SimpleUnitTests.h" definiert

  void AssertEqual_Date(std::string s, int Tag_exp, int Mon_exp, int Jahr_exp, bool res_exp)
  { // prüft alle Ergebnisse von stringToDate
    int t, m, j;
    bool res_act = stringToDate(s, t, m, j);
    if (res_act)
    {
      rk1::Assert::AreEqual(Tag_exp, t, "Tag " + s);
      rk1::Assert::AreEqual(Mon_exp, m, "Monat " + s);
      rk1::Assert::AreEqual(Jahr_exp, j, "Jahr " + s);
    }
    rk1::Assert::AreEqual(res_exp, res_act, "result " + s);
  }

  void Unittests_StringToDate()
  {
    rk1::Assert::WriteLine("Unittests_StringToDate");
    bool result = true;
    // teste alle üblichen Kombinationen
    // Jahr zweistellig, Tag und Monat einstellig und zweistellig
    AssertEqual_Date("1.2.07", 1, 2, 7, true);
    AssertEqual_Date("12.3.07", 12, 3, 7, true);
    AssertEqual_Date("1.12.07", 1, 12, 7, true);
    AssertEqual_Date("17.18.07", 17, 18, 7, true);

    // Jahr vierstellig, Tag und Monat einstellig und zweistellig
    AssertEqual_Date("1.2.1920", 1, 2, 1920, true);
    AssertEqual_Date("12.3.1920", 12, 3, 1920, true);
    AssertEqual_Date("1.12.1920", 1, 12, 1920, true);
    AssertEqual_Date("17.18.1920", 17, 18, 1920, true);

    // Teste unzulässige Formate. Das Programm sollte nicht abstürzen
    //                            und -1 zurückgeben:
    AssertEqual_Date("", -1, -1, -1, false);
    AssertEqual_Date(".", -1, -1, -1, false);
    AssertEqual_Date("1", -1, -1, -1, false);
    AssertEqual_Date("1.", -1, -1, -1, false);
    AssertEqual_Date("1.2", -1, -1, -1, false);
    AssertEqual_Date("..", -1, -1, -1, false);
    AssertEqual_Date("...", -1, -1, -1, false);
    AssertEqual_Date("abc", -1, -1, -1, false);
    AssertEqual_Date("1. Dezember ", -1, -1, -1, false);
  }
#endif // #ifdef SIMPLEUNITTESTS_H__ 

  // --------------- Aufgabe 2 -------------------------------

  // Den Datentyp des Parameters 'result' in 'double' ändern
  // 'stoi' durch 'stod' ersetzen:
  bool try_parse(std::string s, double& result)
  {
    try {
      size_t idx;
      result = std::stod(s, &idx);
      return (idx == s.length()); // Alles wurde
    }                             // konvertiert
    catch (...) {
      return  false;
    }
  }

// *********** Kap. 4 Aufgabe 4.8 Reguläre Ausdrücke
  // Die regulären Ausdrücke sind teilweise etwas vereinfacht.

  // a)
  bool Contains2(std::string Line, std::string s1, std::string s2)
  { // Line enthält s1 und dann s2, dazwischen beliebige Zeichen
    const std::string p = s1 + ".*" + s2;
    try
    {
      const std::regex pattern(p);
      return std::regex_search(Line, pattern);
    }
    catch (std::exception& e)
    {
      MessageBox::Show("Exception '" + rk1::to_String(p) + "' \r\n");
      return false;
    }
  }

  // b)
  bool ContainsSpacesBetween2(std::string Line, std::string s1, std::string s2)
  { // Line enthält s1 und dann s2, dazwischen Leerzeichen
    const std::string p = s1 + "\\s*" + s2;
    const std::string p_raw = s1 + R"(\s*)" + s2;
    try
    {
      const std::regex pattern(p_raw);
      return std::regex_search(Line, pattern);
    }
    catch (std::exception& e)
    {
      MessageBox::Show("Exception '" + rk1::to_String(p) + "' \r\n");
      return false;
    }
  }

  // c)
  bool ContainsSpacesBetween2Words(std::string Line, std::string s1, std::string s2)
  { // Line enthält s1 und s2 als eigenständige Worte, dazwischen Leerzeichen
    const std::string p = "\\b(" + s1 + ")\\s*\\b(" + s2 + ")";
    const std::string p_raw = R"(\b()" + s1 + R"()\s*\b()" + s2 + R"())";
    try
    {
      const std::regex pattern(p_raw);
      return std::regex_search(Line, pattern);
    }
    catch (std::exception& e)
    {
      MessageBox::Show("Exception '" + rk1::to_String(p) + "' \r\n");
      return false;
    }
  }
#ifdef SIMPLEUNITTESTS_H__ 
  // Dieses Makro wird durch ein #include "SimpleUnitTests.h" definiert
  void Unittests_Contains2()
  {
    using std::string;
    string id = "RegExpr Contains2 ";
    rk1::Assert::WriteLine("Unittests_" + id);

    string s1 = "int x=1";
    string s2 = "int  x=1";
    string s3 = "int x =1";
    string s4 = "uint x=1";
    string s5 = "uint  x=1";
    string s6 = "uint x =1";
    string s7 = "int ax=1";
    string s8 = "int  ax=1";
    string s9 = "int ax =1";

    // a)
    rk1::Assert::AreEqual(true, Contains2(s1, "int", "x"), id + "C2-1");
    rk1::Assert::AreEqual(true, Contains2(s2, "int", "x"), id + "C2-2");
    rk1::Assert::AreEqual(true, Contains2(s3, "int", "x"), id + "C2-3");
    rk1::Assert::AreEqual(true, Contains2(s4, "int", "x"), id + "C2-4");
    rk1::Assert::AreEqual(true, Contains2(s5, "int", "x"), id + "C2-5");
    rk1::Assert::AreEqual(true, Contains2(s6, "int", "x"), id + "C2-6");
    rk1::Assert::AreEqual(true, Contains2(s7, "int", "x"), id + "C2-7");
    rk1::Assert::AreEqual(true, Contains2(s8, "int", "x"), id + "C2-8");
    rk1::Assert::AreEqual(true, Contains2(s9, "int", "x"), id + "C2-9");

    // b)
    id = "RegExpr ContainsSpacesBetween2 ";
    rk1::Assert::WriteLine("Unittests_" + id);
    rk1::Assert::AreEqual(true,
      ContainsSpacesBetween2(s1, "int", "x"), id + "CS2-1");
    rk1::Assert::AreEqual(true,
      ContainsSpacesBetween2(s2, "int", "x"), id + "CS2-2");
    rk1::Assert::AreEqual(true,
      ContainsSpacesBetween2(s3, "int", "x"), id + "CS2-3");
    rk1::Assert::AreEqual(true,
      ContainsSpacesBetween2(s4, "int", "x"), id + "CS2-4");
    rk1::Assert::AreEqual(true,
      ContainsSpacesBetween2(s5, "int", "x"), id + "CS2-5");
    rk1::Assert::AreEqual(true,
      ContainsSpacesBetween2(s6, "int", "x"), id + "CS2-6");
    rk1::Assert::AreEqual(false,
      ContainsSpacesBetween2(s7, "int", "x"), id + "CS2-7");
    rk1::Assert::AreEqual(false,
      ContainsSpacesBetween2(s8, "int", "x"), id + "CS2-8");
    rk1::Assert::AreEqual(false,
      ContainsSpacesBetween2(s9, "int", "x"), id + "CS2-9");

    // c)
    id = "RegExpr ContainsSpacesBetween2Words ";
    rk1::Assert::WriteLine("Unittests_" + id);
    rk1::Assert::AreEqual(true,
      ContainsSpacesBetween2Words(s1, "int", "x"), id + "CS2w-1");
    rk1::Assert::AreEqual(true,
      ContainsSpacesBetween2Words(s2, "int", "x"), id + "CS2w-2");
    rk1::Assert::AreEqual(true,
      ContainsSpacesBetween2Words(s3, "int", "x"), id + "CS2w-3");
    rk1::Assert::AreEqual(false,
      ContainsSpacesBetween2Words(s4, "int", "x"), id + "CS2w-4");
    rk1::Assert::AreEqual(false,
      ContainsSpacesBetween2Words(s5, "int", "x"), id + "CS2w-5");
    rk1::Assert::AreEqual(false,
      ContainsSpacesBetween2Words(s6, "int", "x"), id + "CS2w-6");
    rk1::Assert::AreEqual(false,
      ContainsSpacesBetween2Words(s7, "int", "x"), id + "CS2w-7");
    rk1::Assert::AreEqual(false,
      ContainsSpacesBetween2Words(s8, "int", "x"), id + "CS2w-8");
    rk1::Assert::AreEqual(false,
      ContainsSpacesBetween2Words(s9, "int", "x"), id + "CS2w-9");
  }
#endif // #ifdef SIMPLEUNITTESTS_H__ 

    // d)
  bool FunctionCall(std::string Line, std::string FunctionName)
  { // FunctionName, beliebig viele Leerzeichen, (
    const std::string p = "\\b(" + FunctionName + ")\\s*\\(";
    const std::string p_raw = R"(\b()" + FunctionName + R"()\s*\()";
    try
    {
      const std::regex pattern(p_raw);
      return std::regex_search(Line, pattern);
    }
    catch (std::exception& e)
    {
      MessageBox::Show("Exception '" + rk1::to_String(p) + "' \r\n");
      return false;
    }
  }

#ifdef SIMPLEUNITTESTS_H__ 
  // Dieses Makro wird durch ein #include "SimpleUnitTests.h" definiert
  void Unittests_FunctionCall()
  {
    // d)
    std::string id = "RegExpr FunctionCall ";
    rk1::Assert::WriteLine("Unittests_" + id);
    rk1::Assert::AreEqual(false, FunctionCall("f12=12", "f12"), id + "1");
    rk1::Assert::AreEqual(true, FunctionCall("y = f12(x", "f12"), id + "2");
    rk1::Assert::AreEqual(true, FunctionCall("y = f12( x", "f12"), id + "3");
    rk1::Assert::AreEqual(true, FunctionCall("y = f12 (x", "f12"), id + "4");
    rk1::Assert::AreEqual(true, FunctionCall("y = f12 ( x", "f12"), id + "5");
    rk1::Assert::AreEqual(true, FunctionCall(" int f12( ", "f12"), id + "6");
    rk1::Assert::AreEqual(false, FunctionCall(" f123( ", "f12"), id + "7");
    rk1::Assert::AreEqual(false, FunctionCall(" af123( ", "f12"), id + "8");
    rk1::Assert::AreEqual(false, FunctionCall(" af12( ", "f12"), id + "9");
    rk1::Assert::AreEqual(false, FunctionCall("f1 2(", "f12"), id + "10");
    rk1::Assert::AreEqual(false, FunctionCall("f12", "f12"), id + "11");
  }
#endif // #ifdef SIMPLEUNITTESTS_H__ 

  // e)
  bool AssignmentOf(std::string Line, std::string VariableName)
  { // Ein =, beliebig viele Leerzeichen, VariableName
    std::string p = "={1}\\s*(" + VariableName + ")";
    std::string p_raw = R"(={1}\s*()" + VariableName + R"())";
    try
    {
      const std::regex pattern(p_raw);
      return std::regex_search(Line, pattern);
    }
    catch (std::exception& e)
    {
      MessageBox::Show("Exception '" + rk1::to_String(p) + "' \r\n");
      return false;
    }
  }

#ifdef SIMPLEUNITTESTS_H__ 
  // Dieses Makro wird durch ein #include "SimpleUnitTests.h" definiert
  void Unittests_AssignmentOf()
  {
    //e)
    std::string  id = "RegExpr AssignmentOf ";
    rk1::Assert::WriteLine("Unittests_" + id);
    rk1::Assert::AreEqual(true, AssignmentOf("y = xyz", "xyz"), id + "1");
    rk1::Assert::AreEqual(true, AssignmentOf("y= xyz", "xyz"), id + "2");
    rk1::Assert::AreEqual(true, AssignmentOf("y =xyz", "xyz"), id + "3");
    rk1::Assert::AreEqual(true, AssignmentOf("int y=xyz", "xyz"), id + "4");
    rk1::Assert::AreEqual(true, AssignmentOf("xyz=xyz", "xyz"), id + "5");
    rk1::Assert::AreEqual(true, AssignmentOf(" y = xyz(", "xyz"), id + "6");
    rk1::Assert::AreEqual(false, AssignmentOf(" int xyz", "xyz"), id + "6");
    rk1::Assert::AreEqual(false, AssignmentOf(" xyz(", "xyz"), id + "6");
  }
#endif // #ifdef SIMPLEUNITTESTS_H__ 

  // f)
  bool ClassDefinition(std::string Line)
  { // ohne Templates und weitere Sonderfälle
    const std::string p = "(class |struct )\\s*\\w*";
    const std::string p_raw = R"((class |struct )\s*\w*)";
    try
    {
      const std::regex pattern(p_raw);
      return std::regex_search(Line, pattern);
    }
    catch (std::exception& e)
    {
      MessageBox::Show("Exception '" + rk1::to_String(p) + "' \r\n");
      return false;
    }
  }

#ifdef SIMPLEUNITTESTS_H__ 
  // Dieses Makro wird durch ein #include "SimpleUnitTests.h" definiert
  void Unittests_ClassDefinition()
  {
    //f)
    std::string  id = "RegExpr ClassDefinition ";
    rk1::Assert::WriteLine("Unittests_" + id);
    rk1::Assert::AreEqual(true, ClassDefinition("class X {"), id + "1");
    rk1::Assert::AreEqual(true, ClassDefinition("// class X {"), id + "2");
    rk1::Assert::AreEqual(true, ClassDefinition("  class X:public A {"), id + "3");
    rk1::Assert::AreEqual(true, ClassDefinition(" struct X {"), id + "4");
    rk1::Assert::AreEqual(false, ClassDefinition("class1 X {"), id + "5");
    rk1::Assert::AreEqual(false, ClassDefinition("321"), id + "6");
  }
#endif // #ifdef SIMPLEUNITTESTS_H__ 


#ifdef SIMPLEUNITTESTS_H__ 
  // Dieses Makro wird durch ein #include "SimpleUnitTests.h" definiert
  void Unittests_RegExpr()
  {
    Unittests_Contains2();
    Unittests_FunctionCall();
    Unittests_AssignmentOf();
    Unittests_ClassDefinition();
  }
#endif // #ifdef SIMPLEUNITTESTS_H__ 

#ifdef SIMPLEUNITTESTS_H__ 
  // Dieses Makro wird durch ein #include "SimpleUnitTests.h" definiert
  void Unittests_Kap_4_strings()
  {
    rk1::Assert::Init("Unittests_Kap_4_Strings"); // rk1::Assert::LogTestCases::No );
    Unittests_AnzahlZeichen();
    Unittests_Contains();
    Unittests_Split3();
    Unittests_Trim();
    Unittests_ReplaceAll();
    Unittests_generatePassword();
    Unittests_uintToBinaryString();
    Unittests_BigIntAdd(100);
    Unittests_StringToDate();
    Unittests_RegExpr();
    rk1::Assert::Summary();
  }
#endif // #ifdef SIMPLEUNITTESTS_H__ 
} // end of namespace N_Loesungen_Strings 


