﻿// *********** Kap. 5 Lösungen Kapitel 5. Arrays und Container




#pragma once
#include <cmath>
#include <string>
#include <array>
#include <vector>
int N = 100;
std::vector<int> v(N); // ein vector mit N Elementen
// *********** Kap. 5 Aufgabe 5.2 Eindimensionale Arrays
namespace N_Loesungen_Arrays
{
  using namespace System;
  using namespace System::Windows::Forms;

  // --------------- Aufgabe 1. ------------------------------

  void ArrayAufgabe_1()
  {
    {
      int a[10];
      for (int i = 1; i <= 10; i++) a[i] = 0;   // a) 
      int b[2], c[2];
      b[0] = 0; b[1] = 1;
      // c = b;                                    // b) 
      int x = b[b[b[0]]];                       // c)
      c[0] = 0; c[1] = 1;
      if (b == c) x++;                          // d)
      /*
       a) Fehler: Zugriff auf a[10]
       b) Zuweisung von Arrays ist nicht möglich
       c) x=0
       d) b==c vergleicht die Adressen und nicht die Werte der Arrays
      */
    }
    {
      std::array<int,10> a;
      for (int i = 1; i <= 10; i++) a[i] = 0;   // a) 
      std::array<int, 10> b, c;
      b[0] = 0; b[1] = 1;
      c = b;                                    // b) 
      int x = b[b[b[0]]];                       // c)
      c[0] = 0; c[1] = 1;
      if (b == c) x++;                          // d)
      /*
       a) Fehler: Zugriff auf a[10]
       b) Zuweisung von std::array ist möglich
       c) x=0
       d) b==c vergleicht die Inhalte und nicht die Adressen der Arrays
      */
    }
  }

  // --------------- Aufgabe 2 -------------------------------

    void SiebEratosthenes(TextBox^ tb)
  {
    const int n = 1000; // Eine Konstante verwenden, damit die 
    // Anzahl der Elemente des Arrays leicht geändert werden kann.
    // Mit einem vector wie in c) kann n auch eine Variable sein,
    // z.B. ein Parameter von SiebEratosthenes  
    //// Für die Lösung von a), b) oder c) einfach nur die
    //// jeweilige Variante aktivieren durch Entfernen von // 
    // std::array<bool, n + 1> prim; // a)
    //// oder
    // bool prim[n + 1]; // b)
    //// oder
    std::vector<bool> prim(n + 1, true); // c)
    // p[i]==true, falls i eine Primzahl ist, sonst false

    for (int i = 0; i <= n; i++)
      prim[i] = true;         // d) prim.at(i) = true;
    for (int i = 2; i <= n; i++)
      if (prim[i])            // d) if (prim.at(i))
        for (int j = i; j <= n / i; j++)
          prim[j*i] = false;  // d) prim.at(j * i) = false;
    for (int i = 2; i <= n; i++)
      if (prim[i])            // d) if (prim.at(i))
      {
        tb->AppendText((i).ToString() + " ");
      }
  };



    // --------------- Aufgabe 3 ------------------------------- 

  std::vector<std::string> tokenize(const std::string& s, std::string separators = ";.,- ")
  { // ";.,- " ist ein Default Argument für den Parameter separators 
    // Damit kann tokenize ohne Argument für den zweiten Parameter aufgerufen 
    // werden. separators kann auch als lokale Variable definiert werden. 
    // ??? nach Kap. ???, einschließlich der Unit-Tests, außerdem Numerierung anpassen, auch in 4.2.3
    std::vector<std::string> result;
    std::string::size_type pos_tok = s.find_first_not_of(separators);
    while (pos_tok != std::string::npos)
    { // token gefunden ab Position pos_tok 
      std::string::size_type  pos_sep = s.find_first_of(separators, pos_tok);
      if (pos_sep == std::string::npos)
        pos_sep = s.length();
      std::string token = s.substr(pos_tok, pos_sep - pos_tok);

      result.push_back(token);
      pos_tok = s.find_first_not_of(separators, pos_sep + 1);
    }
    return result;
}


// c) 

#ifdef SIMPLEUNITTESTS_H__ 
// Dieses Makro wird durch ein #include "SimpleUnitTests.h" definiert
  void assertEqual(std::vector<std::string> f, std::vector<std::string> s, std::string msg)
  {

    rk1::Assert::AreEqual(f == s, true, msg);
  }

  std::vector<std::string> make_string_vector(std::string s1 = "", std::string s2 = "", std::string s3 = "")
  {
    std::vector<std::string> result;
    if (s1 != "")
      result.push_back(s1);
    if (s2 != "")
      result.push_back(s2);
    if (s3 != "")
      result.push_back(s3);
    return result;
  }

  void Unittests_tokenize()
  {
    const int nTests = 10;
    std::string s[nTests];
    std::vector<std::string> st[nTests];
    s[0] = "";              st[0] = make_string_vector();
    s[1] = " ";             st[1] = make_string_vector();
    s[2] = "123";           st[2] = make_string_vector("123");
    s[3] = ";123";          st[3] = make_string_vector("123");
    s[4] = "123;";          st[4] = make_string_vector("123");
    s[5] = ";123;";         st[5] = make_string_vector("123");
    s[6] = "456 ab.xy";     st[6] = make_string_vector("456", "ab", "xy");
    s[7] = " 456 ab.xy";    st[7] = make_string_vector("456", "ab", "xy");
    s[8] = "456 ab.xy;";    st[8] = make_string_vector("456", "ab", "xy");
    s[9] = "456 ab.xy;";    st[9] = make_string_vector("456", "ab", "xy");
    // Dieselben Testfälle wie in Aufgabe 4.1 
    // kein token: 
    // s[0]: leerer String, keine Ausgabe 
    // s[1]: nur Separator, keine Ausgabe 
    // ein token: 
    // s[2]: nur token, Ausgabe "123" 
    // s[3]: Separator am Anfang, Ausgabe "123" 
    // s[4]: Separator am Ende, Ausgabe "123" 
    // s[5]: Separator am Anfang und Ende, Ausgabe "123" 
    // mehrere tokens, Separatoren in der Mitte: 
    // s[6]: kein Separator am Anfang und Ende, Ausgabe "456", "ab", "xy" 
    // s[7]: Separator am Anfang, Ausgabe "456", "ab", "xy" 
    // s[8]: Separator am Ende, Ausgabe "456", "ab", "xy" 
    // s[9]: Separator am Anfang und Ende "456", "ab", "xy" 

    for (int i = 0; i < nTests; i++)
      assertEqual(tokenize(s[i]), st[i], "test_tokenize i=" + std::to_string(i));
  }
#endif // #ifdef SIMPLEUNITTESTS_H__ 


  // --------------- Aufgabe 4 -------------------------------

    double MisesSimulation(TextBox^ tb, int AnzahlPersonen)
  {
    std::array<int, 365> g; // oder
    // int g[365];
    int AnzahlVersuche = 1000,
      AnzahlTreffer = 0;
    for (int i = 1; i <= AnzahlVersuche; i++)
    {
      for (int j = 0; j < 365; j++) g[j] = 0;
      for (int j = 1; j <= AnzahlPersonen; j++)
        g[rand() % 365]++;
      bool gefunden = false;
      for (int j = 0; j < 365; j++)
        if (g[j] > 1) gefunden = true;
      if (gefunden) AnzahlTreffer++;
    };
    tb->AppendText("n=" + (AnzahlPersonen).ToString() + " w="
      + (1.0*AnzahlTreffer / AnzahlVersuche).ToString() + System::Environment::NewLine);
    return 1.0*AnzahlTreffer / AnzahlVersuche;
  }

    void TestMisesSimulation(TextBox^ tb)
    {
      MisesSimulation(tb, 23);
      MisesSimulation(tb, 23);
      MisesSimulation(tb, 23);
      MisesSimulation(tb, 23);
      MisesSimulation(tb, 23);

      MisesSimulation(tb, 10);
      MisesSimulation(tb, 20);
      MisesSimulation(tb, 30);

      // Die Simulationsergebnisse mit 1000 Versuchen stimmen recht
      // gut mit den exakten Werten (in Klammern) überein:
      /*
      n=23 w=0,499  (p=0,5073)
      n=23 w=0,508
      n=23 w=0,5
      n=23 w=0,535
      n=23 w=0,512

      n=10 w=0,116   (p=0,1169)
      n=20 w=0,414   (p=0,4114)
      n=30 w=0,69    (p=0,7063)
      */
    }

    // --------------- Aufgabe 5 -------------------------------

    // a)
    double Horner(double x)
    { // p: Array mit den Koeffizienten des Polynoms
      const int n = 2; // Der Grad des Polynoms
      double p[n + 1] = { 17,0,3 }; // Koeffizienten von 17+3*x^2
      double s = 0;
      for (int i = 0; i < n + 1; i++)
        s = s*x + p[n - i];
      return s;
    }

    /* Symbolische Ablaufprotokolle
    double Horner(double x) mit n=0
    { // p: Array mit den Koeffizienten des Polynoms
      const int n = 0; // Der Grad des Polynoms
      double p[0 + 1]; // Koeffizienten: p[0]
      double s = 0;
      for (int i = 0; i < 0 + 1; i++)
        s = s*x + p[0 - i];
          Ablaufprotokoll:
                                  i      s
          s = s*x + p[n - i];     0   0*x + p[0-0]
      return s; // p[0]
    }

    double Horner(double x) mit n=1
    { // p: Array mit den Koeffizienten des Polynoms
    const int n = 1; // Der Grad des Polynoms
    double p[1 + 1]; // Koeffizienten: p[0], p[1]
    double s = 0;
    for (int i = 0; i < 1 + 1; i++)
      s = s*x + p[1 - i];
        Ablaufprotokoll:
                                i      s
        s = s*x + p[n - i];     0   0*x + p[1-0]
        s = s*x + p[n - i];     1   p[1]*x + p[1-1]
    return s; // p[1]*x + p[0]
    }

    double Horner(double x) mit n=2
    { // p: Array mit den Koeffizienten des Polynoms
    const int n = 2; // Der Grad des Polynoms
    double p[2 + 1]; // Koeffizienten: p[0], p[1], p[2]
    double s = 0;
    for (int i = 0; i < 2 + 1; i++)
    s = s*x + p[2 - i];
    Ablaufprotokoll:
                            i      s
    s = s*x + p[n - i];     0   0*x + p[2-0]
    s = s*x + p[n - i];     1   p[2]*x + p[2-1]
    s = s*x + p[n - i];     1   (p[2]*x + p[2-1])*x + p[2-2]
                                = p[2]*x^2 + p[2-1]*x + p[0]
    return s; // p[2]*x^2 + p[1]*x + p[0]
    }
    */

    /*
    b)

    Induktionsanfang: Nach der ersten Zuweisung s=s*x+...
    in der Schleife gilt (i==1) und (s==p[n]).

    Induktionsvoraussetzung:
    Nach der k-ten Zuweisung s=s*x+...
    in der Schleife (vor i++) gilt (i==k) und

    s==p[n]*x^k + p[n-1]*x^(k-1) +...+ p[n-k+1]*x+p[n-k]

    Beim nächsten Schleifendurchlauf erhält i den Wert (i==k+1)
    und s den Wert:

    s==p[n]*x^(k+1) + p[n-1]*x^k +...+ p[n-k+1]*x^2+p[n-k]*x+p[n-(k+1)]

    Das ist gerade die Induktionsbehauptung für k+1.

    Beim letzten Durchlauf hat i den Wert n:

    s==p[n]*x^n + p[n-1]*x^(n-1) +...+ p[n-n+1]*x+p[n-n]
    */

    // c)
    double Horner_sin(double x)
    { // p: Array mit den Koeffizienten der Taylorreihe für Sinus
      double k3 = 3 * 2 * 1;
      double k5 = 5 * 4 * k3;
      double k7 = 7 * 6 * k5;
      const int n = 7; // Der Grad des Polynoms
      double p[n + 1] = { 0, 1, 0, -1 / k3, 0, +1 / k5, 0, -1 / k7 };
      double s = 0;
      for (int i = 0; i < n + 1; i++)
        s = s*x + p[n - i];
      return s;
    }

      void test_HornerSinus(TextBox^ tb)
    {
      for (int i = 1; i <= 31; i++)
      {
        double x = i / 10.0;
        double s1 = std::sin(x); // #include <cmath>
        double s2 = Horner_sin(x);
        tb->AppendText("x=" + (x).ToString() + " sin=" + s1.ToString() +
          " Horn-sin=" + (s2).ToString() + " diff=" + (std::abs(s1 - s2)).ToString() +
          System::Environment::NewLine);

        // Offensichtlich liefert die Taylor-Reihe für kleine Werte
        // eine gute Näherung
      }
    }


// *********** Kap. 5 Aufgabe 5.3 Die Initialisierung von Arrays bei ihrer Definition

    // --------------- Aufgabe 1. ------------------------------

    int ai0[3]; // global, alle Elemente 0

    void InitArrays()
    {
      int ai1[3];  // lokal, alle Elemente haben undefinierte Werte
      int ai2[3] = { 1, 2, 3 }; // {1,2,3}
      int ai3[3] = { 1, 2 };    // {1,2,0}
      int ai4[3] = {};    // alle Elemente 0
    }


    // --------------- Aufgabe 2. ------------------------------

    int Fibonacci_aus_Array(int n)
    {
      const int max = 47;
      std::array<int, 10> f = { 0, 1, 1, 2, 3, 5, 8, 13, 21, 34 }; // 10 Werte
      if ((0 <= n) && (n < 10)) return f[n];
      else if (n < 47)
      {
        for (int i = 10; i <= n; i++)
          f[i] = f[i - 1] + f[i - 2];
        return f[n];
      }
      // oder mit einem C-Array
      {
        int f[max] = { 0, 1, 1, 2, 3, 5, 8, 13, 21, 34 }; // 10 Werte
        if ((0 <= n) && (n < 10)) return f[n];
        else if (n < 47)
        {
          for (int i = 10; i <= n; i++)
            f[i] = f[i - 1] + f[i - 2];
          return f[n];
        }
        else return -1;
      }
    }

#ifdef SIMPLEUNITTESTS_H__ 
    // Dieses Makro wird durch ein #include "SimpleUnitTests.h" definiert

    void Unittests_Fibonacci_aus_Array()
    {
      const int max = 47;
      int f[max] = { 0, 1, 1, 2, 3, 5, 8, 13, 21, 34, 55, 89, 144, 233, 377, 610,
        987, 1597, 2584, 4181, 6765, 10946, 17711 }; // 23 Werte
      for (int i = 0; i < 23; i++)
        rk1::Assert::AreEqual(Fibonacci_aus_Array(i), f[i], "FibonacciArray(" + std::to_string(i) + ")");
    }
#endif // #ifdef SIMPLEUNITTESTS_H__ 




// *********** Kap. 5 Aufgabe 5.5 Mehrdimensionale Arrays
    // --------------- Aufgabe 1. ------------------------------

      void FindMinMaxInMultidimArray(TextBox^ tb)
    {
      // a)
      const int m = 10, n = 20;
      std::array<std::array<int, 10>, 20> a2;
      int a2_c[m][n]; // mit einem C-Array
      int min_i = 0, min_j = 0;

      // Testwerte:
      for (int i = 0; i < m; i++)
        for (int j = 0; j < n; j++)
          a2[i][j] = 100 - (i + j);

      // Bestimme die gesuchten Positionen
      for (int i = 0; i < m; i++)
        for (int j = 0; j < n; j++)
          if (a2[i][j] < a2[min_i][min_j])
          {
            min_i = i;
            min_j = j;
          }
      tb->AppendText((min_i).ToString() + ":" + (min_j).ToString() + "\r\n");
      // b)
      const int p = 10;
      std::array<std::array<std::array<int, m>, n>, p> a3;
      int a3_c[m][n][p]; // C-Array
      int min_k = 0;
      min_i = 0, min_j = 0;

      // Testwerte:
      for (int i = 0; i < m; i++)
        for (int j = 0; j < n; j++)
          for (int k = 0; k < p; k++)
            a3[i][j][k] = 100 - (i + j + k);

      // Bestimme die gesuchten Positionen
      for (int i = 0; i < m; i++)
        for (int j = 0; j < n; j++)
          for (int k = 0; k < p; k++)
            if (a3[i][j][k] < a3[min_i][min_j][min_k])
            {
              min_i = i;
              min_j = j;
              min_k = k;
            }
      tb->AppendText((min_i).ToString() + ":" + (min_j).ToString() + ":" + (min_k).ToString() + "\r\n");
    }



// *********** Kap. 5 Aufgabe 5.6 Dynamische Programmierung

      long long binom(int n, int k)
      {
        const int max = 30; // für größere Werte overflow ??? mit long long geht mehr als 30
        long long a[max][max] = { 0 }; // initialisiert alle Arrayelemente mit 0
        for (int i = 0; i < max; i++)
          for (int j = 0; j < i; j++)
          {
            if (i == 0) a[0][0] = 1;
            else if (i > 0)
            {
              if (j == 0) a[i][j] = 1;
              else if (j > 0) a[i][j] = a[i - 1][j - 1] + a[i - 1][j];
            }
          }
        if (0 <= k && k <= n && n < max)
          return a[n][k];
        else
          return 0;
      }
      void zeigePascalDreieck(TextBox^ tb)
      {
        tb->AppendText("Pascal Dreieck\r\n");
        for (int i = 1; i < 20; i++)
        {
          String^ s;
          for (int j = 0; j < i; j++)
            s += (binom(i, j)).ToString() + " ";
          tb->AppendText(s + System::Environment::NewLine);
        }
      }
#ifdef SIMPLEUNITTESTS_H__ 
      void Unittests_Kap_5_Arrays()
      {
        rk1::Assert::Init("Unittests_Kap_5_Arrays"); // rk1::Assert::LogTestCases::No );
        // bool ask = false;
        // Unittests_Array(ask);
        rk1::Assert::Summary();
      }
#endif // #ifdef SIMPLEUNITTESTS_H__ 

} // end of namespace N_Loesungen_Arrays


