﻿// *********** Kap. 10 Lösungen Kapitel 10. Namensbereiche



// *********** Kap. 10 Aufgabe 10.4 Namensbereiche

// --------------- Aufgabe 1. ------------------------------
// #include <cstdlib>
// #include <vector>

namespace N_namespaces 
{

  // a) b) c)
  namespace N {
    int f(int n)
    {
      return n + 1;
    }

    // d)
    namespace N1 {

      class C
      {
        int g(int n);
        int h(int n);
        int i(int n);
      };

    } // end of namespace N1 
  }

  // a)
  void a()
  {
    int r = N::f(1);
  }

  // b)
  void b()
  {
    using N::f;
    int r = f(2);
  }

  // c)
  void c()
  {
    using namespace N;
    int r = f(3);
  }

  // oder a), b), c)
  void useNamespace_a_b_c()
  {
    // a)
    int a = N::f(10);
    { // b)
      using N::f;
      int r = f(2);
    }
    {  // c)
      using namespace N;
      int c = f(10);
    }
  }

  // e)
  int N::N1::C::g(int n)
  {
    return n + 1;
  }

  // f)
  namespace A = N::N1;
  int A::C::i(int x)
  {
    return x + 1;
  }

  // --------------- Aufgabe 2. ------------------------------

  /*
  Wenn man in einem Namensbereich eine #include-Anweisung mit einer
  Header-Datei der Standard-Bibliothek aufnimmt, führt das meist zu
  einer Vielzahl von Fehlermeldungen:

    namespace N_include_2 {
      #include<unordered_map>
    }

  Wenn man diese Header-Datei zuvor (z.B. in einer vorherigen #include-
  Datei) außerhalb eines Namensbereichs aufnimmt

    #pragma once
    #include<unordered_map>
    namespace N_include_1 {
    }

  wird sie bei einem zweiten #include kein zweites Mal eingebunden.

  */

} // end of namespace N_namespaces

#include "include-1.h" // beide global, nicht in einem Namensbereich
#include "include-2.h"





