﻿// *********** Kap. 11 Lösungen Kapitel 11. Exception-Handling




#include <vector>
#include <stdexcept> // für logic_error
#include <cmath>

namespace N_Loesungen_Exception_Handling 
{
  using namespace System::Windows::Forms;

  // --------------- Aufgabe 1 -------------------------------
  /*
  a)    in keiner der Funktionen f1, f2 usw. eine Exception ausgelöst wird:

  Lösung: f1, f2, f4

  b)    in f1 eine Exception ausgelöst wird

  Lösung: f1, f3, f4

  c)    in f2 eine Exception ausgelöst wird

  Lösung: f1, f2, f3, f4

  d)    in f1 und f3 eine Exception ausgelöst wird

  Lösung: f1, f3, f5

  e)    in f1 und f4 eine Exception ausgelöst wird

  Lösung: f1, f3, f4, f5

  */

  void f1(TextBox^ tb, char c)
  {
    tb->AppendText("f1 \r\n");
    if (c == 'b') throw 1;
    if (c == 'd') throw 1;
    if (c == 'e') throw 1;
  };

  void f2(TextBox^ tb, char c)
  {
    tb->AppendText("f2 \r\n");
    if (c == 'c') throw 2;
  };

  void f3(TextBox^ tb, char c)
  {
    tb->AppendText("f3 \r\n");
    if (c == 'd') throw 3;
  };

  void f4(TextBox^ tb, char c)
  {
    tb->AppendText("f4 \r\n");
    if (c == 'e') throw 4;
  };

  void f5(TextBox^ tb, char c)
  {
    tb->AppendText("f5 \r\n");
  };

  void f_(TextBox^ tb, Char c)
  {
    tb->AppendText(c.ToString() + "\r\n");
    try {
      try {
        f1(tb, c);
        f2(tb, c);
      }
      catch (...)
      {
        f3(tb, c);
      }
      f4(tb, c);
    }
    catch (...)
    {
      f5(tb, c);
    }
  }

  void Aufgabe_1(TextBox^ tb)
  {
    f_(tb, 'a');
    f_(tb, 'b');
    f_(tb, 'c');
    f_(tb, 'd');
    f_(tb, 'e');
  }


  // --------------- Aufgabe 2 -------------------------------

  void f1() {};
  void f2() {};
  void f3() {};
  void f4() {};

  void Aufgabe_2_a()
  {
    try {
      f1();
      f2();
      f3();
      f4();
    }
    catch (...)
    {
    }
  }

  void Aufgabe_2_b()
  {
    try {
      f1();
      f2();
    }
    catch (...)
    {
    }
    try {
      f3();
      f4();
    }
    catch (...)
    {
    }
  }

  void Aufgabe_2_c()
  {
    try { f1(); }
    catch (...)
    {
    }
    try { f2(); }
    catch (...)
    {
    }
    try { f3(); }
    catch (...)
    {
    }
    try { f4(); }
    catch (...)
    {
    }
  }

  void Aufgabe_2()
  {
    Aufgabe_2_a();
    Aufgabe_2_b();
    Aufgabe_2_c();
  }

  // --------------- Aufgabe 3 -------------------------------

  void Aufg3(int i)
  {
    if (i == 0) throw i + 1;            // a)
    else if (i == 1) throw 1.0*i;       // b)
    else if (i == 2) throw std::exception(); // c)
    else throw std::logic_error("Vorbedingung nicht erfüllt"); // d)
  }
  void test_Aufg3(TextBox^ tb, int i)
  {
    try {
      Aufg3(i);
    }
    catch (int i)
    {
      tb->AppendText("int Exception i=" + i.ToString() + "\r\n");
    }
    catch (double d)
    {
      tb->AppendText("double Exception d=" + d.ToString() + "\r\n");
    }
    catch (std::logic_error& e)
    {
      tb->AppendText("Exception logic_error what=" + rk1::to_String(e.what()) + "\r\n");
    }
    catch (std::exception& e)
    {
      tb->AppendText("Exception what=" + rk1::to_String(e.what()) + "\r\n");
    }
  };

  void Aufgabe_3(TextBox^ tb)
  {
    test_Aufg3(tb, 0);
    test_Aufg3(tb, 1);
    test_Aufg3(tb, 2);
    test_Aufg3(tb, 3);
  }


  // --------------- Aufgabe 4 -------------------------------

  void f(int i)
  { // #include <stdexcept>
    if (i == 0) throw std::exception();
    else if (i == 1) throw std::logic_error("logic error");
    else if (i == 2) throw std::range_error("range error");
    else if (i == 3) throw std::out_of_range("out of range error");
    else throw std::exception();
  }

  // a)
  void g1(TextBox^ tb, int i)
  {
    try { f(i); }
    catch (std::logic_error& e)
    {
      tb->AppendText("logisch \r\n");
    }
    catch (std::out_of_range& e)
    {
      tb->AppendText("range \r\n");
    }
    catch (std::exception& e)
    {
      tb->AppendText("exception \r\n");
    }
  };

  void test_Aufg4a(TextBox^ tb)
  {
    tb->AppendText("3 a) \r\n");
    g1(tb, 0); // exception
    g1(tb, 1); // logisch
    g1(tb, 2); // exception
    g1(tb, 3); // logisch
  }

  // b)
  void g2(TextBox^ tb, int i)
  {
    try { f(i); }
    catch (std::logic_error& e)
    {
      tb->AppendText(rk1::to_String(e.what()) + "\r\n");
    }
    catch (std::out_of_range& e)
    {
      tb->AppendText(rk1::to_String(e.what()) + "\r\n");
    }
    catch (std::exception& e)
    {
      tb->AppendText(rk1::to_String(e.what()) + "\r\n");
    }
  };

  void test_Aufg4b(TextBox^ tb)
  {
    tb->AppendText("4 b) \r\n");
    g2(tb, 0); // exception::what(),    "no named exception thrown"
    g2(tb, 1); // logic_error::what(),  "logic error"
    g2(tb, 2); // range_error::what(),  "range error"
    g2(tb, 3); // out_of_range::what(), "out of range error"
               // Dieses Ergebnis erhält man einfacher wie in d)
  }

  // c)
  void g3(TextBox^ tb, int i)
  {
    try { f(i); }
    catch (std::exception e)
    {
      tb->AppendText(rk1::to_String(e.what()) + "\r\n");
    }
  };

  void test_Aufg4c(TextBox^ tb)
  {
    tb->AppendText("4 c) \r\n");
    g3(tb, 0); // exception::what(), "no named exception thrown"
    g3(tb, 1); // exception::what(), "no named exception thrown"
    g3(tb, 2); // exception::what(), "no named exception thrown"
    g3(tb, 3); // exception::what(), "no named exception thrown"
               // Da der Datentyp im Exception-Handler keine Referenz
               // ist, wird immer die Funktion 'what' von 'exception'
               // aufgerufen.
  }

  // d)
  void g4(TextBox^ tb, int i)
  {
    try { f(i); }
    catch (std::exception& e)
    {
      tb->AppendText(rk1::to_String(e.what()) + "\r\n");
    }
    catch (...)
    {
      tb->AppendText("irgendeine Exception");
    }
  };

  void test_Aufg4d(TextBox^ tb)
  {
    tb->AppendText("3 d) \r\n");
    g4(tb, 0); // exception::what(),    "no named exception thrown"
    g4(tb, 1); // logic_error::what(),  "logic error"
    g4(tb, 2); // range_error::what(),  "range error"
    g4(tb, 3); // out_of_range::what(), "out of range error"
  }
  void Aufgabe_4(TextBox^ tb)
  {
    test_Aufg4a(tb);
    test_Aufg4b(tb);
    test_Aufg4c(tb);
    test_Aufg4d(tb);
  }

  // --------------- Aufgabe 5 -------------------------------

  class MeineException_1 : public std::exception
  {
  public:
    MeineException_1(std::string msg) noexcept :message1(msg) {}
    MeineException_1(const char* msg) noexcept :message2(msg) {}
  private:
    std::string message1;
    const char* message2;
  }; 
  // Bei dieser Version gibt what den leeren String der Basisklasse aus 
  void test_MeineException_1(TextBox^ textBox1)
  { // analog für MeineException_2 und MeineException_3
    try {
      throw MeineException_1("MeineException_1");
    }
    catch (MeineException_1& e) // eigene abgeleitete Klasse
    {
      textBox1->AppendText(rk1::to_String(e.what())); // leerer String
    }
    catch (std::exception& e) // C++ Standardbibliothek
    {
      textBox1->AppendText(rk1::to_String(e.what()));
    }
    catch (Exception^ e) // C++/CLR .NET
    {
      textBox1->AppendText(e->Message);
    }
    catch (...)          // alle weiteren Exceptions
    {
      textBox1->AppendText("Was war das?");
    }
  }

  class MeineException_2 : public std::exception
  {
  public:
    MeineException_2(std::string msg) noexcept :message1(msg) {}
    MeineException_2(const char* msg) noexcept :message2(msg) {}
    const char* what() const noexcept override {
      return message1.c_str(); // Variante 1
      return message2;         // Variante 2
    };
  private:
    std::string message1; // Variante 1
    const char* message2; // Variante 2
  }; 
  // Die Daten aus der Basisklasse exception werden nicht genutzt
  
  class MeineException_3 : public std::runtime_error
  {
  public: 
    // MeineException_3(std::string msg) noexcept :message1(msg) {}
    // MeineException_3(const char* msg) noexcept :message2(msg) {}
    // Fehler: std::runtime_error hat keinen Standardkonstruktor
  private:
    std::string message1;
    const char* message2;
  };


  // --------------- Aufgabe 6 -------------------------------

  // Siehe auch Betrand Meyer, Object Oriented Software Construction,
  //                           Abschnitt 12.2

  class ENegative {};

  double Sqrt(double d)
  {
    try {
      if (d < 0) throw ENegative();
      return std::sqrt(d); // #include <cmath>
    }
    catch (...)
    {
      MessageBox::Show("negativ");
      return 0;
    }
  }

  /*
  Diese Funktion hat 3 Schwächen:
  a) statt catch(...) sollte man catch(ENegative) verwenden

  b) sie kann einfacher formuliert werden:
  */

  double Sqrt1(double d)
  {
    if (d < 0)
    {
      MessageBox::Show("negativ");
      return 0;
    }
    else
      return std::sqrt(d);
  }

  /*
  c) Die Klasse ENegative sollte von std::exception abgeleitet werden und
     die  üblichen Anforderungen erfüllen:
  */

  class negative_exception :public std::exception
  { // #include <exception>
    std::string str;
  public:
    negative_exception(const std::string& msg) :str(msg) { };
    const char* what() const throw() override { return str.c_str(); }
  };

  /*
  d) Auch mit den Varianten a), b) und c) ist diese Funktion nicht sehr gut, da
     der Anwender mit einer Meldung konfrontiert wird, mit der er vermutlich
     nicht viel anfangen kann. Es wäre besser, in dieser Funktion nur eine
     Exception auszulösen und diese in der aufrufenden Funktion zu behandeln:
  */

  double Sqrt2(double d)
  {
    if (d < 0)
      throw negative_exception("Bitte geben Sie einen positven Wert ein");
    return std::sqrt(d);
  }

  void useSqrt2(double d)
  {
    try {
      // ...
      double y = Sqrt2(d);
      // ...
    }
    catch (const negative_exception& e)
    {
      MessageBox::Show(rk1::to_String(e.what()));
    }
  }


  // --------------- Aufgabe 7 -------------------------------

  void h1()
  { // kann zu einem Speicherleck führen
    std::vector<int*> v = { new int(17) };
    // f();
    for (auto i = v.begin(); i != v.end(); i++)
      delete *i;
  }

  // Ersetzt man die Zeiger in h1 durch Objekte mit RAII, wird bei 
  // einer Exception in f() der Destruktor dieser Objekte 
  // aufgerufen, der den Speicher freigibt.

  // Solche Objekt werden am besten mit smart pointern definiert.
  // Alternativ:

  class C {
    std::vector<int*> v;
  public:
    void push_back(int* p)
    {
      v.push_back(p);
    }
    ~C()
    {
      for (auto i = v.begin(); i != v.end(); i++)
        delete *i;
    }

  };

  void h2()
  {
    C v;
    v.push_back(new int(17));
    // f();
  }

  void Aufgabe_7()
  {
    h1();
    h2();
  }


  // --------------- Aufgabe 8 -------------------------------

  namespace N_Aufgabe8 {
    // https://www.securecoding.cert.org/confluence/display/cplusplus/ERR60-CPP.+Exception+objects+must+be+nothrow+copy+constructible

    // a)     
    class C {
      int* a;
      int* b;
#if VS_VERSION >= 2015   
      void init() noexcept(false)
#else
      void init() 
#endif
      {
        // ...
      }

    public:
      C() : a(nullptr), b(nullptr)
      {
        a = new int();
        b = new int();
        init();
      }

      ~C()
      {
        delete a;
        delete b;
      }
    };

    // b) Überarbeiten Sie die Klasse C so, dass auch dann, wenn init 
    //    eine Exception auslöst, kein Speicherleck auftritt.

    class C_Lsg { // Im Kapitel Smart-Pointer wird noch eine elegantere
      int* a;                                     // Lösung vorgestellt
      int* b;
    protected:
#if VS_VERSION >= 2015   
      void init() noexcept(false);
#else
      void init();
#endif
    public:
      C_Lsg()
      {
        try {
          a = new int();
          b = new int();
          init();
        }
        catch (...)
        {
          delete a;
          delete b;
          a = nullptr;
          b = nullptr;
          throw;
        }
      }
    };

  }  // end of namespace N_Aufgabe8 



} // end of namespace N_Loesungen_Exception_Handling 

