﻿// *********** Kap. 12 Lösungen Kapitel 12. Containerklassen der Standardbibliothek



#include <fstream>
#include <string>
#include <algorithm>
#include <map>
#include <set>
#include <fstream>
#include <sstream> 
#include <vector> 
#include <random>


// ??? #include "Loesung_Kap_5_ArraysContainer.h"

namespace N_Loesungen_Container {
  using namespace System::Windows::Forms;


// *********** Kap. 12 Aufgabe 12.1.5 Containerklassen

  // --------------- Aufgabe 1 ------------------------------- 

  void Alg(TextBox^ tb)
  {
    // a) 
    int a[10] = { 9,8,7,6,5,4,3,2,1,0 };
    std::sort(a, a + 10);
    for (int i = 0; i < 10; i++)
      tb->AppendText(a[i].ToString() + "\r\n");

    // b) 
    int b[10];
    std::copy(a, a + 10, b);
    for (int i = 0; i < 10; i++)
      tb->AppendText(b[i].ToString() + "\r\n");

    // c) 
    if (std::equal(a, a + 10, b))
      tb->AppendText("gleich \r\n");
    else
      tb->AppendText("ungleich \r\n");
    b[1] = 17;
    if (std::equal(a, a + 10, b))
      tb->AppendText("gleich \r\n");
    else
      tb->AppendText("ungleich \r\n");
  }


  // --------------- Aufgabe 2 ------------------------ 

  void GeprüfteIteratoren(TextBox^ tb, int test)
  {
    std::vector<int> v;
    std::vector<int>::iterator it;

    std::vector<int> v1;
    std::vector<int> v3(10);

    // a) 
    if (test == 1)
      *it = 17;

    // b) 
    else if (test == 2)
    {
      it = v.begin();
      *it;
    }

    // c) 
    else if (test == 3)
    {
      it = v.begin();
      v.push_back(17);
      *it;
    }

    // d) 
    else if (test == 4)
      *v.end() = 17;

    // e) 
    else if (test == 5)
      copy(v1.begin(), v.end(), v3.begin());

    // f) 
    else if (test == 6)
      copy(v.end(), v.begin(), v3.begin());

    else
      MessageBox::Show("invalid testcase");
  }

// *********** Kap. 12 Aufgabe 12.1.7 Mehrdimensionale Vektoren

  // --------------- Aufgabe 1 ------------------------------- 

  void ShowCapacity(TextBox^ tb, int n)
  {
    std::vector<int> v;
    std::vector<int>::size_type c, c0 = v.capacity();
    for (int i = 0; i < n; i++)
    {
      v.push_back(i);
      c = v.capacity();
      if (c != c0)
        tb->AppendText("v cap: " + v.capacity().ToString() + " " + i.ToString() + "\r\n");
      c0 = c;
    }
    v.clear();
    tb->AppendText("nach erase: " + v.capacity().ToString() + "\r\n");
  }

  // --------------- Aufgabe 2 ------------------------------- 

  void PascalDreieck(TextBox^ tb, int n)
  {
    std::vector<std::vector<int>> p(n);
    // reserviere Speicher für die Dreiecksmatrix: 
    for (int i = 0; i < n; i++)
      p[i].resize(i + 1); // p[i] hat i+1 Elemente p[i,0] ... p[i,i] 

    // Berechne die Werte des Pascal-Dreiecks: 
    p[0][0] = 1;
    for (int i = 1; i < n; i++)
    {
      p[i][0] = 1;
      p[i][i] = 1;
      for (int j = 1; j <= i - 1; j++)
        p[i][j] = p[i - 1][j - 1] + p[i - 1][j];
    };

    // Werte anzeigen: 
    for (int i = 0; i < n; i++)
    {
      std::string s = "";
      for (int j = 0; j <= i; j++)
        s = s + std::to_string(p[i][j]) + " ";
      tb->AppendText(rk1::to_String(s) + "\r\n");
    };
  }


// *********** Kap. 12 Aufgabe 12.2.3 Assoziative Container

  // --------------- Aufgabe 1 ------------------------ 

  typedef int ValueType;
  typedef int KeyType;
  typedef std::map<KeyType, ValueType> InfoSys;
  InfoSys m;

  bool ValueToKey(KeyType key, ValueType& value)
  {
    InfoSys::iterator pos = m.find(key);
    bool found = (pos != m.end());
    if (found)
      value = pos->second;
    return found;
  }

  void InfoSystClick(TextBox^ tb, KeyType x)
  {
    ValueType data;
    bool found = ValueToKey(x, data);
    if (found)
      tb->AppendText("gefunden: " + data + "\r\n");
    else
      tb->AppendText("nicht gefunden!\r\n");
      /*
      Aufgrund des logarithmischen Komplexität von m.find ist wegen

      log(1000) ~ log(2^10) = 10
      log(1000000) = log(1000*1000) ~ log(2^20) = 20

      eine Verdoppelung der Suchzeiten zu erwarten. Sie sind aber so
      klein, dass mit einer Genauigkeit des Timers von 1 Mikrosekunde
      keine Unterschiede beobachtet werden konnten:

      Gemessene Suchzeiten bei 1000 Elementen:

      7,71048793979115E-5 Sekunden
      7,54286863675221E-5
      7,79429759131062E-5
      7,87810724283008E-5
      7,79429759131062E-5

      Gemessene Suchzeiten bei 1000000 Elementen:

      9,7219195762584E-5
      7,54286863675221E-5
      8,12953619738849E-5
      7,79429759131062E-5
      7,12382037915486E-5
      */
  }

    void fillContainer(int n)
    {
      m.clear();
      for (int i = 0; i < n; i++)
        m[i] = i;
    }

#ifdef SIMPLEUNITTESTS_H__ 
    void Unittests_ValueToKey(int n)
    {
      fillContainer(n);
      if (n > 0)
      {
        int data;
        bool found = ValueToKey(-1, data);
        rk1::Assert::AreEqual(found, false, "test_ValueToKey: " + std::to_string(-1));
        found = ValueToKey(0, data);
        rk1::Assert::AreEqual(found, true, "test_ValueToKey: " + std::to_string(0));
        found = ValueToKey(n - 1, data);
        rk1::Assert::AreEqual(found, true, "test_ValueToKey: " + std::to_string(n - 1));
        found = ValueToKey(n, data);
        rk1::Assert::AreEqual(found, false, "test_ValueToKey: " + std::to_string(n));
        found = ValueToKey(n + 1, data);
        rk1::Assert::AreEqual(found, false, "test_ValueToKey: " + std::to_string(n + 1));
      }
    }
#endif // #ifdef SIMPLEUNITTESTS_H__ 


    // --------------- Aufgabe 2 -------------------------------
    std::set <int> randSet;
    std::mt19937 gen1;
    std::uniform_int<int> rnd(1, 100); // #include <random>

    int NewRand(unsigned int Max)
    {
      if (randSet.size() < Max)
      {
        unsigned int Anzahl_vorher = randSet.size(), r;
        while (randSet.size() == Anzahl_vorher) // Endlosschleife, falls
        {                                  // s.size()>=Max          
          r = rnd(gen1); // oder r = rand() % Max;
          randSet.insert(r);
        }
        return r;
      }
      else return -1; // oder Exception auslösen
    }


    void NewRandClick(TextBox^ tb)
    {
      int n = 10;
      for (int i = 0; i < n + 5; i++)
        tb->AppendText(NewRand(n) + "\r\n");
    }

    // --------------- Aufgabe 3 -------------------------------

    typedef std::set<std::string> Woerterbuch;

    Woerterbuch WoerterbuchLesen(const std::string& ifn)
    {
      Woerterbuch dict;
      std::vector<std::string>  c;
      std::ifstream fin(ifn);
      if (fin)
      {
        std::string z;
        while (getline(fin, z))
        {
          c = N_Loesungen_Arrays::tokenize(z);
          dict.insert(c.begin(), c.end());
        }
        if (!fin.eof())
          MessageBox::Show(rk1::to_String("read error: " + ifn));
      }
      else
        MessageBox::Show(rk1::to_String("open error: " + ifn));
      fin.close(); // überflüssig, aber kein Fehler
      return dict;
    }


    void TextPruefen(TextBox^ tb, const std::string& ifn, const Woerterbuch& dict)
    {
      std::vector<std::string>  c;
      std::ifstream fin(ifn);
      if (fin)
      {
        std::string z;
        while (getline(fin, z))
        {
          c = N_Loesungen_Arrays::tokenize(z);
          for (auto i = c.begin(); i != c.end(); i++)
          {
            if (dict.find(*i) == dict.end())
            { // nicht im Wörterbuch enthaltenene Wörter ausgeben:
              tb->AppendText(rk1::to_String(z + ": " + *i + "\r\n"));
            }
          }
        }
        if (!fin.eof())
          MessageBox::Show(rk1::to_String("read error: " + ifn));
      }
      else
        MessageBox::Show(rk1::to_String("open error: " + ifn));
        fin.close(); // überflüssig, aber kein Fehler
    }
    namespace fn2 { // ??? Die im Folgenden verwendeten Dateinamen
      const std::string TestDir = "c:\\Test\\"; 
      const std::string TestTextfile = TestDir + "Faust.txt";
      const std::string Faust_veraendert = TestDir + "Faust_veraendert.txt";
      const std::string TestCppfile = TestDir + "AssCont.h";
    }

  void RechtschrPruefung(TextBox^ tb)
  {
    Woerterbuch dict =
      WoerterbuchLesen(fn2::TestTextfile); // faust.txt
    tb->AppendText("Anzahl der Wörterbucheinträge: "
      + dict.size().ToString() + "\r\n");
    TextPruefen(tb, fn2::Faust_veraendert, dict);
    // In Faust_veraendert wurden gegenüber faust.txt einige Worte verändert
  }


  // --------------- Aufgabe 4 -------------------------------

  typedef std::multimap<std::string, int> MMType;

  MMType MakeXRef(std::vector<std::string> v) // Ein XRef-Generator in 13 Zeilen
  { // erzeugt eine Crossreference-Liste aus den Strings eines Vektors
    MMType mm;
    int line = 1;
    for (auto i = v.begin(); i != v.end(); i++)
    {
      std::vector<std::string> c = N_Loesungen_Arrays::tokenize(*i);
      for (auto token = c.begin(); token != c.end(); token++)
        mm.insert(make_pair(*token, line));
      line++;
    }
    return mm;
  }

  MMType MakeXRef(std::string ifn) // fn: Dateiname
  { // erzeugt eine Crossreference-Liste aus den Wörtern der Zeilen einer Datei 
    MMType mm;
    std::ifstream fin(ifn);
    if (fin)
    {
      std::string z;
      int line = 1;
      while (getline(fin, z))
      {
        std::vector<std::string> c = N_Loesungen_Arrays::tokenize(z);
        for (auto token = c.begin(); token != c.end(); token++)
          mm.insert(make_pair(*token, line));
        line++;
      }
      if (!fin.eof())
        MessageBox::Show(rk1::to_String("read error: " + ifn));
    }
    else
      MessageBox::Show(rk1::to_String("open error: " + ifn));
    return mm;
  }


void PrintXRef(TextBox^ tb, MMType mm, char* fn = 0)
{ // Schreibt eine XRef-Liste in die TextBox oder in 
  // die Datei mit dem Namen fn
  std::ofstream of;
  if (fn != 0) of.open(fn);
  for (auto i = mm.begin(); i != mm.end(); )
  {
    std::ostringstream out;
    auto first = mm.lower_bound(i->first),
      last = mm.upper_bound(i->first);
    out << i->first << ": ";
    for (auto j = first; j != last; j++)
    {
      out << "  " << j->second;
      i++; // Mit jedem gefundenen Wert hochzählen
    };
    // i=last++; // Alternative zu i++ in der Schleife 
    if (fn != 0) of << out.str() << std::endl;
    else tb->AppendText(rk1::to_String(out.str()));
  }
}


void XRefClick(TextBox^ tb)
{
  std::vector<std::string> v = {
  "Alle meine Entchen",
  "schwimmen auf dem See,"
  "schwimmen auf dem See," };

  MMType mm = MakeXRef(v);
  PrintXRef(tb, mm);
  mm.clear();

  mm = MakeXRef(fn2::TestCppfile);
  PrintXRef(tb, mm);
}





} // end of namespace N_Loesungen_Container

