﻿// *********** Kap. 13 Lösungen Kapitel  13. Dateibearbeitung mit den Streamklassen



#include <fstream> 
#include <string>

namespace N_Loesungen_Streamklassen
{
  using namespace System::Windows::Forms;


  namespace fn1 { // Die im Folgenden verwendeten Dateinamen
    const std::string TestDir = "c:\\Test\\"; // oder z.B. "c:\\test";
    const std::string TestHTMLfile = TestDir + "Faust.html";
    const std::string TestExefile = TestDir + "Kap_4.exe";
    const std::string TestCppfile = TestDir + "AssCont.h";

    const std::string TextDir = "\\Loesungen_VC2008\\Text\\";
    const std::string TestTextfile = TextDir + "Faust.txt";
  }

// *********** Kap. 13 Aufgabe 13.3 Binärdateien

  // --------------- Aufgabe 1 a) ---------------------------- 

  int countBytes(std::string fn)
  {
    char c;
    int n = 0;
    std::ifstream f(fn, std::ios::binary);
    if (!f)
      MessageBox::Show("open error");
    while (f.read(&c, sizeof(c)))
      n++;
    if (!f.eof())
      MessageBox::Show("read error");
    f.close();
    return n;
  }

  int countBytesTxt(std::string fn)
  {
    char c;
    int n = 0;
    std::ifstream f(fn);
    if (!f)
      MessageBox::Show("open error");
    while (f.read(&c, sizeof(c)))
      n++;
    if (!f.eof())
      MessageBox::Show("read error");
    f.close();
    return n;
  }


  int countBytes(std::string fn, bool binary)
  {
    char c;
    int n = 0;
    std::ifstream f;
    if (binary) f.open(fn, std::ios::binary);
    else f.open(fn);
    // wie 
    // ifstream f(fn,ios::binary); oder 
    // ifstream f(fn); // ohne ios::binary ist das Ergebnis sowohl für 
    // Text- als auch für Binärdateien falsch 
    if (!f)
      MessageBox::Show("open error");
    while (f.read(&c, sizeof(c)))
      n++;
    if (!f.eof())
      MessageBox::Show("read error");
    f.close();
    return n;
  }

  void createTestfile(std::string fn, int n)
  {
    std::ofstream fout(fn1::TestDir + fn);
    char a[] = { '1','2','3',26,'5','6' };
    fout.write(a, n);
    fout.close();
  }

  void Unittests_countBytes()
  {
    createTestfile("0.dat", 0);
    createTestfile("1.dat", 1);
    createTestfile("6.dat", 6);

    int n0 = countBytes(fn1::TestDir + "0.dat", false);

    rk1::Assert::AreEqual(n0, 0, "countBytes 0");
    int n0b = countBytes(fn1::TestDir + "0.dat", true);
    rk1::Assert::AreEqual(n0b, 0, "countBytes 0 b");

    int n1 = countBytes(fn1::TestDir + "1.dat", false);
    rk1::Assert::AreEqual(n1, 1, "countBytes 1");
    int n1b = countBytes(fn1::TestDir + "1.dat", true);
    rk1::Assert::AreEqual(n1b, 1, "countBytes 1 b");

    int n2 = countBytes(fn1::TestDir + "6.dat", false);
    rk1::Assert::AreEqual(n2, 3, "countBytes 1");
    int n2b = countBytes(fn1::TestDir + "6.dat", true);
    rk1::Assert::AreEqual(n2b, 6, "countBytes 1 b");
  }

  void CountBytesClick(TextBox^ tb)
  {
    // entweder 
    int n = countBytes(fn1::TestTextfile);
    tb->AppendText(rk1::to_String(fn1::TestTextfile) + " (binary mode): " + n.ToString() + " bytes\r\n");
    n = countBytesTxt(fn1::TestTextfile);
    tb->AppendText(rk1::to_String(fn1::TestTextfile) + "  (text  mode):  " + n.ToString() + " bytes\r\n");


    n = countBytes(fn1::TestExefile);
    tb->AppendText(rk1::to_String(fn1::TestExefile) + " (binary mode): " + n.ToString() + " bytes\r\n");
    n = countBytesTxt(fn1::TestExefile);
    tb->AppendText(rk1::to_String(fn1::TestExefile) + "  (text  mode):  " + n.ToString() + " bytes\r\n");

    // oder 
    n = countBytes(fn1::TestTextfile, true);
    tb->AppendText(rk1::to_String(fn1::TestTextfile) + "   (binary):   " + n.ToString() + " bytes\r\n");
    n = countBytes(fn1::TestTextfile, false);
    tb->AppendText(rk1::to_String(fn1::TestTextfile) + ": " + n.ToString() + " bytes\r\n");

    n = countBytes(fn1::TestExefile, true);
    tb->AppendText(rk1::to_String(fn1::TestExefile) + "    (binary):    " + n.ToString() + " bytes\r\n");
    n = countBytes(fn1::TestExefile, false);
    tb->AppendText(rk1::to_String(fn1::TestExefile) + ": " + n.ToString() + " bytes\r\n");
    // Die Ergebnisse stimmen nur für Dateien, die im Binärmodus geöffnet 
    // wurden. 
  }


  // --------------- Aufgabe 1 b) ---------------------------- 

  void CopyFile(const std::string& src, const std::string& dst)
  {
    std::ifstream fin(src, std::ios::binary);
    std::string msg = "open error ";
    if (!fin)
      MessageBox::Show(rk1::to_String(msg + src));
    std::ofstream fout(dst, std::ios::binary);
    if (!fout)
      MessageBox::Show(rk1::to_String(msg + dst));
    char c;
    while (fin.read(&c, sizeof(c)))
    {
      fout.write(&c, sizeof(c));
      if (!fout)
        MessageBox::Show("write error");
    }
    if (!fin.eof())
      MessageBox::Show("read error");
    fin.close();
    fout.close();
  }

  const std::string CopyTextDest = fn1::TestDir + "Ctest.txt";
  const std::string CopyExeDest = fn1::TestDir + "Ctest.exe";

  void test_CopyFile()
  {
    CopyFile(fn1::TestTextfile, CopyTextDest);
    CopyFile(fn1::TestExefile, CopyExeDest);
  }


  // --------------- Aufgabe 1 c) ---------------------------- 

  bool CompareFiles(const std::string fn1, const std::string fn2)
  {
    std::string msg = "open error ";

    std::ifstream f1(fn1, std::ios::binary);
    if (!f1)
      MessageBox::Show(rk1::to_String(msg + fn1));

    std::ifstream f2(fn2, std::ios::binary);
    if (!f2)
      MessageBox::Show(rk1::to_String(msg + fn2));

    bool gleich = true; // zwei leere Dateien sind gleich 
    while (f1 && f2 && gleich)
    {
      char c1, c2;
      f1.read(&c1, sizeof(c1));
      f2.read(&c2, sizeof(c2));

      gleich = (c1 == c2);
    }
    if (!f1 && !f1.eof())
      MessageBox::Show("read error f1");
    if (!f2 && !f2.eof())
      MessageBox::Show("read error f2");

    if (gleich)
      gleich = (f1.eof() == f2.eof()); // Falls die Dateien verschieden lang sind 
    f1.close();
    f2.close();
    return gleich;
    /*
    Die folgende Schleife funktioniert nicht, da wegen der short circuit
    evaluation von booleschen Ausdrücken beim Ende von f1 in f2 nicht mehr
    gelesen wird:

    while (f1.read(&c1,sizeof(c1)) && f2.read(&c2,sizeof(c2)) && gleich)
    gleich=(c1==c2);
    */
  }

#ifdef SIMPLEUNITTESTS_H__ 
  // Dieses Makro wird durch ein #include "SimpleUnitTests.h" definiert
  void Unittests_copy_and_compare_files()
  {
    test_CopyFile();
    bool b = CompareFiles(fn1::TestTextfile, CopyTextDest);
    rk1::Assert::AreEqual(b, true, "CompareFiles 1");
    b = CompareFiles(fn1::TestExefile, CopyExeDest);
    rk1::Assert::AreEqual(b, true, "CompareFiles 2");
    b = CompareFiles(fn1::TestTextfile, CopyExeDest);
    rk1::Assert::AreEqual(b, false, "CompareFiles 3");
    b = CompareFiles(fn1::TestExefile, CopyTextDest);
    rk1::Assert::AreEqual(b, false, "CompareFiles 4");
  }

  void Unittests_Files()
  {
    rk1::Assert::Init("Unittest_Files");
    Unittests_countBytes();
    Unittests_copy_and_compare_files();
    rk1::Assert::Summary();
  }
#endif // #ifdef SIMPLEUNITTESTS_H__ 




// *********** Kap. 13 Aufgabe 13.3 Textdateien

  // --------------- Aufgabe 1 -------------------------------

  void CsvTabelleAnlegen(std::string out_fn)
  { 
    std::ofstream fout(out_fn);
    if (fout)
    {
      fout << "n ;  n*n ;  n*n*n " << std::endl;
      for (int i = 5; i <= 10; i++)
        fout << i << ";" << i*i << ";" << i*i*i << ";" << std::endl;
      fout.close(); // überflüssig
    }
    else
      MessageBox::Show(rk1::to_String("open error " + out_fn));
  }


  // --------------- Aufgabe 2 -------------------------

  void PrintTextlines(std::ostream& fout, std::string in_fn)
  {
    std::ifstream fin(in_fn);
    if (fin)
    {
      std::string s;
      while (getline(fin, s))
      {
        for (std::string::size_type i = 0; i < s.length(); i++)
          if (s[i] == 'ä') s.replace(i, 1, "&auml;");
          else if (s[i] == 'ö') s.replace(i, 1, "&ouml;");
          else if (s[i] == 'ü') s.replace(i, 1, "&uuml;");
          else if (s[i] == 'ß') s.replace(i, 1, "&szlig;");
          else if (s[i] == 'Ä') s.replace(i, 1, "&Auml;");
          else if (s[i] == 'Ö') s.replace(i, 1, "&ouml;");
          else if (s[i] == 'Ü') s.replace(i, 1, "&Uuml;");
          if (fout << "<BR>" << s << std::endl)
            MessageBox::Show(rk1::to_String("write error "));
      }
    }
    else
      MessageBox::Show(rk1::to_String("open error " + in_fn));
  }

  void TextToHTML(std::string ifn, std::string htmlfn)
  {
    std::ofstream fout(htmlfn);
    fout << "<HTML>" << std::endl
      << "<HEAD>" << std::endl
      << "<TITLE>"
      << ifn
      << "</TITLE>" << std::endl
      << "</HEAD>" << std::endl
      << "<BODY>" << std::endl;
    PrintTextlines(fout, ifn);
    fout << "</BODY>" << std::endl;
    fout << "</HTML>" << std::endl;
    fout.close(); // überflüssig
  }


} // end of namespace N_Loesungen_Streamklassen 
