﻿#pragma once

// *********** Kap. 5 Aufgabe 5.4 Arrays als Container



#ifdef _DEBUG 
#include "SimpleUnitTests.h"
#endif

#include <string>
#include <cstdlib>

namespace N_Arrays_als_Container
{
  using namespace System::Windows::Forms;


  // --------------- Aufgabe 1. ------------------------------

  const int maxElements = 5; // Mit einem kleinen Wert von maxElements
                             // kann man die Prüfungen auf die Obergrenze
                             // einfach testen.
  int nElements = 0; // Anzahl der Arrayelemente
                     // belegt im Array: A[0] .. A[nElements-1]
  typedef int T;
  T A[maxElements];

  // a)
  bool pushBack(T data)
  {
    bool success = true;
    if (nElements < maxElements)
    {
      A[nElements] = data;
      nElements++;
    }
    else success = false;
    return success;
    // Nachbedingung: Falls beim Aufruf nElements<maxElements gilt:
    //                  nElements=nElements0+1
    //                  a[nElements-1]==data
    //                  Rückgabewert true
    //                und andernfalls Rückgabewert false.
  }


  // b)
  void showArray(TextBox^ tb)
  {
    for (int i = 0; i < nElements; i++)
      tb->AppendText(A[i].ToString() + "  ");
    tb->AppendText(System::Environment::NewLine);
  }

  // c)

  /*
  nElements  A[0]  A[1]  A[2]    pushBack maxElements
  nElements=0          0                                      3
  pushBack("10")       1     "10"                   true
  pushBack("11")       2           "11"             true
  pushBack("12")       3                 "12"       true
  pushBack("13")       3                            false

  Mit n<maxElements Aufrufen von pushBack werden die Positionen
  a[0], …, a[n-1] des Array mit den Argumenten von pushBack gefüllt.
  */

  // d)

  int findLinear(T x, int Start)
  {
    int result = nElements;
    bool found = false;
    for (int i = Start; i < nElements && !found; i++)
      if (x == A[i])
      {
        result = i;
        found = true;
      }
    return result;
  }


  // e)

  bool eraseElement(int pos)
  {
    bool result = true;
    if ((0 <= pos) && (pos < nElements))
    {
      A[pos] = A[nElements - 1];
      nElements--;
    }
    else result = false;
    return result;
  }


  // f)

  void Auswahlsort()
  {
    for (int i = 0; i < nElements - 1; i++)
    {
      int min = i;
      for (int j = i + 1; j < nElements; j++)
        if (A[j] < A[min]) min = j;
      T x = A[i];
      A[i] = A[min];
      A[min] = x;
    }
  }

  // g)
  int findBinary(T s)
  {
    int M = -1;
    int L = 0;
    int R = nElements - 1;
    bool found = false;
    while ((L <= R) && (!found))
    {
      // A sortiert ==> A[L] <= A[R]
      M = (L + R) / 2;
      // A[L] <= A[M] <= A[R]
      if (A[M] < s) L = M + 1;
      else if (s < A[M]) R = M - 1;
      else found = true;
    }
    if (found) return M;
    else return nElements;
  }


  // h)
  bool insertSorted(T x)
  {
    bool result = false;
    if (nElements < maxElements)
    {
      // Die Position p für das neue Element bestimmen
      int p = 0;
      while ((p < nElements) && (A[p] < x)) // Reihenfolge der Bedingungen ist relevant (Short-Circuit-Evaluation)
        p++; // Alle Elemente ab Position p um eine Position nach hinten verschieben
      for (int i = nElements - 1; i >= p; i--)
        A[i + 1] = A[i];
      A[p] = x;       // Das neue Element in Position p eintragen
      nElements++;  // Anzahl der Elemente aktualisieren
      result = true;
    }
    return result;
  }


  // i)
  // Falls das gesuchte Element mehrfach im Array enthalten ist,
  // wird mit einer binären Suche nicht unbedingt das letzte gefunden.

  // j)
  bool eraseSorted(const T& x)
  {
    bool result = false;
    int p = findLinear(x, 0);
    if ((0 <= p) && (p < nElements))
    { // Alle Elemente ab Position p um eine Position nach vorne
      for (int i = p; i < nElements - 1; i++)
        A[i] = A[i + 1];
      nElements--; // Anzahl der Elemente aktualisieren
      result = true;
    }
    return result;
  }


  // k)

  void Unittests_1()
  {
    // teste pushBack, findLinear und eraseElement
    nElements = 0;
    rk1::Assert::AreEqual(findLinear(1, 0), 0, "findLinear(1,0) - a");
    pushBack(1);
    rk1::Assert::AreEqual(findLinear(1, 0), 0, "findLinear(1,0) - b");
    pushBack(2);
    rk1::Assert::AreEqual(findLinear(2, 0), 1, "findLinear(2,0)");
    pushBack(3);
    rk1::Assert::AreEqual(findLinear(3, 0), 2, "findLinear(3,0) - a");
    // Ist das gefundene Element auch wirklich das erste?
    pushBack(3);
    rk1::Assert::AreEqual(findLinear(3, 0), 2, "findLinear(3,0) - b");
    // teste eraseElement
    eraseElement(0);
    rk1::Assert::AreEqual(findLinear(0, 0), nElements, "nach eraseElement(0,0)");
  }

  void Unittests_SetAndSort2Elements(T e1, T e2)
  {
    nElements = 0;
    pushBack(e1);
    pushBack(e2);
    Auswahlsort();
  }

  void Unittests_SetAndSort3Elements(T e1, T e2, T e3)
  {
    nElements = 0;
    pushBack(e1);
    pushBack(e2);
    pushBack(e3);
    Auswahlsort();
  }

  void Unittests_Auswahlsort_0123()
  { // teste Auswahlsort mit 0, 1, 2 und 3 Elementen
    nElements = 0;
    Auswahlsort(); // Auswahlsort sollte bei einem leeren Array nicht abstürzen
    pushBack(1);
    Auswahlsort(); // Array mit einem Element
    rk1::Assert::AreEqual(findLinear(1, 0), 0, "findLinear(1,0)");

    Unittests_SetAndSort2Elements(1, 2); // bereits sortiert
    rk1::Assert::AreEqual(findLinear(1, 0), 0, "sort 2, 1a");
    rk1::Assert::AreEqual(findLinear(2, 0), 1, "sort 2, 1b");
    Unittests_SetAndSort2Elements(2, 1); // umgekehrte Reihenfolge
    rk1::Assert::AreEqual(findLinear(1, 0), 0, "sort 2, 2a");
    rk1::Assert::AreEqual(findLinear(2, 0), 1, "sort 2, 2b");

    Unittests_SetAndSort3Elements(1, 2, 3); // testen alle Permutationen
    rk1::Assert::AreEqual(findLinear(1, 0), 0, "sort 3, 1a");
    rk1::Assert::AreEqual(findLinear(2, 0), 1, "sort 3, 1b");
    rk1::Assert::AreEqual(findLinear(3, 0), 2, "sort 3, 1c");
    Unittests_SetAndSort3Elements(1, 3, 2);
    rk1::Assert::AreEqual(findLinear(1, 0), 0, "sort 3, 1a");
    rk1::Assert::AreEqual(findLinear(2, 0), 1, "sort 3, 1b");
    rk1::Assert::AreEqual(findLinear(3, 0), 2, "sort 3, 1c");
    Unittests_SetAndSort3Elements(2, 1, 3);
    rk1::Assert::AreEqual(findLinear(1, 0), 0, "sort 3, 1a");
    rk1::Assert::AreEqual(findLinear(2, 0), 1, "sort 3, 1b");
    rk1::Assert::AreEqual(findLinear(3, 0), 2, "sort 3, 1c");
    Unittests_SetAndSort3Elements(2, 3, 1);
    rk1::Assert::AreEqual(findLinear(1, 0), 0, "sort 3, 1a");
    rk1::Assert::AreEqual(findLinear(2, 0), 1, "sort 3, 1b");
    rk1::Assert::AreEqual(findLinear(3, 0), 2, "sort 3, 1c");
    Unittests_SetAndSort3Elements(3, 1, 2);
    rk1::Assert::AreEqual(findLinear(1, 0), 0, "sort 3, 1a");
    rk1::Assert::AreEqual(findLinear(2, 0), 1, "sort 3, 1b");
    rk1::Assert::AreEqual(findLinear(3, 0), 2, "sort 3, 1c");
    Unittests_SetAndSort3Elements(3, 2, 1);
    rk1::Assert::AreEqual(findLinear(1, 0), 0, "sort 3, 1a");
    rk1::Assert::AreEqual(findLinear(2, 0), 1, "sort 3, 1b");
    rk1::Assert::AreEqual(findLinear(3, 0), 2, "sort 3, 1c");
  }

  bool isSorted()
  {
    bool result = true;
    for (int i = 0; i < nElements - 1; i++)
      if (A[i] > A[i + 1]) result = false;
    return result;
  }

  void Unittests_Auswahlsort_n(int n)
  { // teste Auswahlsort mit n Zufallszahlen
    nElements = 0;
    for (int i = 0; i < n; i++)
      pushBack(std::rand());
    Auswahlsort();
    rk1::Assert::AreEqual(isSorted(), true, "sort n");
  }

  void Unittests_2()
  {// teste findBinary, insertSorted und eraseSorted
    bool result = true;
    nElements = 0;
    rk1::Assert::AreEqual(findBinary(1), 0, "findBinary(1,0)");
    pushBack(1);
    rk1::Assert::AreEqual(findLinear(1, 0), 0, "findLinear(1,0)");
    pushBack(2);
    rk1::Assert::AreEqual(findLinear(2, 0), 1, "findLinear(2,0)");
    pushBack(3);
    rk1::Assert::AreEqual(findLinear(3, 0), 2, "findLinear(2,0)");
    // teste eraseElement
    eraseElement(0);
    rk1::Assert::AreEqual(findLinear(0, 0), nElements, "nach eraseElement(2,0)");
  }

  void Unittests_3_10_4() // ??? Namen 
  {
    Unittests_1();
    Unittests_Auswahlsort_0123();
    for (int i = 0; i < 100; i++)
      Unittests_Auswahlsort_n(i);
    Unittests_2();
  }

  void Unittests_Array(bool ask)
  {
    if (!ask || MessageBox::Show("Die Daten im Array werden gelöscht - weiter?",
      "Unittests_Array 3.10", // ???
      MessageBoxButtons::YesNo) == System::Windows::Forms::DialogResult::Yes)
    {
      // ???    rk1::Assert::Init(tb, "Unittests_Array 3.10.4"); // Tests initialisieren
      Unittests_3_10_4();
      rk1::Assert::Summary();// Testzusammenfassung ausgeben
    }
  }
}
