﻿// *********** Kap. 7 Lösungen Kapitel 7. Zeiger

// using namespace std; // Okt. 2019, nur für test-track



// *********** Kap. 7 Aufgabe 7.4 Dynamisch erzeugte Variablen

#include <cmath> // für Hornersin
#include <string>

namespace N_Loesungen_Zeiger
{
  using namespace System::Windows::Forms;

  // --------------- Aufgabe 1 -------------------------------

  void Aufgabe_7_4_1()
  {
    int i = 5;
    int *pi, pj;
    char *pc, pd;
    // a)
    //    pi=i;   // Fehler: Konvertierung von 'int' nach 'int*' nicht möglich
    // b)
    pi = &i;  // *pi==5
              // c)
    *pi = i;  // *pi==5
              // d)
              //    *pi=&i; // Fehler: Konvertierung von 'int*' nach 'int' nicht möglich
              // e)
              //    pi=pj;  // Fehler: Konvertierung von 'int' nach 'int*' nicht möglich
              // f)
    pc = &pd; // *pc=pd
              // g)
              //    pi=pc;// Fehler: Konvertierung von 'char*' nach 'int*' nicht möglich
              // h)
    pd = *pi; // pd==5, wegen f) auch *pc==5
              // i)
    *pi = i**pc; // *pi==5*5
                 // j)
    pi = 0;   // pi kann nicht dereferenziert werden
  }


  // --------------- Aufgabe 2 -------------------------------

  // c)
  int* f_retp()
  {
    int x = 1;
    return &x;
  }

  void Aufgabe_7_4_2(TextBox^ tb)
  {
    // a)
    int j = 10;
    int* p = &j;
    *p = 17;
    tb->AppendText(j.ToString() + "\r\n"); // 17 wegen p==&j
    tb->AppendText((*p).ToString() + "\r\n"); // 17

    // b)
    *new(int) = 17;
    // Erzeugt eine Variable dynamisch, ohne ihre Adresse zu speichern. 
    // Deswegen kann dieser Speicher nicht mehr freigegeben werden 
    // (Speicherleck).

    // c)
    tb->AppendText((*f_retp()).ToString() + "\r\n");

    // Eine lokale, nicht statische Variable existiert nur während der
    // Ausführung des Blocks, in dem sie definiert wurde. Deshalb wird durch
    // *f_retp() ein nicht reservierter Speicherbereich angesprochen, und das
    // Fehler. Die meisten Compiler geben bei der Rückgabe eines solchen
    //  Wertes eine Warnung aus.
  }


  // --------------- Aufgabe 3 -------------------------------

  void ptr_swap(int* x, int* y)
  {
    //            x     *x    y    *y     h
    //            x0    *x0   y0   *y0
    int h = *x; //                          *x0
    *x = *y;    //        *y0
    *y = h;     //                    *x0
  } // *x=*y0 and *y=*x0

  void zeige_ptr_swap(TextBox^ tb)
  {
    int x = 17, y = 18;
    tb->AppendText("x=" + x.ToString() + " y=" + y.ToString() + "\r\n");    // x=17 y=18
    ptr_swap(&x, &y);
    tb->AppendText("x=" + x.ToString() + " y=" + y.ToString() + "\r\n");    // x=18 y=17
  }


// *********** Kap. 7 Aufgabe 7.5 Dynamisch erzeugte eindimensionale Arrays
  // --------------- Aufgabe 1. ------------------------------
  void DynSiebEratosthenes(TextBox^ tb, int n)
  {
    // Die einzigen beiden Änderungen: n muss keine Konstante
    // mehr sein, und das Array wird dynamisch erzeugt:
    //                               const int n=1000;
    bool* prim = new bool[n + 1]; // statt bool prim[n+1];
                                  // p[i]==true, falls i eine Primzahl ist, sonst false
    for (int i = 0; i <= n; i++)
      prim[i] = true;
    for (int i = 2; i <= n; i++)
      if (prim[i])
        for (int j = i; j <= n / i; j++)
          prim[j*i] = false;
    for (int i = 2; i <= n; i++)
      if (prim[i])
        tb->AppendText(i.ToString() + "\r\n");
    delete[] prim;
  };

  // --------------- Aufgabe 2. ------------------------------

  // a)

  typedef int T; // T irgendein Datentyp

  void ReAllocate(T*& a, int n_copy, int n_new)
  {
    T* pnew = new T[n_new]; // erzeuge das neue Array
    if (n_copy > n_new) n_copy = n_new;
    for (int i = 0; i < n_copy; i++)
      pnew[i] = a[i]; // kopiere das alte in das neue Array
    delete[] a;    // Speicher für das alte Array wieder freigeben
                   // Wegen diesem delete darf ReAllocate nur
                   // mit einem Argument aufgerufen werden, das auf ein
                   // dynamisch erzeugtes Array zeigt.
    a = pnew;         // Zeiger auf das neue Array zurückgeben
  }

  void test_ReAllocate_1()
  {
    int n0 = 1;
    T* d = new int[n0];
    for (int n = n0; n < 1000; n = 2 * n)
    {
      ReAllocate(d, n, n);
      for (int i = 0; i < n; i++)
        d[i] = i;
    }
    delete[] d;    // nicht vergessen
  }

  void test_ReAllocate_2()
  {
    // a)
    int* p1;
    ReAllocate(p1, 0, 100);
    // Der nicht initialisierte Zeiger p1 wird in
    // ReAllocate mit delete[] freigegeben - Fehler.

    // b)
    // Der mit new int initialisierte Zeiger p2 wird in
    // ReAllocate mit delete[] freigegeben - Fehler.

    // c)
    int x;
    int* p3 = &x;
    ReAllocate(p3, 0, 100);
    // Die mit int x angelegte Variable wird in
    // ReAllocate mit delete[] freigegeben.
    // p3 zeigt nicht auf einen Speicherbereich, der
    // mit new angelegt wurde. Der Aufruf von delete
    // in ReAllocate ist ein Fehler.

    // d)
    // wie in test_ReAllocate_1 - das funktioniert.
  }


// *********** Kap. 7 Aufgabe 7.9.1 Arrays, Zeiger und Zeigerarithmetik

  // --------------- Aufgabe 1. ------------------------------

  void Aufgabe_7_6_1(TextBox^ tb)
  {
    int a[10] = { 1, 3, 5, 7 }, *p = a;
    // *p      // = a[0] = 1
    // *p+1    // = a[0]+1 = 2
    // (*p)+1  // = a[0]+1 = 2
    // *(p+1)  // = a[1] = 3
    // *(p+3**p) // = a[3] = 7
    // *p**p   // = a[0]*a[1] = 1
    *(p + *(p + 1)); // = a[3] = 7
                     //int a[10]={1,3,5,7}, *p=a;
    tb->AppendText((*p).ToString() + "\r\n");      // = a[0] = 1
    tb->AppendText((*p + 1).ToString() + "\r\n");    // = a[0]+1 = 2
    tb->AppendText(((*p) + 1).ToString() + "\r\n");  // = a[0]+1 = 2
    tb->AppendText((*(p + 1)).ToString() + "\r\n");  // = a[1] = 3
    tb->AppendText((*(p + 3 * *p)).ToString() + "\r\n"); // = a[3] = 7
    tb->AppendText((*p**p).ToString() + "\r\n");   // = a[0]*a[0] = 1
  }




// *********** Kap. 7 Aufgabe 7.9.2 Arrays als Funktionsparameter
  // --------------- Aufgabe 1 -------------------------------

  // a)

  void AuswSort(int a[], int n)
  {
    for (int i = 0; i < n - 1; i++)
    {
      int min = i;
      for (int j = i + 1; j < n; j++)
        if (a[j] < a[min]) min = j;
      int x = a[i];
      a[i] = a[min];
      a[min] = x;
    }
  }

  // b)
  bool isSorted(int a[], int n)
  {
    bool result = true;
    for (int i = 0; i < n - 1; i++)
      if (a[i] > a[i + 1]) result = false;
    return result;
  }

  // c)

  bool ArraysAreEqual(int A[], int B[], int n)
  {
    bool result = true;
    for (int i = 0; i < n; i++)
      if (A[i] != B[i])
        result = false;
    return result;
  }

#ifdef SIMPLEUNITTESTS_H__ 
  // Dieses Makro wird durch ein #include "SimpleUnitTests.h" definiert
  void Unittest_AuswSort_n()
  {
    int a1s[1] = { 1 };
    {
      int a1[1] = { 1 };
      bool s = isSorted(a1, 1);
      rk1::Assert::AreEqual(true, s, "isSorted(a1, 1);");

      AuswSort(a1, 1);
      bool b = ArraysAreEqual(a1, a1s, 1);
      rk1::Assert::AreEqual(true, b, "Auswsort(a1,1);");
    }

    int a12s[2] = { 1, 2 };
    {
      int a12[2] = { 1, 2 };
      bool s = isSorted(a12, 2);
      rk1::Assert::AreEqual(true, s, "isSorted(a12, 2);");

      AuswSort(a12, 2);
      bool r = ArraysAreEqual(a12, a12s, 2);
      rk1::Assert::AreEqual(true, r, "Auswsort(a12,2);");
    } {
      int a21[2] = { 2, 1 };
      bool s = isSorted(a21, 2);
      rk1::Assert::AreEqual(false, s, "isSorted(a21, 2);");

      AuswSort(a21, 2);
      bool r = ArraysAreEqual(a21, a12s, 2);
      rk1::Assert::AreEqual(true, r, "Auswsort(a21,2);");
    }

    int a012s[3] = { 0, 1, 2 };
    {
      int a012[3] = { 0, 1, 2 };
      bool s = isSorted(a012, 3);
      rk1::Assert::AreEqual(true, s, "isSorted(a012, 3);");

      AuswSort(a012, 3);
      bool r = ArraysAreEqual(a012, a012s, 3);
      rk1::Assert::AreEqual(true, r, "AuswSort(a012, 3);");
    } {
      int a021[3] = { 0, 2, 1 };
      bool s = isSorted(a021, 3);
      rk1::Assert::AreEqual(false, s, "isSorted(a012, 3);");

      AuswSort(a021, 3);
      bool r = ArraysAreEqual(a021, a012s, 3);
      rk1::Assert::AreEqual(true, r, "AuswSort(a021, 3);");
    } {
      int a102[3] = { 1, 0, 2 };
      bool s = isSorted(a102, 3);
      rk1::Assert::AreEqual(false, s, "isSorted(a012, 3);");

      AuswSort(a102, 3);
      bool r = ArraysAreEqual(a102, a012s, 3);
      rk1::Assert::AreEqual(true, r, "AuswSort(a102, 3);");
    } {
      int a120[3] = { 1, 2, 0 };
      bool s = isSorted(a120, 3);
      rk1::Assert::AreEqual(false, s, "isSorted(a012, 3);");

      AuswSort(a120, 3);
      bool r = ArraysAreEqual(a120, a012s, 3);
      rk1::Assert::AreEqual(false, r, "AuswSort(a120, 3);");
    } {
      int a201[3] = { 2, 0, 1 };
      bool s = isSorted(a201, 3);
      rk1::Assert::AreEqual(false, s, "isSorted(a012, 3);");

      AuswSort(a201, 3);
      bool r = ArraysAreEqual(a201, a012s, 3);
      rk1::Assert::AreEqual(false, r, "AuswSort(a201, 3);");
    } {
      int a210[3] = { 2, 1, 0 };
      bool s = isSorted(a210, 3);
      rk1::Assert::AreEqual(false, s, "isSorted(a012, 3);");

      AuswSort(a210, 3);
      bool r = ArraysAreEqual(a210, a012s, 3);
      rk1::Assert::AreEqual(true, r, "AuswSort(a210, 3);");
    }
  }
#endif

  // --------------- Aufgabe 2 -------------------------------

  double Horner(double x, int n, double* p)
  { // p: Array mit den Koeffizienten des Polynoms,
    // n: der Grad des Polynoms
    double s = 0;
    for (int i = 0; i < n + 1; i++)
      s = s*x + p[n - i];
    return s;
  }

  void test_HornerSinus_p(TextBox^ tb)
  {
    double k3 = 3 * 2 * 1;
    double k5 = 5 * 4 * k3;
    double k7 = 7 * 6 * k5;
    const int n = 7; // Der Grad des Polynoms
    double p[n + 1] = { 0, 1, 0, -1 / k3, 0, +1 / k5, 0, -1 / k7 };
    for (int i = 1; i <= 31; i++)
    {
      double x = i / 10.0;
      double s1 = std::sin(x); // #include <cmath>
                               //s1=poly(x,n,p);
      double s2 = Horner(x, n, p);
      tb->AppendText("x=" + x.ToString() + " sin=" + s1 +
        " Horn-sin=" + s2.ToString() + " diff=" + std::abs(s1 - s2).ToString() + "\r\n");
      // Offensichtlich liefert die Taylor-Reihe für kleine Werte
      // eine gute Näherung
    }
  }



// *********** Kap. 7 Aufgabe 7.10 Stringliterale, nullterminierte Strings, ...
  // --------------- Aufgabe 1 -------------------------------

  // a)
  int Leerzeichen(const char* s)
  {
    int n = 0;
    while (*s != '\0')
    {
      if (*s == ' ') n++;
      s++;
    }
    return n;
  }

  // b)
  // Der Funktionsname "Leerzeichen" wird mit "LZ" abgekürzt:
  // { LZ("");0 | LZ("1");0 | LZ("1 ");1 | LZ(" 1");1 | LZ(" 1 ");2 }

  // c)  
  void Test_Leerzeichen(TextBox^ tb)
  { // ein einfacher Test für die Funktion Leerzeichen
    // { LZ("");0 | LZ("1");0 | LZ("1 ");1 | LZ(" 1");1 | LZ(" 1 ");2 }
    // Am einfachsten: Die Werte im Debugger anschauen
    int n1 = Leerzeichen("");    // 0
    int n2 = Leerzeichen("1");   // 0
    int n3 = Leerzeichen("1 ");  // 1
    int n4 = Leerzeichen(" 1");  // 1
    int n5 = Leerzeichen(" 1 "); // 2
                                 // oder die Werte in einer TextBox ausgeben:
    tb->AppendText("Leerzeichen('') = " + n1.ToString() + "\r\n");
    tb->AppendText("Leerzeichen('1') = " + n2.ToString() + "\r\n");
    tb->AppendText("Leerzeichen('1 ') = " + n3.ToString() + "\r\n");
    tb->AppendText("Leerzeichen(' 1') = " + n4.ToString() + "\r\n");
    tb->AppendText("Leerzeichen(' 1 ') = " + n5.ToString() + "\r\n");
  }
#ifdef SIMPLEUNITTESTS_H__ 
  // Dieses Makro wird durch ein #include "SimpleUnitTests.h" definiert

  void Unittests_Leerzeichen()
  { // ein einfacher Test für die Funktion Leerzeichen
    // { LZ("");0 | LZ("1");0 | LZ("1 ");1 | LZ(" 1");1 | LZ(" 1 ");2 }

    rk1::Assert::AreEqual(0, Leerzeichen(""), "Leerzeichen('')");
    rk1::Assert::AreEqual(0, Leerzeichen("1"), "Leerzeichen('1')");
    rk1::Assert::AreEqual(1, Leerzeichen("1 "), "Leerzeichen('1 ')");
    rk1::Assert::AreEqual(1, Leerzeichen(" 1"), "Leerzeichen(' 1')");
    rk1::Assert::AreEqual(2, Leerzeichen(" 1 "), "Leerzeichen(' 1 ')");
  }
#endif // #ifdef SIMPLEUNITTESTS_H__ 


  // --------------- Aufgabe 2. ------------------------------

  void charPtr_2()
  { /*
    char *x;     // Diese Definition reserviert Speicher für die
    // Adresse eines Zeigers auf char.
    x = "hello"; // Hier wird Speicherplatz für das Literal "hello"
    // reserviert und dessen Adresse x zugewiesen.

    a) Falsch: Es wird kein nicht reservierter Speicherbereich
    überschrieben

    b) Falsch: Diese Anweisung hat keine Zugriffsverletzung zur Folge.

    c) Richtig: a) und b) sind gleichwertig, wenn man vom
    unterschiedlichen Zeitpunkt der Zuweisung absieht.

    d) Auch diese Deklaration ist möglich. Allerdings hat x hier den
    Datentyp "Array mit Elementen des Datentyps char".
    */
  }


  // --------------- Aufgabe 3 -------------------------------
  void charPtr_3(TextBox^ tb)
  {
    char const* s = "blablabla";
    // a)
    if (s == " ");    // Vergleicht die Adressen der beiden Stringliterale
                      // "blablabla" und " " und nicht etwa die Strings

                      // b)
                      //  if (*s==" ") ; // char und char* können nicht verglichen werden

                      // c)
    if (*s == 'a' + 1); // Vergleicht das Zeichen an der Adresse von s (also
                        // 'b') mit dem Zeichen 'a'+1 (ebenfalls 'b').
                        // Ergebnis: true

                        // d)
                        //  if (s==' ') ;  // char* und char können nicht verglichen werden

                        // e)
    std::string s1 = s;
    std::string s2 = s + 1;
    std::string s3 = s + 20;

    tb->AppendText(rk1::to_String(s) + "\r\n"); // "blablabla"
    tb->AppendText(rk1::to_String(s + 1) + "\r\n"); // "lablabla"
    tb->AppendText(rk1::to_String(s + 20) + "\r\n"); // undefiniert, eventuell
                                 // eine Zugriffsverletzung

    // f)
    char c = 'A';
    char a[100];
#pragma warning( push )  
#pragma warning(disable : 4996) //_CRT_SECURE_NO_WARNINGS
    strcpy(a, &c); // Kopiert alle Zeichen ab der Adresse von c bis zum
                   // nächsten Nullterminator. Falls in den ersten 100 Bytes,
                   // die auf c folgen, kein Nullterminator kommt, kann das
                   // zu einer Zugriffsverletzung führen.
#pragma warning( pop )   
  }
  // --------------- Aufgabe 4 -------------------------------

  int Checksum(const char* name)
  {
    char a[10]; // 10 is enough
#pragma warning( push )  
#pragma warning(disable : 4996) //_CRT_SECURE_NO_WARNINGS
    strcpy(a, name);
#pragma warning( pop )   
    int s = 0;
    for (int i = 0; a[i] != 0; i++) s = s + a[i];
    return s;
  }

  void Checksum_Aufruf()
  {
    int c = Checksum("Check me, baby");
    /*
    Der Aufruf von Checksum mit einem Argument, das länger als 10
    Zeichen ist, kann dazu führen, dass nicht reservierte
    Speicherbereiche überschrieben werden (buffer overflow).

    ??? Solche Funktionen werden gerne von Viren-Programmierern benutzt.
    Mit geschickt gewählten Argumenten wird
    1. die Rücksprungadresse auf dem Stack überschrieben, und
    2. Code übergeben, der dann ausgeführt wird.
    */
  }

  // --------------- Aufgabe 5 -------------------------------

  void charPtr_5()  // konstante Zeiger
  {
    const int i = 17;
    int* p1 = nullptr;    char* q1 = nullptr;
    const int* p2;        const char* q2;
    int const* p3;        char const* q3;
    int* const p4 = p1;   char* const q4 = q1;

    // a)
    // p1=p2; // cannot convert 'const int *' to 'int *'
    // b)
    // p1=&i; // cannot convert 'const int *' to 'int *'
    // c)
    p2 = p1;
    // d)
    // *p3=i; // connot modify const object
    // e)
    //   *p4=18; // Syntaktisch ok, aber kein Speicher reserviert für *p4.

    // f)
    // q1=q2;  // cannot convert 'const char *' to 'char *'
    // g)
    // q1 = "abc";  // deprecated // In VS2019 ein Fehler
                 // h)
    q2 = q1;
    // i)
    // *q3='x'; // cannot modify const object
    // j)
    //   *q4='x'; // Syntaktisch ok, aber kein Speicher reserviert für *p4.
  }






// *********** Kap. 7 Aufgabe 7.11 Verkettete Listen

  namespace N_LinkedList {
    // --------------- Aufgabe 1 -------------------------------

    typedef int T; // Falls Werte anderer Datentypen als int in der
                   // Liste gespeichert werden sollen, muss der 
                   // Datentyp nur hier geändert werden. 
    // oder statt typedef
    // using T = int;

    struct Listnode {
      T data;            // Daten
      Listnode* next;
    };

    Listnode* first = nullptr;
    Listnode* last = nullptr;
    // Normalerweise ist die Verwendung von globalen Variablen wie
    // first und last nicht empfehlenswert.
    // Globale Variablen lassen sich mit Klassen leicht vermeiden. Diese 
    // Lösung ist so formuliert, dass sie einfach in eine objektorientierte 
    // Version übertragen werden kann. Dazu muss sie im Wesentlichen 
    // nur zwischen class VerketteteListe{ ... } geschrieben werden.


    // --------------- Aufgabe 1 a) ----------------------------

    Listnode* newListnode(const T& data, Listnode* next)
    { // Gibt einen Zeiger auf einen neuen Listenknoten {d0,nx0} zurück,
      // wobei d0 und nx0 die Argumente für data und next sind.
      Listnode* n = new Listnode;
      n->data = data;
      n->next = next;
      return n; // Nachbedingung: Der Rückgabewert zeigt auf einen neuen
    }           //                Knoten mit den Elementen {d0,nx0}

    void pushFront(const T& data)       // first  last data Neuer Knoten n
    {                                   //  f0     l0   d0    n0
      first = newListnode(data, first); //  n0                ->{d0,f0}
      if (last == nullptr)
        last = first;                   //         n0
                                        // Nachbedingung:
                                        // Fall I, f0==l0==0: first==last->{d0,0}
                                        // Fall II, l0!=0:    first->{d0,f0}
    }

    // Size ist für einige der folgenden Tests notwendig. Diese Funktion
    // prüft insbesondere auch, ob mit t=t->next die Bedingung t==0 
    // erreicht wird.
    int Size(Listnode* t)
    { // gibt die Anzahl der auf t folgenden Knoten zurück
      int n = 0;
      while (t != nullptr)
      {
        n++;
        t = t->next;
      }
      return n;
    }

    void clearList(); // Prototyp, siehe Aufgabe h)
                      // Für die Aufgaben bis h) reicht es, in dieser Funktion 
                      // first und last den Wert 0 zuzuweisen.

#ifdef SIMPLEUNITTESTS_H__ 
// Dieses Makro wird durch ein #include "SimpleUnitTests.h" definiert

    void Unittests_pushFront(int n)
    { // Füge Knoten ein und prüfe first, last und Size
      rk1::Assert::WriteLine("test_pushFront n=" + std::to_string(n));
      clearList();
      pushFront(5);
      rk1::Assert::AreEqual(first->data, 5, "pushFront 5 first");
      rk1::Assert::AreEqual(last->data, 5, "pushFront 5 last");
      rk1::Assert::AreEqual(Size(first), 1, "Size()==1");

      pushFront(10);
      rk1::Assert::AreEqual(first->data, 10, "pushFront 10 first");
      rk1::Assert::AreEqual(last->data, 5, "pushFront 5 last");
      rk1::Assert::AreEqual(Size(first), 2, "Size()==2");

      // Viele Tests
      clearList();
      for (int i = 0; i < n; i++)
      {
        pushFront(i);
        rk1::Assert::AreEqual(first->data, i, "pushFront 0 first");
        rk1::Assert::AreEqual(last->data, 0, "pushFront n last");
        rk1::Assert::AreEqual(Size(first), i + 1, "Size()==n");
      }
    }
#endif // #ifdef SIMPLEUNITTESTS_H__ 

    // --------------- Aufgabe 1 b) ----------------------------
    void showList(TextBox^ tb, Listnode* start)
    { // Gibt alle Daten der Liste ab der Position start aus
      tb->AppendText("Liste:\r\n");
      for (Listnode* tmp = start; tmp != 0; tmp = tmp->next)
        tb->AppendText(tmp->data.ToString() + " ");
      tb->AppendText("\r\n");
    }

    void test_showList()
    { // Ein automatischer Test von showList müsste den Text in der 
      // TextBox prüfen. Da das relativ aufwendig ist, scheint ein
      // manueller Test angemessener zu sein.
    }
    // --------------- Aufgabe 1 c) ----------------------------

    /*
    first       n1      n2      n3        n4
    -------------------------------------------------
    first=0;                          0
    first=newListnode("10",first);   n1     ->{"10",0}
    first=newListnode("11",first);   n2             ->{"11",n1}
    first=newListnode("12",first);   n3                      ->{"12",n2}
    first=newListnode("13",first);   n4                               ->{"13",n3}

    Das entspricht der Liste:

    first -> {"13",n3} -> {"12",n2} -> {"11",n1} -> {"10",0}

    Nach jedem Aufruf zeigt first auf den zuletzt eingefügten Knoten.
    In diesem Knoten zeigt next auf den zuvor eingefügten Knoten, usw.
    Im letzten Knoten der Liste hat next den Wert 0.
    Diese Liste ist also eine LIFO-Liste.
    */


    // --------------- Aufgabe 1 d) ----------------------------

    Listnode* findLinear(Listnode* start, const T& x)
    {
      Listnode* found = nullptr;
      Listnode* tmp = start;
      while (tmp != nullptr && found == nullptr)
      {
        if (tmp->data == x)
          found = tmp;
        tmp = tmp->next;
      }
      return found;
      // Nachbedingung:
      //   Entweder found==0: Dann wurden alle Knoten der Liste von start
      //     bis zum Ende durchlaufen, und die Bedingung tmp->data==x
      //     ist nie eingetreten.
      //   Oder found!=0: Dann wurden alle Knoten der Liste durchlaufen,
      //     bis das erste Mal tmp->data==x gilt.
      //     Ein Zeiger auf diesen Knoten wird dann zurückgegeben.
    }
    void FindLinearClick(TextBox^ tb, int x)
    {
      Listnode* p = findLinear(first, x);
      if (p == nullptr)
        tb->AppendText(x.ToString() + ": nicht gefunden\r\n");
      while (p != nullptr)
      {
        tb->AppendText(p->data.ToString() + ": gefunden");
        p = findLinear(p->next, x);
      }
    }

#ifdef SIMPLEUNITTESTS_H__ 
    // Dieses Makro wird durch ein #include "SimpleUnitTests.h" definiert

    void Unittests_findLinear()
    { // Einige Testfälle 
      rk1::Assert::WriteLine("test_findLinear");
      clearList();
      // 1. Suche in der leeren Liste sollte funktionieren,
      //    insbesondere nicht zu einem Programmabsturz führen
      rk1::Assert::AreEqual(int(findLinear(first, 1)), 0, "find in empty list");

      // 2. Ein Element einfügen und finden:
      pushFront(1);
      rk1::Assert::AreEqual(1, findLinear(first, 1)->data, "Liste mit '1'");
      //pushFront(2);
      // suche einen Wert, der nicht in der Liste enthalten ist
      rk1::Assert::AreEqual(0, int(findLinear(first, 2)), "Liste mit '1'");
    }
#endif // #ifdef SIMPLEUNITTESTS_H__ 


    // --------------- Aufgabe 1 e) ----------------------------

    void insertLastListnode(const T& data)  // first last Neuer Knoten n
                                            //  f0    l0
    { // Erzeugt einen neuen Listen-Knoten und fügt diesen nach last ein.
      // Last zeigt anschließend auf den letzten und first auf den
      // ersten Knoten der Liste.
      Listnode* n = newListnode(data, nullptr);        //                 n0 ->{d0,0}
      if (last == nullptr) first = n;                   //  n0
      else last->next = n;                      //        l0->{d,n0}
      last = n;                                 //        n0
                                                // Nachbedingung: Bezeichnet man den Wert von last vor
                                                //   dem Aufruf dieser Funktion mit l0, gilt
                                                //   Fall I,  l0==0: first==n && last==n
                                                //   Fall II, l0!=0: l0->next==n && last==n
    }

    void pushBack(const T& data)
    {
      insertLastListnode(data);
    }

#ifdef SIMPLEUNITTESTS_H__ 
    // Dieses Makro wird durch ein #include "SimpleUnitTests.h" definiert

    void Unittests_pushBack(int n)
    {
      rk1::Assert::WriteLine("test_pushBack" + std::to_string(n));
      clearList();
      insertLastListnode(5);
      rk1::Assert::AreEqual(first->data, 5, "pushBack 5 first");
      rk1::Assert::AreEqual(last->data, 5, "pushBack 5 last");
      rk1::Assert::AreEqual(Size(first), 1, "Size()==1");

      insertLastListnode(10);
      rk1::Assert::AreEqual(first->data, 5, "pushBack 10 first");
      rk1::Assert::AreEqual(last->data, 10, "pushBack 5 last");
      rk1::Assert::AreEqual(Size(first), 2, "Size()==2");

      // Viele Tests
      clearList();
      for (int i = 0; i < n; i++)
      {
        insertLastListnode(i);
        rk1::Assert::AreEqual(first->data, 0, "pushBack 0 first");
        rk1::Assert::AreEqual(last->data, i, "pushBack n last");
        rk1::Assert::AreEqual(Size(first), i + 1, "Size()==n");
      }
    }
#endif // #ifdef SIMPLEUNITTESTS_H__ 


    // --------------- Aufgabe 1 f) ----------------------------

    Listnode* findBefore(const T& data)
    {
      // Wird von insertSorted verwendet: Gibt einen Zeiger auf den ersten Knoten  
      // zurück, für den data<=tmp->data gilt
      Listnode* result = first;
      Listnode* tmp = first;
      while (tmp != nullptr && data > tmp->data)
      {
        result = tmp;
        tmp = tmp->next;
      }
      return result;
      // result==first: data>first->tmp - füge vor oder nach first ein
      // result!=first: data>result->tmp
    }

    void insertSorted(const T& data)
    {
      // Diese Fallunterscheidungen sind deshalb notwendig,
      // weil ein neuer Knoten anders eingefügt werden muss
      // - in eine leere Liste
      // - am Anfang einer nicht leeren Liste
      // - innerhalb einer nicht nicht leeren Liste
      // - am Ende einer nicht leeren Liste.
      if (first == nullptr)
      { // Die Liste ist leer. Deshalb das neue Element
        // an der Position first einhängen.
        first = newListnode(data, first);
        last = first;
      }
      else
      {
        // Die Liste ist nicht leer. Suche die Einfügeposition.
        Listnode* p = findBefore(data);
        if (p == first && data < p->data)
        {
          // Der neue Knoten kommt vor dem ersten Knoten.
          first = newListnode(data, first);
        }
        else if (p == last)
        { // Der neue Knoten wird der neue letzte Knoten.
          insertLastListnode(data);
        }
        else
        { // Der neue Knoten wird nach p eingefügt.
          // first und last werden nicht verändert.
          p->next = newListnode(data, p->next);
        }
      }
    }

    bool isSorted(Listnode* n)
    {
      bool result = true;
      Listnode* tmp = n;
      T old;
      if (tmp != nullptr)
        old = tmp->data;
      while (tmp != nullptr && result)
      {
        if (tmp->data < old)
          result = false;
        old = tmp->data;
        tmp = tmp->next;
      }
      return result;
    }

#ifdef SIMPLEUNITTESTS_H__ 
    // Dieses Makro wird durch ein #include "SimpleUnitTests.h" definiert

    void Unittests_isSorted()
    {
      rk1::Assert::WriteLine("test_isSorted");
      clearList();
      rk1::Assert::AreEqual(isSorted(first), true, "insertSorted: leere Liste");
      insertSorted(5);
      rk1::Assert::AreEqual(isSorted(first), true, "insertSorted: Liste mit einem Element");
      insertSorted(3);
      rk1::Assert::AreEqual(isSorted(first), true, "insertSorted: Liste mit einem Element");
      insertSorted(7);
      rk1::Assert::AreEqual(isSorted(first), true, "insertSorted: three element list not sorted");
    }

    void Unittests_insertSorted_random(int max)
    {
      rk1::Assert::WriteLine("test_insertSorted_random" + std::to_string(max));
      clearList();
      for (int i = 0; i < max; i++)
      {
        insertSorted(rand());
        rk1::Assert::AreEqual(isSorted(first), true, "insertSorted_random");
      }
      rk1::Assert::AreEqual(isSorted(first), true, std::to_string(max) + "element list sorted");
    }
#endif // #ifdef SIMPLEUNITTESTS_H__ 


    // --------------- Aufgabe 1 g) ----------------------------


    void eraseListnode(Listnode*& pn)
    { // entfernt *p aus der Liste 
      if (pn != nullptr)//falls pn==0, nichts machen oder Fehlermeldung
      {
        Listnode* tmp = pn;
        pn = pn->next;
        delete tmp;
      }
    }

    void clearList()
    { // löscht alle Knoten der Liste
      while (first != nullptr)
        eraseListnode(first);
      last = nullptr;
    }

    void test_clearList()
    {
      // siehe dazu die Ausführungen in Abschnitt ??? 7.4.3
    }


    // --------------- Aufgabe 1 h) ----------------------------
    /*
    Beziehung: Bei einer nicht leeren Liste zeigt first auf den
    ersten und last auf den letzten Knoten der Liste.
    Bei einer leeren Liste haben first und last den Wert 0.
    a) Das Ablaufprotokoll im Text legt nahe, dass diese Beziehung
    generell gilt.
    b) showList und findData verändern keine Knoten der Liste und
    zerstören deshalb auch diese Beziehung nicht.
    d) wie a)
    e) Die Konstruktion des Algorithmus lässt erwarten, dass diese
    Beziehung auch nach insertSorted noch gilt. Der Nachweis aus
    dem Quelltext dürfte aber etwas aufwendig werden.
    f) Falls nicht gerade der letzte Knoten gelöscht wird, wird diese
    Beziehung durch die Konstruktion des Algorithmus nahegelegt.
    Beim Löschen des letzten Knotens wird der bisherige vorletzte
    Knoten zum letzten Knoten.
    Falls ein Knoten den Vorgänger nicht wie bei einer doppelt
    verketteten Liste enthält, muss der zeitaufwendig bestimmt
    werden.
    g) first und last werden auf 0 gesetzt, und das entspricht
    einer leeren Liste.
    */


#ifdef SIMPLEUNITTESTS_H__ 
    // Dieses Makro wird durch ein #include "SimpleUnitTests.h" definiert

    void Unittests_LinkedList(int n)
    {
      rk1::Assert::Init("Unittests_LinkedList");
      Unittests_pushFront(n);
      // showList(tb, first);
      Unittests_findLinear();
      Unittests_pushBack(n);
      // showList(tb, first);
      Unittests_isSorted();
      Unittests_insertSorted_random(n);
      // showList(tb, first);
      rk1::Assert::Summary();
    }
#endif // #ifdef SIMPLEUNITTESTS_H__ 



    // --------------- Aufgabe 2 -------------------------------


    // --------------- Aufgabe 2 a) ----------------------------

    struct DllListnode {
      T data;            // Daten
      DllListnode* next;
      DllListnode* prev;
    };

    DllListnode* newDllListnode(const T& data,
      DllListnode* next, DllListnode* prev)
    { // Gibt einen Zeiger auf einen neuen Listenknoten 
      // {d0,nx0,p0} zurück, wobei d0, nx0 und p0 die 
      // Argumente für data, next und prev sind.
      DllListnode* n = new DllListnode;
      n->data = data;
      n->next = next;
      n->prev = prev;
      return n; // Nachbedingung: Der Rückgabewert zeigt auf 
    }     // einen neuen Knoten mit den Elementen {d0,nx0,p0}

    DllListnode* firstDll = 0;
    DllListnode* lastDll = 0;


    // --------------- Aufgabe 2 b) ----------------------------

    void pushFrontDll(const T& data)   // first last data  n       f0
    {                                  //   f0   l0   d0          ->{*,*,p1}
      if (firstDll == nullptr)
      { // erster Aufruf
        firstDll = newDllListnode(data, 0, 0);//n0             n0->{d0,0,0}
        lastDll = firstDll;                 //     n0
      }
      else
      { // ab dem zweiten Aufruf
        firstDll = newDllListnode(data,
          firstDll, nullptr);    //n0            n0->{d0,f0,0}
        firstDll->next->prev = firstDll;//                          ->{*,*,n0}
      }
      // Nachbedingung:
      // Fall I, f0==l0==0: first==last->{d0,0,0}
      // Fall II, l0!=0:    first==n, n->{d0,f0,0}, f0->{*,*,n}
    }
    void clearDllList(); // Prototyp, siehe Aufgabe 

    int Size(DllListnode* t)
    {
      int n = 0;
      while (t != nullptr)
      {
        n++;
        t = t->next;
      }
      return n;
    }

    int SizeRev(DllListnode* t)
    {
      int n = 0;
      while (t != nullptr)
      {
        n++;
        t = t->prev;
      }
      return n;
    }

#ifdef SIMPLEUNITTESTS_H__ 
    // Dieses Makro wird durch ein #include "SimpleUnitTests.h" definiert

    void Unittests_pushFrontDll(int n)
    {
      clearDllList();
      pushFrontDll(5);
      rk1::Assert::AreEqual(firstDll->data, 5, "pushFrontDll 5 first");
      rk1::Assert::AreEqual(lastDll->data, 5, "pushFrontDll 5 last");
      rk1::Assert::AreEqual(Size(firstDll), 1, "Dll Size()==1");
      rk1::Assert::AreEqual(SizeRev(lastDll), 1, "Dll SizeRev()==1");

      pushFrontDll(10);
      rk1::Assert::AreEqual(firstDll->data, 10, "pushFront Dll 10 first");
      rk1::Assert::AreEqual(lastDll->data, 5, "pushFront Dll 5 last");
      rk1::Assert::AreEqual(Size(firstDll), 2, "Dll Size()==2");
      rk1::Assert::AreEqual(SizeRev(lastDll), 2, "Dll SizeRev()==2");

      // Viele Tests
      clearDllList();
      for (int i = 0; i < n; i++)
      {
        pushFrontDll(i);
        rk1::Assert::AreEqual(firstDll->data, i, "pushFront 0 first");
        rk1::Assert::AreEqual(lastDll->data, 0, "pushFront n last");
        rk1::Assert::AreEqual(Size(firstDll), i + 1, "Size()==n");
        rk1::Assert::AreEqual(SizeRev(lastDll), i + 1, "SizeRev()==n");
      }
    }
#endif //#ifdef SIMPLEUNITTESTS_H__ 


    // --------------- Aufgabe 2 c) ----------------------------
    void showDllForw(TextBox^ tb, DllListnode* start)
    { // Gibt alle Daten der Liste ab der Position start aus
      tb->AppendText("Dll-Liste vorwärts:\r\n");
      DllListnode* tmp = start;
      while (tmp != nullptr)
      {
        tb->AppendText(tmp->data.ToString() + " ");
        tmp = tmp->next;
      }
      tb->AppendText("\r\n");
    }


    // --------------- Aufgabe 2 d) ----------------------------

    void showDllRev(TextBox^ tb, DllListnode* start)
    { // Gibt alle Daten der Liste ab der Position first aus
      tb->AppendText("Liste rückwärts:\r\n");
      DllListnode* tmp = start;
      while (tmp != nullptr)
      {
        tb->AppendText(tmp->data.ToString() + " ");
        tmp = tmp->prev;
      }
      tb->AppendText("\r\n");
    }

    // --------------- Aufgabe 2 e) ----------------------------
    /*
    Aus Platzgründen wurde firstDll durch fD, lastDll durch lD abgekürzt.
    Die Zeiger auf die neu erzeugten Knoten werden mit n1, n2 usw.
    bezeichnet.
    Die Werte im Ablaufprotokoll erhält man einfach durch Einsetzen der
    Nachbedingung von pushFrontDll.

    // fD  lD    n1          n2            n3
    fD=0                       0
    lD=0                           0
    pushFrontDll(d1)           n1  n1   ->{d1,0,0}
    pushFrontDll(d2)           n2       ->{d1,0,n2} ->{d2,n1,0}
    pushFrontDll(d3)           n3                   ->{d2,n1,n3}  ->{d3,n2,0}
    */

    // --------------- Aufgabe 2 f) ----------------------------

    void pushBackDll(const T& data)
    { // Erzeugt einen neuen Listen-Knoten und fügt diesen
      // nach last ein. Last zeigt anschließend auf den
      // letzten und first auf den ersten Knoten der Liste.
      if (lastDll == nullptr)
      {
        firstDll = newDllListnode(data, nullptr, nullptr);
        lastDll = firstDll;
      }
      else
      {
        DllListnode* n = newDllListnode(data, nullptr, lastDll);
        lastDll->next = n;
        lastDll = n;
      }
      // Nachbedingung:
      // Fall I, f0==l0==0: first==last->{d0,0,0}
      // Fall II, l0!=0:    last==n, n->{d0,0,l0}, l0->{*,n,*}
    }

#ifdef SIMPLEUNITTESTS_H__ 
    // Dieses Makro wird durch ein #include "SimpleUnitTests.h" definiert

    void Unittests_pushBackDll(int n)
    {
      clearDllList();
      pushBackDll(5);
      rk1::Assert::AreEqual(firstDll->data, 5, "pushBack 5 first");
      rk1::Assert::AreEqual(lastDll->data, 5, "pushBack 5 last");
      rk1::Assert::AreEqual(Size(firstDll), 1, "Size()==1");
      rk1::Assert::AreEqual(SizeRev(lastDll), 1, "SizeRev()==1");

      pushBackDll(10);
      rk1::Assert::AreEqual(firstDll->data, 5, "pushBack 10 first");
      rk1::Assert::AreEqual(lastDll->data, 10, "pushBack 10 last");
      rk1::Assert::AreEqual(Size(firstDll), 2, "Size()==2");
      rk1::Assert::AreEqual(SizeRev(lastDll), 2, "SizeRev()==2");

      // Viele Tests
      clearDllList();
      for (int i = 0; i < n; i++)
      {
        pushBackDll(i);
        rk1::Assert::AreEqual(firstDll->data, 0, "pushBack 0 first");
        rk1::Assert::AreEqual(lastDll->data, i, "pushBack n last");
        rk1::Assert::AreEqual(Size(firstDll), i + 1, "Size()==n");
        rk1::Assert::AreEqual(SizeRev(lastDll), i + 1, "SizeRev()==n");
      }
    }
#endif // #ifdef SIMPLEUNITTESTS_H__ 


    // --------------- Aufgabe 2 g) ----------------------------

    /*
    Aus Platzgründen wurde firstDll durch fD, lastDll durch lD abgekürzt.
    Die Zeiger auf die neu erzeugten Knoten werden mit n1, n2 usw.
    bezeichnet.
    Die Werte im Ablaufprotokoll erhält man einfach durch Einsetzen der
    Nachbedingung von pushBackDll.

    // fD  lD    n1          n2            n3
    fD=0                       0
    lD=0                           0
    pushBackDll(d1)            n1  n1   ->{d1,0,0}
    pushBackDll(d2)                n2   ->{d1,n2,0} ->{d2,0,n1}
    pushBackDll(d3)                n3               ->{d2,n3,n1}  ->{d3,0,n2}
    */


    // --------------- Aufgabe 2 h) ----------------------------

    DllListnode* findDllLinear(DllListnode* start, const T& x)
    {
      DllListnode* found = nullptr;
      DllListnode* tmp = start;
      while (tmp != nullptr && found == nullptr)
      {
        if (tmp->data == x) found = tmp;
        tmp = tmp->next;
      }
      return found;
    }

    void eraseDllListnode(DllListnode*& pn)
    { // entfernt *pn aus der Liste
      if (pn != nullptr) // für pn==nullptr nichts machen
      {
        DllListnode* tmp = pn;
        if (pn->next != nullptr && pn->prev != nullptr)
        { // pn zeigt weder auf den ersten noch den letzten Knoten
          // firstDll und lastDll bleiben unverändert   
          pn->prev->next = pn->next;
          pn->next->prev = pn->prev;
        }
        else if (pn->next == nullptr && pn->prev != nullptr)
        { // pn zeigt auf den letzten Knoten, hat aber davor noch Knoten
          // lastDll muss angepasst werden.
          pn->prev->next = nullptr;
          lastDll = pn->prev;
        }
        else if (pn->next != nullptr && pn->prev == nullptr)
        { // pn zeigt auf den ersten Knoten, hat aber danach noch Knoten
          // firstDll muss angepasst werden.
          firstDll = pn->next;
          firstDll->prev = nullptr;
        }
        else if (pn->next == nullptr && pn->prev == nullptr)
        { // pn zeigt auf den einzigen Knoten der Liste. 
          // firstDll muss angepasst werden.
          firstDll = nullptr;
          lastDll = nullptr;
        }
        delete tmp;
      }
    }

    void EraseDllListnodeClick(TextBox^ tb, int x)
    {
      DllListnode* p = findDllLinear(firstDll, x);
      if (p != nullptr)
      {
        eraseDllListnode(p);
        tb->AppendText(x.ToString() + ": gelöscht \r\n");
      }
      else
        tb->AppendText(x.ToString() + ": nicht gefunden \r\n");
    }

#ifdef SIMPLEUNITTESTS_H__ 
    // Dieses Makro wird durch ein #include "SimpleUnitTests.h" definiert

    void Unittests_eraseDllListnode(int max)
    {
      rk1::Assert::WriteLine("test_eraseDllListnode" + std::to_string(max));
      clearDllList();
      for (int i = 0; i < max; i++)
        pushFrontDll(i);
      // showDllForw(firstDll);
      // ??? raus Application::DoEvents();

      for (int i = 0; i < max / 2; i++)
      {
        int x = rand() % max;       // lösche zufällige Werte
                                    // die nächsten 3 Anweisungen stellen sicher, dass auch das erste,
                                    // letzte und ein zufällig
        if (i == 0) x = 0;          // lösche das erste Element
        else if (i == 1) x = max - 1; // lösche das letzte Element
        else if (i == 2) x = max;   // lösche ein nicht vorhandenes Element
                                    // rk1::Assert::WriteLine("lösche "+x.ToString());
        DllListnode* p = findDllLinear(firstDll, x);
        if (p != nullptr)
          eraseDllListnode(p);
        // showDllForw(tb, firstDll);
        // Application::DoEvents();
      }
      for (int i = 0; i < max; i++)
      { // lösche alle restlichen Elemente
        // rk1::Assert::WriteLine("lösche "+i.ToString());
        DllListnode* p = findDllLinear(firstDll, i);
        if (p != nullptr)
          eraseDllListnode(p);
        // showDllForw(tb, firstDll);
        // Application::DoEvents();
      }
    }
#endif // #ifdef SIMPLEUNITTESTS_H__ 

    // --------------- Aufgabe 2 i) ----------------------------

    void clearDllList()
    { // löscht alle Knoten der Liste
      while (firstDll != nullptr) eraseDllListnode(firstDll);
      firstDll = nullptr;
      lastDll = nullptr;
    }

    // --------------- Aufgabe 2 j) ----------------------------

#ifdef SIMPLEUNITTESTS_H__ 
  // Dieses Makro wird durch ein #include "SimpleUnitTests.h" definiert

    void Unittests_DllList(int n)
    {
      rk1::Assert::Init("Unittests_DllList");
      Unittests_pushFrontDll(n);
      Unittests_pushBackDll(n);
      Unittests_eraseDllListnode(n);
      rk1::Assert::Summary();
    }
#endif // #ifdef SIMPLEUNITTESTS_H__ 


    // --------------- Aufgabe 3 -------------------------------

    //$$$ InsertWordDoc Ind.rtf

  } // end of namespace N_LinkedList 


// *********** Kap. 7 Aufgabe 7.12 Binärbäume

  // --------------- Aufgabe 1 ----------------------------

  // --------------- Aufgabe 1 a) ----------------------------
  typedef int dataType;
  typedef int keyType;
  // oder
  // using dataType = int;
  // using keyType = int;

  struct Treenode {
    keyType key;         // die Schlüsselwerte
    dataType data;       // die Nutzdaten
    Treenode* left;
    Treenode* right;
  };

  Treenode* newTreenode(const keyType& key, const dataType& data,
    Treenode* left, Treenode* right)
  { // gibt einen Zeiger auf einen neuen Knoten zurück
    Treenode* tmp = new Treenode;
    tmp->key = key;
    tmp->data = data;
    tmp->left = left;
    tmp->right = right;
    return tmp;
  }


  // --------------- Aufgabe 1 b) ----------------------------

  void insertBinTreenode(Treenode*& root, const keyType& key, const dataType& data)
  {
    if (root == nullptr)
      root = newTreenode(key, data, nullptr, nullptr);
    else
    {
      Treenode* i = root;
      Treenode* p = nullptr;
      while (i != nullptr)
      {
        p = i;
        if (key < i->key) i = i->left;
        else i = i->right;
      }
      if (key < p->key)
        p->left = newTreenode(key, data, nullptr, nullptr);
      else
        p->right = newTreenode(key, data, nullptr, nullptr);
    }
  }

  Treenode* root = nullptr;

  void InsertClick(keyType x, dataType y)
  {
    insertBinTreenode(root, x, y);
  }


  // --------------- Aufgabe 1 c) ----------------------------

  Treenode* searchBinTree(const keyType& x)
  {
    Treenode* result = nullptr;
    if (root != nullptr)
    {
      Treenode* i = root;
      while (i != nullptr && i->key != x)
      {
        if (x < i->key) i = i->left;
        else i = i->right;
      }
      if (i != nullptr && i->key == x)
        result = i;
    }
    return result;
  }

  bool ValueToKey(const keyType& Key, dataType& Value)
  {
    Treenode* p = searchBinTree(Key);
    if (p == nullptr)
      return false;
    else
    {
      Value = p->data;
      return true;
    }
  }


#ifdef SIMPLEUNITTESTS_H__ 
  // Dieses Makro wird durch ein #include "SimpleUnitTests.h" definiert

  void Unittests_BinTree()
  { // Einige einfache Testfälle 
    root = nullptr;
    dataType Value;
    rk1::Assert::Init("Unittests_BinTree");

    // 1. Suche im leeren Baum sollte funktionieren, und
    //    insbesondere nicht zu einem Programmabsturz führen
    rk1::Assert::AreEqual(ValueToKey(1, Value), false, "leerer Baum");

    // 2. Ein Element einfügen und finden:
    insertBinTreenode(root, 1, 2);
    rk1::Assert::AreEqual(ValueToKey(1, Value), true, "Baum mit '1'");
    rk1::Assert::AreEqual(Value, 2, "Baum mit '1'");

    // 2. Zwei Elemente einfügen und finden:
    insertBinTreenode(root, 2, 3);
    rk1::Assert::AreEqual(ValueToKey(1, Value), true, "Baum mit '1'");
    rk1::Assert::AreEqual(Value, 2, "Baum mit '1'");
    rk1::Assert::AreEqual(ValueToKey(2, Value), true, "Baum mit '1' und '2'");
    rk1::Assert::AreEqual(Value, 3, "Baum mit '1' und '2'");
    rk1::Assert::Summary();
  }
#endif // #ifdef SIMPLEUNITTESTS_H__ 


  // d)
  void insertBinTreenode_rec(Treenode*& node,
    const keyType& key, const dataType& data)
  {
    if (node == nullptr)
      node = newTreenode(key, data, nullptr, nullptr);
    else if (key < node->key)
      insertBinTreenode_rec(node->left, key, data);
    else
      insertBinTreenode_rec(node->right, key, data);
  }

  // e)
  void processTreenode(TextBox^ tb, Treenode* n)
  {
    tb->AppendText("key:" + n->key + " data:" + n->data + "\r\n");
  };

  void traverseTree_rec(TextBox^ tb, Treenode* n)
  {
    if (n != nullptr)
    {
      traverseTree_rec(tb, n->left);
      processTreenode(tb, n);
      traverseTree_rec(tb, n->right);
    }
  }

  void TraverseClick(TextBox^ tb)
  {
    traverseTree_rec(tb, root);
  }

  // f)
  Treenode* searchBinTree_rec(Treenode* tn, const dataType& x)
  {
    if (tn == nullptr)
      return nullptr;
    else if (x == tn->key)
      return tn;
    else if (x < tn->key)
      return searchBinTree_rec(tn->left, x);
    else
      return searchBinTree_rec(tn->right, x);
  }

  bool ValueToKey_rec(keyType Key, dataType& Value)
  {
    Treenode* p = searchBinTree_rec(root, Key);
    if (p == nullptr)
      return false;
    else
    {
      Value = p->data;
      return true;
    }
  }

#ifdef SIMPLEUNITTESTS_H__ 
  // Dieses Makro wird durch ein #include "SimpleUnitTests.h" definiert

  void Unittests_BinTree_recursive()  // ??? raus TextBox^ tb)
  { // Einige Testfälle 
    rk1::Assert::Init("Unittests_BinTree_recursive");

    root = nullptr;
    dataType Value;

    // 1. Suche im leeren Baum sollte funktionieren,
    //    insbesondere nicht zu einem Programmabsturz führen
    rk1::Assert::AreEqual((int)searchBinTree_rec(root, 1), 0, "searchBinTree: leerer Baum");
    rk1::Assert::AreEqual(ValueToKey_rec(1, Value), false, "ValueToKey_rec: leerer Baum");

    // 2. Suche in einem Baum mit einem Element:
    insertBinTreenode_rec(root, 1, 10);
    // rk1::Assert::AreNotEqual((int)searchBinTree_rec(root, 1), 1, "searchBinTree: 1 Element, gefunden");
    rk1::Assert::AreEqual((int)searchBinTree_rec(root, 2), 0, "searchBinTree: 1 Element, Knoten mit key 2 nicht gefunden");

    rk1::Assert::AreEqual(ValueToKey_rec(1, Value), true, "Baum mit key '1', Knoten mit key 1 gefunden");
    rk1::Assert::AreEqual(Value == 10, true, "Baum mit key '1', Konten mit Wert 10 gefunden");

    // 3. Suche in einem Baum mit 3 Elementen:
    insertBinTreenode_rec(root, 2, 20);
    rk1::Assert::AreEqual((int)searchBinTree_rec(root, 3), 0, "searchBinTree: 2 Elemente, Knoten mit key 3 nicht gefunden");

    rk1::Assert::AreEqual(ValueToKey_rec(2, Value), true, "Baum mit 2 Elementen, Knoten mit key 2 gefunden");
    rk1::Assert::AreEqual(Value == 20, true, "Baum mit 2 Elementen, Konten mit Wert 20 gefunden");

    const int MaxTests = 10;
    for (int i = 3; i < MaxTests; i++)
    {
      int x = i;
      if (i < 50) x = -i;
      insertBinTreenode_rec(root, x, 10 * x);
    }

    for (int i = 3; i < MaxTests; i++)
    {
      int x = i;
      if (i < 50) x = -i;

      rk1::Assert::AreEqual(ValueToKey_rec(x, Value), true, "Baum mit vielen Elementen, Knoten gefunden");
      rk1::Assert::AreEqual(Value == 10 * x, true, "Baum mit vielen Elementen, Konten mit Wert gefunden");
    }
    rk1::Assert::Summary();
  }

#endif // #ifdef SIMPLEUNITTESTS_H__ 





#ifdef SIMPLEUNITTESTS_H__ 
  // Dieses Makro wird durch ein #include "SimpleUnitTests.h" definiert

  void Unittests_Kap_7_Zeiger()
  {
    int n = 100;
    rk1::Assert::Init("Unittests Zeiger");
    Unittests_Leerzeichen();
    N_LinkedList::Unittests_LinkedList(n);
    N_LinkedList::Unittests_DllList(n);
    Unittests_BinTree_recursive();
    rk1::Assert::Summary();
  }
#endif // #ifdef SIMPLEUNITTESTS_H__ 

} // end of namespace N_Loesungen_Kap_Zeiger 
