﻿
// *********** Kap. 9 Aufgabe 9.1.5 Klassen
#include <fstream>

namespace N_Loesungen_Klassen
{
  using namespace System::Windows::Forms;



  // --------------- Aufgabe 1 -------------------------------

  /* Ein Konstruktor hat die Aufgabe, alle Datenelemente einer Klasse so zu
     initialisieren, dass sie beim Aufruf einer beliebigen Elementfunktion
     in einem definierten Zustand sind.

     In einem Destruktor sollen alle Ressourcen wieder freigegeben werden,
     die in einem Konstruktor reserviert wurden.
  */
  class C {
    int n, max;
    int* a;
  public:
    C()
    {
      max = 100;
      a = new int[max];
    } // Fehler: n wird nicht initialisiert, aber in show_data verwendet
      //         Falls n initialisiert wird, muss auch a[0] ... a[n]
      //         initialisiert werden.
    C(int i)
    {
      n = 1;
      a = new int[100];
      a[0] = i;
    }; // Fehler: max wird nicht initialisiert, aber in add_data verwendet

    C(int i, int j)
    {
      n = 2;
      max = 100;
      a = new int[100];
      a[1] = i;
      a[2] = j;
    }; // Fehler: max und a[0] werden nicht initialisiert

    void add_data(int d)
    {
      if (n < max - 1)
      {
        n++;
        a[n] = d;
      }
    }
    void show_data(TextBox^ tb)
    {
      for (int i = 0; i < n; i++)
        tb->AppendText(a[i].ToString() + "\r\n");
    }

    // Der Destruktor mit delete[] a fehlt
  };


  // --------------- Aufgabe 2 -------------------------------

  // a)
  class C1 {
    int x, y, z;
  public:
    C1(int x_ = 0, int y_ = 0, int z_ = 0)
    {
      x = x_; y = y_; z = z_;
    }
  }; // Da die Elemente nur initialisiert und keine Ressourcen reserviert
     // werden, ist kein Destruktor notwendig

  // b)
  class C2 {
    int* x;
  public:
    C2(int n)
    {
      x = new int[n];
    }
  }; // Destruktor mit delete[] x ist notwendig

  // c)
  class C3 { // #include <fstream>
    std::ifstream f; // eine Klasse der C++-Standardbibliothek
  public:
    C3(const char* FileName)
    {
      f.open(FileName);
    }
  }; // Da für die Klasse C3 kein expliziter Konstruktor definiert wird,
     // erzeugt der Compiler einen. Dieser ruft die Destruktoren aller
     // Elemente von C3 auf, also auch den von f. Da ifstream eine Klasse
     // der Standardbibliothek von C++ ist und alle Klassen dieser Bibliothek
     // Destruktoren haben, die sich anständig verhalten und alle ihre
     // Ressourcen wieder freigeben, ist für C3 kein Destruktor notwendig.
     // Ein Destruktor mit close ist aber auch kein Fehler.


  // --------------- Aufgabe 3 -------------------------------

  const double pi = 3.14159265358979323846;

  // a)
  class Kreis {
    double r;
  public:
    Kreis(const double& Radius = 1)
    {
      r = Radius;
    }

    double Radius()
    {
      return r;
    }

    void setzeRadius(const double& Radius)
    {
      r = Radius;
    }
    // d)
    double Flaeche()
    {
      return r*r*pi;
    }

    double Umfang()
    {
      return 2 * r*pi;
    }

    std::string toStr()
    {
      return "Kreis mit Radius " + std::to_string(r);
    }
  };

  // b)
  class Quadrat {  // Elementfunktionen außerhalb definieren
    double a;
  public:
    Quadrat(const double& Seitenlaenge = 1);

    double Seitenlaenge();
    void setzeSeitenlaenge(const double& Seitenlaenge);
    double Flaeche();
    double Umfang();
    std::string toStr();
  };

  Quadrat::Quadrat(const double& Seitenlaenge)
  {
    a = Seitenlaenge;
  };

  double Quadrat::Seitenlaenge()
  {
    return a;
  }

  void Quadrat::setzeSeitenlaenge(const double& Seitenlaenge)
  {
    a = Seitenlaenge;
  }

  // d)
  double Quadrat::Flaeche()
  {
    return a*a;
  }

  double Quadrat::Umfang()
  {
    return 4 * a;
  }

  std::string Quadrat::toStr()
  {
    return "Quadrat mit Seitenlänge " + std::to_string(a);
  }


  // c)
  class Rechteck {
    double a, b; // Seitenlängen
  public:
    Rechteck(const double& a_, const double& b_)
    {
      a = a_;
      b = b_;
    };

    double Seitenlaenge_a()
    {
      return a;
    }

    double Seitenlaenge_b()
    {
      return b;
    }

    void setzeSeitenlaengen(const double& a_, const double& b_)
    {
      a = a_;
      b = b_;
    }

    // d)
    double Flaeche()
    {
      return a*b;
    }

    double Umfang()
    {
      return 2 * (a + b);
    }

    std::string toStr()
    {
      return "Rechteck mit a=" + std::to_string(a) + " b=" + std::to_string(b);
    }
  };

  // e)
#include "C2DPunkt.h"


// e)
  void test_Figuren(TextBox^ tb)
  {
    // ??? noch unvollständig
    // ??? noch Unittests 
    Kreis k1(10);
    tb->AppendText(rk1::to_String(k1.toStr()) + "\r\n");
    tb->AppendText("Umfang=" + k1.Umfang().ToString("f2"));
    tb->AppendText(" Flaeche=" + k1.Flaeche().ToString("f2") + "\r\n");
    Kreis* pk = new Kreis(10);
    tb->AppendText(rk1::to_String(pk->toStr()) + "\r\n");
    tb->AppendText("Umfang=" + pk->Umfang().ToString("f2"));
    tb->AppendText(" Flaeche=" + pk->Flaeche().ToString("f2") + "\r\n");

    Quadrat q(10);
    tb->AppendText(rk1::to_String(q.toStr()) + "\r\n");
    tb->AppendText("Umfang=" + q.Umfang().ToString());
    tb->AppendText(" Flaeche=" + q.Flaeche().ToString() + "\r\n");
    Quadrat* pq = new Quadrat(10);
    tb->AppendText(rk1::to_String(pq->toStr()) + "\r\n");
    tb->AppendText("Umfang=" + pq->Umfang().ToString());
    tb->AppendText(" Flaeche=" + pq->Flaeche().ToString() + "\r\n");

    Rechteck r(10, 20);
    tb->AppendText(rk1::to_String(r.toStr()) + "\r\n");
    tb->AppendText("Umfang=" + r.Umfang().ToString());
    tb->AppendText(" Flaeche=" + r.Flaeche().ToString() + "\r\n");
    Rechteck* pr = new Rechteck(7.5, 12.5);
    tb->AppendText(rk1::to_String(pr->toStr()) + "\r\n");
    tb->AppendText("Umfang=" + pr->Umfang().ToString());
    tb->AppendText(" Flaeche=" + pr->Flaeche().ToString() + "\r\n");
  }


  // --------------- Aufgabe 4 -------------------------------

  namespace N_Aufgabe_4 {
    void display(std::string s, int i = -1)
    {
      if (i >= 0) s = s + std::to_string(i);
      System::Diagnostics::Trace::WriteLine(rk1::to_String(s));
      // gibt s im Ausgabe-Fenster (Ansicht|Ausgabe) aus
    }

    class C {
      int x;
    public:
      C(int x_ = 0)
      { // Beim Aufruf ohne Argument ein Standard-
        x = x_;                             // konstruktor
        display("  Konstruktor: ", x);
      }
      ~C()
      {
        display("  Destruktor: ", x);
      }
    };

    void f1(C c)
    {
      display("  in f1(): Wertparameter");
    };

    void f2(const C& c)
    {
      display("  in f2(): Referenzparameter");
    };

    C f3(int i)
    {
      display("  in f3(): return-Wert");
      return C(i);
    };

    void test1()
    {
      C x(1);
      C* z = new C(2);
      display("vor x=C(3)");
      x = C(3);
      display("vor f1(4)");
      f1(4);
      display("vor f2(x)");
      f2(x);
      display("vor f3(5)");
      x = f3(5);
      delete z;
      display("Ende von test()");
    }

    /*
    Die Anweisungen der Funktion test1 erzeugen die eingerückten
    Meldungen:

    C x(1);
      Konstruktor: 1
    C* z=new C(2);
      Konstruktor: 2
    display("vor x=C(3)");
      vor x=C(3)
    x=C(3);
      Konstruktor: 3
      Destruktor: 3
    display("vor f1(4)");
      vor f1(4)
    f1(4);
      Konstruktor: 4
      in f1(): Wertparameter
      Destruktor: 4
    display("vor f2(x)");
      vor f2(x)
    f2(x);
      in f2(): Referenzparameter
    display("vor f3(5)");
      vor f3(5)
    x=f3(5);
      in f3(): return-Wert
      Konstruktor: 5
      Destruktor: 5
    delete z;
      Destruktor: 2
    display("Ende von test()");
      Ende von test()
    }
      Destruktor: 5

    */

    void test2()
    {
      display("vor p1");
      C* p1 = new C[2];
      delete[] p1;

      display("vor p2");
      C* p2 = new C[2];
      delete p2;

      display("vor p3");
      C* p3 = new C;
      delete[] p3;

      display("vor p4");
      C* p4 = new C(4);
      delete[] p4;

      display("Ende von test()");
    }
    /*
    b)    Die Funktion test2 erzeugt unter anderem die folgende Ausgabe:
    vor p1
    Konstruktor: 0
    Konstruktor: 0
    Destruktor: 0
    Destruktor: 0
    vor p2
    Konstruktor: 0
    Konstruktor: 0
    Destruktor: 0
        Die Anweisungen nach display(„vor p3") sind falsch, da ein mit new[] reservierter Speicherbereich mit delete (und nicht mit delete[]) wieder freigegeben wird, bzw. ein mit new reservierter Speicherbereich mit delete[] (und nicht mit delete).
        Gibt man bei dem Ausdruck nach new runde Klammern an, sind die Werte in den Klammern Argumente für den Konstruktor und nicht etwa Arraygrenzen. Deswegen muss nach diesem Aufruf delete und nicht delete[] aufgerufen werden.
    */

  } // end of namespace N_Aufgabe4


  // --------------- Aufgabe 5 -------------------------------

  class MeinString {
    char* s; // Zeiger auf nullterminierten String
    int n;   // Länge des Strings
  public:
    MeinString(const char* p)  // 1
    { // p muss auf einen nullterminierten String zeigen
      n = strlen(p);
      s = new char[n + 1];
#pragma warning( push )  
#pragma warning(disable : 4996) //_CRT_SECURE_NO_WARNINGS
      strcpy(s, p);
#pragma warning( pop )   
    };
    MeinString(char c)         // 2
    { // kann auch mit einem int-Argument aufgerufen werden
      n = 1;
      s = new char[n + 1];
      *s = c;
      *(s + 1) = '\0';
    };

    const char* c_str()
    { // 'strcpy(s1.c_str(),"abc")' geht ohne "const", aber nicht mit.
      // Da ein solcher Aufruf die Klasseninvariante zerstören kann,
      // ist hier const notwendig.
      return s;
    }
  };

  void test_6(TextBox^ tb) // raus ???
  {
    MeinString s("abc");
    tb->AppendText((strlen(s.c_str())).ToString());
  }

  // --------------- Aufgabe 6 -------------------------------

  namespace N_Aufgabe_6 { // namespace, um Namenskonflikte 
                          //            mit Aufgabe 5 zu vermeiden
    class C {
      typedef int T;
      T x;
    public:
      C(T x_) { x = x_; }

      T& data() // T data() wäre zu langsam
      {
        return x;
      }
    };

    void test()
    {
      C c(1);
      c.data() = 17;
      /*
         Da der Funktionswert von data ein Referenztyp ist, kann man mit dieser
         public Funktion den Wert des private Elements x verändern und damit die
         Konsistenzbedingungen verletzen.

         Diesen vermutlich nicht beabsichtigten Effekt kann man verhindern,
         indem man den Rückgabetyp der Funktion data als konstanten
         Referenzparameter definiert:

           const T& data()
           {
           return x;
           }

         Mit einer Elementfunktion, die eine Referenz zurückgibt, können auch
         Datenelemente von Objekten angesprochen werden, die nicht mehr
         existieren.
      */
    }




    // --------------- Aufgabe 7 -------------------------------

    //     Mit diesem Trick lassen sich alle Vorteile des Zugriffsrechts
    //     private zunichte machen.

    //     #undef private ist hier unpassend.

    //     Wenn eine Klasse aber nicht alle Elementfunktionen zur Verfügung
    //     stellt, die ein Anwender benötigt (also nicht vollständig ist),
    //     kann dieser Trick aber doch eine gewisse Berechtigung haben.

  } // end of namespace N_Aufgabe_8

#ifdef SIMPLEUNITTESTS_H__ 
  // Dieses Makro wird durch ein #include "SimpleUnitTests.h" definiert

  void Unittests_Klassen()
  {
    rk1::Assert::Init("Unittests_Klassen");
    Unittests_C2DPunkt();
    rk1::Assert::Summary();
  }
#endif // #ifdef SIMPLEUNITTESTS_H__ 


} // end of namespace N_Loesungen_Klassen 
