﻿// *********** Kap. 9 Aufgabe 9.2.2 Elementinitialisierer


#include <string>
#include <functional>

namespace N_Loesungen_Klassen_als_Datentypen
{
  using System::Windows::Forms::TextBox;

  // --------------- Aufgabe 1 -------------------------------

  namespace N_Elementinit {
    class E {
    public:
      E()
      {
        System::Diagnostics::Trace::WriteLine("Standardkonstruktor");
      }

      E(int)
      {
        System::Diagnostics::Trace::WriteLine("int-Konstruktor");
      }

    };

    class C1 {
      E e1, e2;
    public:
      C1() { }
      C1(int i) :e1(i) { }
      C1(int i, int j) :e1(i), e2(j) { }
    };

    void Konstruktoren()
    {
      // Die folgenden Definitionen erzeugen die Meldungen:
      C1 c0;      // Standardkonstruktor
      C1 c1(1);   // Standardkonstruktor
      // int-Konstruktor
      C1 c2(1, 2); // Standardkonstruktor
      // int-Konstruktor
      // int-Konstruktor

      /* Wenn der Datentyp von E keine Klasse wäre, hätte
      - e1 und e2 in c0 einen undefinierten Wert
      - e2 in c1 einen undefinierten Wert und e1 den Wert 1
      - e1 und e2 in c2 die Werte 1 und 2
      */

    }


    // --------------- Aufgabe 2 -------------------------------

    // Siehe C2DPunkt.h

    /*
    Ersetze die Konstruktoren

      Kreis(const double& Radius)
      {
      r=Radius;
      }

      Quadrat(const double& Seitenlaenge)
      {
      a=Seitenlaenge;
      };

      Rechteck(const double& a_, const double& b_)
      {
      a=a_;
      b=b_;
      };

    durch

      Kreis(const double& Radius):r(Radius) {}
      Quadrat(const double& Seitenlaenge):a(Seitenlaenge){};
      Rechteck(const double& a_, const double& b_):a(a_), b(b_){};

    */

    // --------------- Aufgabe 3 -------------------------------

    // #include "C2DPunkt.h"
    using N_Loesungen_Klassen::C2DPunkt; // aus ??? Loesung_Kap_9_OO_1.h
    // Diese Aufgabe zeigt insbesondere, wie Klassen als Bausteine in
    // weiteren Klassen verwendet werden.

    class C2DKreis {
      double r;
      C2DPunkt pos;
    public:
      C2DKreis(const double& Radius = 1, const double& x = 0, const double& y = 0) :
        r(Radius), pos(x, y) { } // Reihenfolge der Deklaration

      C2DKreis(const double& Radius, const C2DPunkt& pos_) :
        r(Radius), pos(pos_) { } // Reihenfolge der Deklaration
        /*
        Alternativ zu diesen beiden Konstruktoren sind auch die folgenden
        möglich. Beim zweiten dieser Konstruktoren wird ein temporäres Objekt
        als Default-Argument verwendet:

        C2DKreis(const double& Radius, const double& x, const double& y):
        r(Radius), Position(x,y) { } // Reihenfolge der Deklaration

        C2DKreis(const double& Radius=0, C2DPunkt pos=C2DPunkt(0,0)):
        r(Radius), Position(pos) { } // Reihenfolge der Deklaration
        */

        // neu: 

      void setzePosition(const C2DPunkt& p)
      {
        pos = p;
      }

      C2DPunkt Position()
      {
        return pos;
      }

      void setzeRadius(const double& r_)
      {
        r = r_;
      }

      double Radius()
      {
        return r;
      }

      std::string toStr()
      {
        return "Kreis mit Radius " + std::to_string(r) + " in " + pos.toStr();
      }
    };

    void testKreis(TextBox^ tb)
    {
      C2DKreis k1(1, 2, 3);
      tb->AppendText(rk1::to_String(k1.toStr()));
      C2DKreis k2(4);
      tb->AppendText(rk1::to_String(k2.toStr()));
      C2DKreis k3;
      tb->AppendText(rk1::to_String(k3.toStr()));

      C2DPunkt p(6, 7);
      C2DKreis k5(5, p);
      tb->AppendText(rk1::to_String(k5.toStr()));
      C2DKreis k6(8, C2DPunkt(9, 10));
      tb->AppendText(rk1::to_String(k6.toStr()));
      double x = k6.Position().X();
    }
    // --------------- Aufgabe 4 -------------------------------

    class Rechteck1 {
      C2DPunkt LinksOben; // Eckpunkt links oben
      double a, b; // Seitenlängen
    public:
      Rechteck1(C2DPunkt Mittelpunkt, double a_, double b_) :a(a_), b(b_),
        LinksOben(Mittelpunkt.X() - a / 2, Mittelpunkt.Y() - b / 2) { }

      std::string toStr()
      {
        return "Links oben: " + LinksOben.toStr();
      }


      // Die Elemente eines Objekts werden in der Reihenfolge initialisiert, 
      // in der sie in der Klasse aufgeführt werden. Deshalb wird zuerst 
      // LinksOben initialisiert, und dann erst a und b. Linksoben verwendet 
      // dazu die bisher nicht initialisierten Werte a und b.

      // Wenn man die Elemente in einer Initialisiererliste in der Reihenfolge 
      // ihrer Definition in der Klasse aufführt, ist die Gefahr eines solchen 
      // Missverständnisses geringer.

      // Die fehlerhafte Initialisierung in der Klasse Rechteck1 vermeidet 
      // man, indem man die Reihenfolge der Datenelemente ändert.

    };

    class Rechteck2 { // Reihenfolge der Deklarationen vertauscht
      double a, b; // Seitenlängen
      C2DPunkt LinksOben; // Eckpunkt links oben
    public:
      Rechteck2(C2DPunkt Mittelpunkt, double a_, double b_) :
        a(a_), b(b_), LinksOben(Mittelpunkt.X() - a / 2, Mittelpunkt.Y() - b / 2) { }

      std::string toStr()
      {
        return LinksOben.toStr(); // ??? .X().ToString() + "|" + LinksOben.Y().ToString();
      }
    };

    void Rechteck1_(TextBox^ tb)
    {
      C2DPunkt mp(100, 100);
      Rechteck1 r1(mp, 10, 20);
      tb->AppendText(rk1::to_String(r1.toStr()));
      Rechteck2 r2(mp, 10, 20);
      tb->AppendText(rk1::to_String(r2.toStr()));
    }

    // --------------- Aufgabe 5 -------------------------------

  // Da dieser Standardkonstruktor die anderen Konstruktoren ergänzen soll, 
  // kann im Destruktor nicht mehr entschieden werden, ob der reservierte 
  // Speicher mit delete oder mit delete[] freigegeben werden soll.

  } // end of namespace N_9_2_2 {


// *********** Kap. 9 Aufgabe 9.2.5 Überladene Operatoren
// --------------- Aufgabe 1 -------------------------------

/*
Würde man diese Operatoren als Elementfunktionen einer Klasse C
definieren, müsste der linke Operand beim Aufruf das Objekt der
Klasse sein:

c<<f // Im Gegensatz zur üblichen Konvention f<<c
c>>f // Im Gegensatz zur üblichen Konvention f>>c

Das widerspricht aber der üblichen Schreibweise mit den Operatoren
<< und >>, bei der das Stream-Objekt immer links vom Operator steht.
Deswegen sollte man die Operatoren << und >> immer durch eine globale
Funktion überladen.
*/


// --------------- Aufgabe 2 -------------------------------

  class Bruch {
    int z, n; // z: Zähler, n: Nenner
  public:
    Bruch(int z_, int n_ = 1) :z(z_), n(n_)
    {
      // Nenner == 0 abfangen 
      if (n == 0) n = 1; // oder Exception auslösen
    };

    Bruch operator+=(const Bruch& q) const
    {
      return Bruch(z*q.n + q.z*n, n*q.n);
    }

    // a)
    friend Bruch operator-(const Bruch& p, const Bruch& q);
    std::string toStr() const
    {
      return std::to_string(z) + "/" + std::to_string(n);
    }

    bool equal(const Bruch& q)
    {
      return z*q.n == q.z*n;
    }
  };

  // a)
  Bruch operator-(const Bruch& p, const Bruch& q)
  {
    return Bruch(p.z*q.n - q.z*p.n, p.n*q.n);
  };

  // b)
  Bruch operator+(const Bruch& p, const Bruch& q)
  {
    return Bruch(p) += q;
    // return p+=q; // geht nicht wegen const
  };

#ifdef SIMPLEUNITTESTS_H__ 
  // Dieses Makro wird durch ein #include "SimpleUnitTests.h" definiert
  void assertEqual(Bruch p, const Bruch& q)
  {
    rk1::Assert::AreEqual(p.equal(q), true, "Bruch p=" + p.toStr() + " == q=" + q.toStr());
  }

  void Unittests_Bruch(int n)
  {
    rk1::Assert::Init("Unittests_Bruch");

    Bruch p(1, n); // 1/n
    Bruch s(0, 1); // 0
    for (int i = 0; i < n; i++)
      s = s + p;
    assertEqual(s, Bruch(1, 1)); // n*(1/n)==1/1
    Bruch q(1, 2);
    Bruch d = s - q;
    assertEqual(d, q);   // 1/1-1/2==1/2
    rk1::Assert::Summary();
  }
#endif


// *********** Kap. 9 Aufgabe 9.2.7 Kopierkonstruktor und Zuweisungsoperator

#include <vector>

  namespace N_KopKonst_ZuwOp {

    // --------------- Aufgabe 1 -------------------------------

    // a) 
    //   Nicht notwendig, da alle Klassen keine Zeiger auf dynamisch 
    //   reservierten Speicher enthalten.
    // b)
    //   Notwendig, da alle Klassen Zeiger auf dynamisch reservierten
    //   Speicher enthalten.
    // c) 
    //    Mit string anstelle char* ist keine dieser Funktionen notwendig.
    // d) 
    //    Wenn man alles richtig macht, ist es kein Fehler, diese Funktionen
    //    selbst zu definieren, obwohl sie auch vom Compiler erzeugt werden. 
    //    Allerdings haben die selbst definierten Funktionen keine Vorteile 
    //    gegenüber den vom Compiler erzeugten. Sie haben aber den Nachteil, 
    //    dass sie beim Hinzufügen oder Entfernen von Datenelementen angepasst
    //    werden müssen, was leicht vergessen werden kann. 
    // e) 
    //    Am einfachsten ist es, wenn man alle Klassen ohne Zeiger definieren kann.
    //    Dann spart man die Notwendigkeit, diese Funktionen zu schreiben, und 
    //    außerdem das Risiko von Fehlern, falls man das vergisst. 

    // Diese Beispiele zeigen insbesondere, dass man sich viel Arbeit 
    // sparen kann, wenn man Stringklassen anstelle von nullterminierten 
    // Strings verwendet."

    // --------------- Aufgabe 2 -------------------------------

      // a)
    class MeinString {
      char* s; // Zeiger auf nullterminierten String
      int n; // Länge des Strings
    public:
      MeinString(const char* p) // 1
      {
        n = strlen(p);
        s = new char[n + 1];
#pragma warning( push )  
#pragma warning(disable : 4996) //_CRT_SECURE_NO_WARNINGS
        strcpy(s, p);
#pragma warning( pop )   
      };
      ~MeinString() { delete[] s; }
    };

    namespace N_Meinstring_smart_pointer
    {
      class MeinString {
        char* s; // Zeiger auf nullterminierten String
        int n; // Länge des Strings
      public:
        MeinString(const char* p) // 1
        {
          n = strlen(p);
          s = new char[n + 1];
#pragma warning( push )  
#pragma warning(disable : 4996) //_CRT_SECURE_NO_WARNINGS
          strcpy(s, p);
#pragma warning( pop )   
        };
        
        MeinString(const MeinString& x) // Kopierkonstruktor
        {
          n = x.n;            // 1
          s = new char[n + 1];  // 2
#pragma warning( push )  
#pragma warning(disable : 4996) //_CRT_SECURE_NO_WARNINGS
          strcpy(s, x.s);    // 3
#pragma warning( pop )   
        };//dieser Konstruktor stellt die Klasseninvariante her

        MeinString& operator=(const MeinString& x)
        {
          if (this != &x)        // a
          {
            delete[] s;          // b
            n = x.n;             // 1
            s = new char[n + 1]; // 2
#pragma warning( push )  
#pragma warning(disable : 4996) //_CRT_SECURE_NO_WARNINGS
            strcpy(s, x.s);      // 3
#pragma warning( pop )   
          }
          return *this;            // c
        };
        ~MeinString() { delete[] s; }
      };

      class MeinString_smart_pointer {
        // std::shared_ptr<char> s = std::make_shared<char>();
        // char* s; // Zeiger auf nullterminierten String
        std::shared_ptr<char[]> s{ new char[1]{'\0'} };
        int n; // Länge des Strings
      public:
        MeinString_smart_pointer(const char* p) // 1
        {
          n = strlen(p);
          s.reset(new char[n + 1]);
#pragma warning( push )  
#pragma warning(disable : 4996) //_CRT_SECURE_NO_WARNINGS
          strcpy(s.get(), p);
#pragma warning( pop )   
        };
        // ~MeinString() { delete[] s; } nicht notwendig
      };
    }
    void testOhneZuweisungsOp()
    {
      {
        using namespace N_Meinstring_smart_pointer;
        MeinString_smart_pointer  s1("abc"), s2(s1), s3("31234");
        s1 = s3;
      }
      MeinString s1("abc"), s2("31234");
      s1 = s2;
      // MeinString s3(s1);
    }

    // a), b)
    // Da MeinString keinen explizit definierten Zuweisungsoperator hat, erzeugt
    // der Compiler einen, der eine flache Kopie durchführt. Beim Verlassen der 
    // Funktion wird dann der Destruktor für s2 zweimal aufgerufen. Das führt zu
    // einem doppelten Aufruf von delete für den zugehörigen Zeiger, und das hat
    // einen Programmabbruch zur Folge.

    // b) 
    // Ergänzt man MeinString um einen Zuweisungsoperator
    /*
    class MeinString {
      char* s;
      int n; // Länge des Strings
    public:
      // ...
      MeinString& operator=(const MeinString& x)
      {
      if (this != &x)        // a
      {
        delete[] s;          // b
        n = x.n;             // 1
        s = new char[n + 1]; // 2
        strcpy(s, x.s);      // 3
      }
      return *this;            // c
      };
    };
    */
    // führt der Aufruf von testOhneZuweisungsOp nicht mehr zu einem
    // Programmabbruch.

    // c)
    // Verwendet man MeinString so, dass ein Kopierkonstruktor 
    // aufgerufen wird, erhält man ebenfalls einen Fehler, der
    // zu einem Programmabbruch führt:

    // MeinString s3(s1);

    // Ergänzt man MeinString um einen Kopierkonstruktor, tritt 
    // dieser Fehler nicht mehr auf: 
    /*
    class MeinString {
      char* s;
      int n; // Länge des Strings
    public:
      // ...
      MeinString(const MeinString& x) // Kopierkonstruktor
      {
      n = x.n;            // 1
      s = new char[n + 1];  // 2
      strcpy(s, x.s);    // 3
      };//dieser Konstruktor stellt die Klasseninvariante her
    };
    */

    // --------------- Aufgabe 3 -------------------------------

    namespace N_Zuweisungsoperator_außerhalb_der_Klasse
    {
      // Lösung: Wenn ein Zuweisungsoperator außerhalb 
      // der Klasse definiert werden könnte, könnte eine
      // Zuweisung vor dieser Definition ein anderes 
      // Ergebnis haben als eine Zuweisung nach dieser 
      // Definition. Das wäre aber ziemlich verwirrend.

      class MeineKlasse {
        // Hier soll kein Zuweisungsoperator definiert sein.
        // Deshalb erzeugt ihn der Compiler selbst.
        // ...
      };

      MeineKlasse  a, b;

      void Zuweisung1()
      {
        a = b; // Hier wird der vom Compiler erzeugte        
             // Zuweisungsoperator verwendet, da der Compiler  
      }        // nicht weiß, dass später noch ein anderer definiert wird.

      /* Falls das möglich wäre:
      // Ein selbstdefinierter Zuweisungsoperator:
      MeineKlasse & operator=(MeineKlasse& lhs, const MeineKlasse& rhs)
      {
        // ...
      }
      */
      void Zuweisung2()
      {
        a = b; // Hier wird der selbstdefinierte 
             // Zuweisungsoperator verwendet, der 
      }        // eventuell andere Anweisungen ausführt. 

    } // end of namespace N_Zuweisungsoperator_außerhalb_der_Klasse

  // --------------- Aufgabe 3 -------------------------------

    void display(std::string s, int i = -1)
    {
      if (i >= 0) s = s + std::to_string(i);
      std::cout << s << std::endl; // siehe ???
      System::Diagnostics::Trace::WriteLine(rk1::to_String(s));
    } // gibt s im Ausgabe-Fenster (Ansicht|Ausgabe) aus



  } // of namespace N_9_2_6 


// *********** Kap. 9 Aufgabe 9.2.9 Konvertierende und explizite Konstruktoren

  namespace N_explicit {
    class Kreis {
      double r;
    public:
      explicit Kreis(double Radius = 1) :r(Radius) {}
    };

    class Quadrat {
      double a;
    public:
      explicit Quadrat(double Seitenlaenge = 1) :a(Seitenlaenge) {};
    };
    void show(Kreis k) {}
    void show(Quadrat k) {}

    // Fügt man dem Quelltext die Klasse Quadrat ohne "explicit" hinzu,
    // ist der Aufruf show(1) von a) mehrdeutig.

    void Loesung()
    {
      Kreis k;
      k = Kreis(1);
      //
      show(k);
      // show(1); // mehrdeutig
      //  a): beide werden kompiliert
      //  b): Der Aufruf show(1) ist mehrdeutig. Nach 
      //      dieser Erweiterung werden die bisherigen Anweisungen 
      //      nicht mehr kompiliert. 
      //  c): nur show(k) wird kompiliert
      //  d): Wie in c) geht show(1) nicht. Allerdings ist die 
      //      Fehlermeldung präziser.

      Quadrat q;
      show(q);
    }
  } // end of namespace N_explicit


// *********** Kap. 9 Aufgabe 9.2.11 Statische Klassenelemente



  // --------------- Aufgabe 1 -------------------------------
/* ??? http://cppisland.com/?p=501
siehe auch die Diskussion dazu
Singleton& Singleton::Instance()
{
	static Singleton instance;
	return instance;
}


#include <iostream>
#include <mutex>

class Singleton
{
private:
	Singleton(const Singleton&) = delete;
	Singleton & operator=(const Singleton&) = delete;
	

	static std::unique_ptr<Singleton> instance;
	static std::once_flag onceFlag;
public:
	Singleton() = default;

	static void NofityInit()
	{
		std::cout << "Initializing Singleton" << '\n';
	}
	static Singleton& Singleton::Instance()
	{
		std::call_once(Singleton::onceFlag,[] (){
			NofityInit();
			instance.reset(new Singleton); 
		});

		std::cout << "Getting  Singleton instance" << '\n';
		return *(instance.get());
	}
};

std::unique_ptr<Singleton> Singleton::instance;
std::once_flag Singleton::onceFlag;

int main()
{
	Singleton& s1 = Singleton::Instance();
	Singleton& s2 = Singleton::Instance();

	return 0;
}

*/
  
  
  
  class Singleton {
    static Singleton* instance_;
  public:
    static Singleton* Instance();
    int data; // besser private und Zugriffsfunktionen
  private: // protected, falls Singleton als Basisklasse verwendet werden soll
    Singleton() { data = 17; };
  };

  Singleton* Singleton::Instance()
  {
    if (instance_ == nullptr)
      instance_ = new Singleton();
    return instance_;
  };

  Singleton* Singleton::instance_ = nullptr;

  Singleton* p1 = Singleton::Instance();

  void Aufg_Singleton(TextBox^ tb)
  {
    Singleton* p2 = Singleton::Instance();
    p2->data = 19;
    tb->AppendText(p1->data.ToString() + "\r\n"); // p1->data=19
    tb->AppendText(p2->data.ToString() + "\r\n");
    // falls p1 ein gewöhnliches globales Objekt wäre, hätte die
    // globale Variable den Wert 17
  }


// *********** Kap. 9 Aufgabe 9.2.12 Konstante Objekte und Elementfunktionen
  // --------------- Aufgabe 1 -------------------------------
  // a) b)
  namespace N_constElementFkt {

    class Kreis {
      double r;
    public:
      Kreis(const double& Radius = 1)
      {
        r = Radius;
      }
      double Radius() const // <<- 
      {
        return r;
      }
      std::string toStr() const // <<-
      {
        return "Kreis mit Radius " + std::to_string(Radius());
      }
    };

    void show1(Kreis k)
    {
      std::string s = k.toStr();
    }
    void show2(const Kreis& k)
    {
      std::string s = k.toStr(); // dieser Aufruf ist ohne 
    }        // const Elementfunktionen nicht möglich

    // c) const bei allen Elementfunktionen angeben, die direkt
    //    oder indirekt aufgerufen werden.

  } // end of N_constElementFkt
  

// *********** Kap. 9 Aufgabe 9.2.13 std::function
  // --------------- Aufgabe 1 -------------------------------
  
  namespace N_std_function {
    //  ???
    using std::function;

    // globale Funktionen für Aufgabe a)
    void g1() { };
    int g2(int x, std::string y) { return x; }
    std::string g3(int x) { return "s:" + std::to_string(x); };

    class C {
    public:
      // statische Elementfunktionen für b)
      static void s1(void) {};
      static int s2(int x, std::string y) { return 10 * x; };
      static std::string s3(int x) { return "s: " + std::to_string(x); };

      // gewöhnliche Elementfunktionen für c)
      void m1(void) {};
      int m2(int x, std::string y) { return 100 * x; };
      std::string m3(int x) { return "s: " + std::to_string(x); };
    };


    void test_function_assign()
    {
      { // a) globale Funktion
        function<void(void)> g1o = g1;
        function<void()> g1o1 = g1;
        auto g1o2 = g1;
        // Diese Funktionen können so aufgerufen werden:
        g1o();
        g1o1();
        g1o2();

        function<int(int x, std::string y)> g2o = g2;
        int r1 = g2o(1, ""); // r1=

        function<std::string(int x)> g3o = g3;
        std::string s1 = g3o(1); // s1="";
      }
      { // b) statische Elementfunktion
        function<void(void)> s1o = C::s1;
        function<int(int x, std::string y)> s2o = C::s2;
        function<std::string(int x)> s3o = C::s3;
      }
      { // c) nicht statische Elementfunktion
        C c;
        function<void(void)> m1o = std::bind(&C::m1, c);
        function<int(int x, std::string y)>m2o = std::bind(&C::m2, c, 1, "");
        function<std::string(int x)> m3o = std::bind(&C::m3, c, 1);
      }
      { // d) Funktionszeiger
        void(*fp1)();
        fp1 = g1;
        function<void(void)> f1o = fp1;

        int(*fp2)(int x, std::string y);
        fp2 = g2;
        function<int(int x, std::string y)>f2o = fp2;

        std::string(*fp3)(int x);
        fp3 = g3;
        function<std::string(int x)> f3o = fp3;
      }
    }

    // e)
    void call1(std::function<void(void)> f1,
      function<int(int x, std::string y)> f2,
      function<std::string(int x)> f3)
    {
      f1();
      int i2 = f2(1, "");
      std::string s3 = f3(1);
    }


  } // end of N_std_function

  

// *********** Kap. 9 Aufgabe 9.2.15 Klassen und Header-Dateien
  namespace N_9_2_15 {

#include "Kreis.cpp"
#include "Quadrat.cpp"
#include "Rechteck.cpp"
    /* Im Projektmappen-Explorer den Quelldateien hinzufügen:
      // #include "Kreis.cpp"
      // #include "Quadrat.cpp"
      // #include "Rechteck.cpp"
    */
  }
  // Kreis.h

  // Kreis.cpp

  // Quadrat.h

  // Quadrat.cpp

  // Rechteck.h

  // Rechteck.cpp


  void Unittests()
  {
// ???
  }
} // end of namespace N_Loesungen_Klassen_als_Datentypen
