﻿// *********** Kap. 9 Aufgabe 9.2.3 Vererbung



#include <string>
namespace N_Loesungen_Vererbung
{
  using namespace System::Windows::Forms;

  // --------------- Aufgabe 1 -------------------------------

  class C {
    int i, j;
  public:
    C(int x, int y) : i(x), j(y)
    {
      N_Loesungen_Klassen_als_Datentypen::N_KopKonst_ZuwOp::display("Konstruktor C");
    }
    C() : i(0), j(0)
    {
      N_Loesungen_Klassen_als_Datentypen::N_KopKonst_ZuwOp::display("Standardkonstruktor C");
    }
    ~C()
    {
      N_Loesungen_Klassen_als_Datentypen::N_KopKonst_ZuwOp::display("Destruktor C");
    }
  };

  class D : public C {
    int k, a, b;
    C c;
  public:
    D(int x = 1) :c(x, 1), a(x), b(0), k(19)
    {
      N_Loesungen_Klassen_als_Datentypen::N_KopKonst_ZuwOp::display("Konstruktor-1 D");
    }
    D(int x, int y, int z) :C(x, y), a(1), b(2), c(x, y), k(z)
    {
      N_Loesungen_Klassen_als_Datentypen::N_KopKonst_ZuwOp::display("Konstruktor-2 D");
    }
    ~D()
    {
      N_Loesungen_Klassen_als_Datentypen::N_KopKonst_ZuwOp::display("Destruktor D");
    }
  };

  class E : public D {
    int m;
    C c;
    D b;
  public:
    E(int x, int y) :b(y), c(2, 3), m(x + y)
    {
      N_Loesungen_Klassen_als_Datentypen::N_KopKonst_ZuwOp::display("Konstruktor E");
    }
    ~E() {
      N_Loesungen_Klassen_als_Datentypen::N_KopKonst_ZuwOp::display("Destruktor E");
    }
  };

  void Button_9_3_4_1Click(TextBox^ tb)
  {
    tb->AppendText("C c(1,2);\r\n");
    C c(1, 2);    // Konstruktor C
    tb->AppendText("D d(1,2,3);");
    D d(1, 2, 3);  // Konstruktor C
    // Konstruktor C
    // Konstruktor-2 D
    tb->AppendText("E e(1,2);");

      E e(1, 2);    // Standardkonstruktor C
      // Konstruktor C
      // Konstruktor-1 D
      // Konstruktor C
      // Standardkonstruktor C
      // Konstruktor C
      // Konstruktor-1 D
      // Konstruktor E
    }             // Destruktor E
    // Destruktor D
    // Destruktor C
    // Destruktor C
    // Destruktor C
    // Destruktor D
    // Destruktor C
    // Destruktor C
    // Destruktor D
    // Destruktor C
    // Destruktor C
    // Destruktor C


    // --------------- Aufgabe 2 -------------------------------

    class C1DPunkt {
      double x;
    public:
      C1DPunkt(double x_) :x(x_) {  }
      void setzeX(double x_) { x = x_; }
      double X() const { return x; }

      std::string toStr() const
      {
        return std::to_string(x);
      }

      void anzeigen(TextBox^ tb) const
      {
        tb->AppendText(rk1::to_String(toStr()) + "\r\n");
      }
    };

    class C2DPunkt :public C1DPunkt {
      double y;
    public:
      C2DPunkt(double x_, double y_) :C1DPunkt(x_), y(y_) { }
      void setzeY(double y_) { y = y_; }
      double Y() const { return y; }

      std::string toStr() const
      {
        return std::to_string(X()) + "|" + std::to_string(y);
      }

      void anzeigen(TextBox^ tb) const
      {
        tb->AppendText(rk1::to_String(toStr()) + "\r\n");
      }
    };

    class C3DPunkt : public C2DPunkt {
      double z;
    public:
      C3DPunkt(double x_, double y_, double z_) :C2DPunkt(x_, y_), z(z_) {   }
      void setzeZ(double z_) { z = z_; }
      double Z() { return z; }

      std::string toStr()const
      {
        return std::to_string(X()) + "|" + std::to_string(Y()) + "|" + std::to_string(z);
      }

      void anzeigen(TextBox^ tb) const
      {
        tb->AppendText(rk1::to_String(toStr()) + "\r\n");
      }
    };

    void Button_6_3_5_2Click(TextBox^ tb)
    {
      C1DPunkt p1(1);
      C2DPunkt p2(1, 2);
      C3DPunkt p3(1, 2, 3);
      p1.anzeigen(tb);
      p2.anzeigen(tb);
      p3.anzeigen(tb);
    }



    // --------------- Aufgabe 3 -------------------------------

    // a)

    class Quadrat1 {
      double a;
    public:
      Quadrat1(double a_) :a(a_) {}
    };

    class Rechteck1 :public Quadrat1 {
      double b;
    public:
      Rechteck1(double a_, double b_) :Quadrat1(a_), b(b_) {}
    };

    // b)

    class Rechteck2 {
      double a, b;
    public:
      Rechteck2(double a_, double b_) :a(a_), b(b_) {};
    };

    class Quadrat2 :public Rechteck2 {
    public:
      Quadrat2(double a_) :Rechteck2(a_, a_) {}
    };

    // c)

    // Bei der Hierarchie in a) sind die geerbten Funktionen Umfang und 
    // Fläche in der abgeleiteten Klasse falsch. Bei b) sind sie richtig.

    // d)

    // Bei der Hierarchie b) benötigt jedes Quadrat doppelt soviel
    // Speicherplatz wie bei der unter a).


    // --------------- Aufgabe 4 -------------------------------

    // Da Konstruktoren nicht vererbt werden, stehen diese in der abgeleiteten 
    // Klasse nicht zur Verfügung. Bei einer Klasse mit vielen nützlichen 
    // Konstruktoren wie z.B. einer Stringklasse kann das ein gravierender 
    // Nachteil sein. Man kann diese zwar in der abgeleiteten Klasse wieder 
    // alle definieren. Es ist aber fraglich, ob sich dieser Aufwand lohnt und 
    // man nicht besser beim Aufruf eines vorhandenen Konstruktors eine 
    // Konversionsfunktion wie Convert::ToInt verwendet.




// *********** Kap. 9 Aufgabe 9.3.8 Konversionen zwischen Klassen

    // --------------- Aufgabe 1 -------------------------------
    /*
    a)  Ein Automobil hat einen Motor und Räder. Vermutlich wird nie jemand
        sagen, dass ein Automobil ein Motor oder ein Rad ist.

    b)  Eine Katze bzw. ein Hund ist Tier. Von einer 'hat ein'-Beziehung kann
        man höchstens dann reden, wenn ein Hund eine Katze gefressen hat oder
        eine Katze einen Hund hält.

    c)  Ein Landfahrzeug bzw. ein Wasserfahrzeug ist ein Fahrzeug. Ein Automobil
        ist ein Landfahrzeug, ein Segelboot ist ein Wasserfahrzeug. Von einer
        'hat ein'-Beziehung kann man höchstens dann reden, wenn ein
        Wasserfahrzeug ein Landfahrzeug transportiert.

    d)  Hier sind beide Sichtweisen möglich: Ein Abteilungsleiter und eine "
        Sekretärin sind Mitarbeiter. Ein Abteilungsleiter hat eine Sekretärin "
        und Mitarbeiter. Im ersten Fall werden die Mitarbeiter einer Firma "
        modelliert. Im zweiten Fall wird eine Abteilung modelliert. Es soll "
        auch Sekretärinnen geben, die einen Abteilungsleiter haben.
    */


      // --------------- Aufgabe 2 -------------------------------

    /*
     Mit einer Konversion der Basisklasse in eine abgeleitete Klasse könnte 
     man über ein Objekt der abgeleiteten Klasse ein Element der 
     Basisklasse ansprechen, das überhaupt nicht existiert. 
    */

// *********** Kap. 9 Aufgabe 9.3.9 Mehrfachvererbung

    namespace N_Mehrfachvererbung { // namespace to avoid name conflicts
        // --------------- Aufgabe 1 -------------------------------
      class Kreis {
        double r;
        static const double pi;
      public:
        Kreis(double Radius)
        {
          r = Radius;
        }
        double Flaeche()
        {
          return r*r*pi;
        }
        double Umfang()
        {
          return 2 * r*pi;
        }
        std::string toStr() const
        {
          return "Kreis mit Radius " + std::to_string(r);
        }
      };
      const double Kreis::pi = 3.14;

      class C2DPunkt {
        double x, y;
      public:
        C2DPunkt(double x_, double y_) :x(x_), y(y_) { }
        double Abstand()
        {
          return std::sqrt(x*x + y*y);
        }
        std::string toStr() const
        {
          return std::to_string(x) + "|" + std::to_string(y);
        }
      };

      // a)
      namespace N_a {
        class C2DKreis :public Kreis, public C2DPunkt {
        public:
          C2DKreis(double Radius = 1, double x = 0, double y = 0) :
            Kreis(Radius), C2DPunkt(x, y) { }
          C2DKreis(double Radius, C2DPunkt pos) :
            Kreis(Radius), C2DPunkt(pos) { }
          // Eine in dieser Klasse definierte Funktion toStr verdeckt die Funktionen
          // toStr der Basisklasse:
        };

        // s1 = ???
          // C2DKreis erbt alle public Elementfunktionen der Basisklassen, also 
          // Flaeche, Umfang und toStr. Ein Aufruf von toStr über ein Objekt der 
          // Klasse C2DKreis ist dann mehrdeutig.
        // s2 = ???
          // Diese Hierarchie ist nicht geeignet, da ein Kreis mit einer Position 
          // zwar ein Kreis, aber kein Punkt ist.

      } // end of namespace N_a

      // b)
      namespace N_b {
        class C2DKreis {
          Kreis k;
          C2DPunkt Position;
        public:
          C2DKreis(double Radius = 1, double x = 0, double y = 0) :
            k(Radius), Position(x, y) { }
          C2DKreis(double Radius, C2DPunkt pos) :
            k(Radius), Position(pos) { }
          // Eine in dieser Klasse definierte Funktion toStr verdeckt keine
          // Funktionen der Basisklasse:
          std::string toStr() const
          {
            return k.toStr() + " Pos: " + Position.toStr();
          }
        };
        const char* s1 =
          "Da hier keine Vererbung verwendet wird, erbt C2DKreis keine "
          "Elementfunktionen der Klasse Kreis und kann die Funktionen dieser "
          "Klasse Kreis auch nicht wiederverwenden.\r\n\r\n";
        const char* s2 =
          "Diese Hierarchie ist nicht geeignet, da ein Kreis mit einer Position ein "
          "Kreis ist, aber die Funktionen der Klasse Kreis nicht verwendet.\r\n\r\n";
      } // end of namespace N_b

      // c)
      namespace N_c {
        class C2DKreis :public Kreis {
          C2DPunkt Position;
        public:
          C2DKreis(double Radius = 1, double x = 0, double y = 0) :
            Kreis(Radius), Position(x, y) { }
          C2DKreis(double Radius, C2DPunkt pos) :
            Kreis(Radius), Position(pos) { }
        };
        const char* s1 =
          "C2DKreis erbt alle public Elementfunktionen der Basisklasse, also "
          "Flaeche, Umfang und toStr. Alle diese Funktionen liefern auch über "
          "ein Objekt der Klasse C2DKreis richtige Ergebnisse. Die "
          "Elementfunktionen von C2DPunkt stehen dagegen nicht zur Verfügung.\r\n\r\n";
        const char* s2 =
          "Diese Hierarchie ist geeignet, da ein C2DKreis ein Kreis, aber kein "
          "C2DPunkt ist.\r\n\r\n";
      } // end of namespace N_c

      // d)
      namespace N_d {
        class C2DKreis {// Lösung von Aufgabe 6.2.2, 3.
          double r;
          C2DPunkt Position;
        public:
          C2DKreis(double Radius = 1, double x = 0, double y = 0) :
            r(Radius), Position(x, y) { } // Reihenfolge der Deklaration
          C2DKreis(double Radius, C2DPunkt pos) :
            r(Radius), Position(pos) { } // Reihenfolge der Deklaration
          std::string toStr()
          {
            return "Kreis mit Radius " + std::to_string(r) + " in Position " + Position.toStr();
          }
        };
        const char* s1 =
          "Wenn man in der Klasse C2DKreis die Funktionen Flaeche, Abstand usw. "
          "für einen Kreis haben will, muss man sie erneut definieren. Diese "
          "Redundanz sollte man vermeiden.";
        const char* s2 =
          "Abgesehen davon ist diese Alternative geeignet.";
      } // end of namespace N_d

      void Button_6_3_11_1Click(TextBox^ tb)
      {
        // a)
        tb->AppendText("a)\r\n");
        N_a::C2DKreis ka(1, 2, 3);
        tb->AppendText(ka.Umfang().ToString() + "\r\n"); // das geht
        tb->AppendText(ka.Abstand().ToString() + "\r\n"); // das geht
        tb->AppendText(ka.Flaeche().ToString() + "\r\n"); // das geht
        // tb->AppendText(ka.toStr()); // Mehrdeutig
        // error: Mehrdeutiger Zugriff von "toStr".
        // könnte "toStr" in Basis "N_6_3::N_3_11_1::Kreis" sein
        // oder könnte "toStr" in Basis "N_6_3::N_3_11_1::C2DPunkt" sein
        // ??? tb->AppendText(rk1::to_String(N_a::s1) + "\r\n");
        tb->AppendText("\r\n");
        // ??? tb->AppendText(rk1::to_String(N_a::s2) + "\r\n");
        // b)
        tb->AppendText("b)\r\n");
        N_b::C2DKreis kb(1, 2, 3);
        // tb->AppendText(kb.Umfang().ToString()+"\r\n"); // geht nicht
        // tb->AppendText(kb.Abstand().ToString()+"\r\n"); // geht nicht
        // tb->AppendText(kb.Flaeche().ToString()+"\r\n"); // geht nicht
        tb->AppendText(rk1::to_String(kb.toStr()) + "\r\n"); // das geht
        tb->AppendText(rk1::to_String(N_b::s1));
        tb->AppendText("");
        tb->AppendText(rk1::to_String(N_b::s2));
        // c)
        tb->AppendText("c)+\r\n");
        N_c::C2DKreis kc(1, 2, 3);
        tb->AppendText(kc.Umfang().ToString() + "\r\n"); // das geht
        // tb->AppendText(kc.Abstand().ToString()+"\r\n"); // geht nicht
        tb->AppendText(kc.Flaeche().ToString() + "\r\n"); // das geht
        tb->AppendText(rk1::to_String(kc.toStr()) + "\r\n"); // das geht
        tb->AppendText(rk1::to_String(N_c::s1) + "\r\n");
        tb->AppendText("\r\n");
        tb->AppendText(rk1::to_String(N_c::s2) + "\r\n");
        // d)
        tb->AppendText("d)\r\n");
        N_d::C2DKreis kd(1, 2, 3);
        //tb->AppendText(kd.Umfang().ToString()+"\r\n"); // geht nicht
        //tb->AppendText(kd.Abstand().ToString()+"\r\n"); // geht nicht
        tb->AppendText(rk1::to_String(N_d::s1) + "\r\n");
        tb->AppendText("\r\n");
        tb->AppendText(rk1::to_String(N_d::s2) + "\r\n");
      }

    } // end of namespace N_Mehrfachvererbung

    void Unittests()
    {
    }
} // end of namespace N_Loesungen_Vererbung


