﻿// *********** Kap. 9 Aufgabe 9.4.3 Virtuelle Funktionen




#include <string>
#include <cmath> // für fabs und sqrt
namespace N_Loesungen_Polymorphie
{
  using System::Windows::Forms::TextBox;
  using System::Windows::Forms::MessageBox;

  // --------------- Aufgabe 1 -------------------------------
  namespace N_Aufgabe_1
  {
    class C
    {
      virtual void f0();
      virtual void f1() const;
      virtual void f2(int n = 0);
      virtual int f3(int);
      void f4();
      virtual void f5(const int n);
      virtual void f6(const int& n);
      virtual C& f7();
    };
    class D : public C
    {
      // virtual override void f0() ; // Fehler: override muss hinten stehen
      // virtual void f1() override; // Fehler: C::f0 wird wegen const 
                                  // nicht überschrieben
      // void f2() override; // C::f hat einen int-Parameter
      int f3(int = 0) override;
      // void f4() override; // Fehler: C::f4 ist nicht virtuell
      void f5(int n) override; // int und const int werden als gleich betrachtet
      // void f6(int& n) override; // int und int& werden nicht als gleich betrachtet
      D& f7() override;
    };
  }

  // --------------- Aufgabe 2 -------------------------------

  class C1DPunkt {
    double x;
  public:
    C1DPunkt(double x_) :x(x_) {  }
    void setzeX(double x_) { x = x_; }
    double X() const { return x; }

    virtual std::string toStr() const
    {
      return "(" + std::to_string(x) + ")";
    }

    // c)
    void anzeigen(TextBox^ tb) const
    {
      tb->AppendText(rk1::to_String(toStr()) + "\r\n");
    }
    // d)
    virtual double length() const
    {
      return std::fabs(x);
    }
  };

  class C2DPunkt :public C1DPunkt {
    double y;
  public:
    C2DPunkt(double x_, double y_) :C1DPunkt(x_), y(y_) {  }
    void setzeY(double y_) { y = y_; }
    double Y() const { return y; }

    std::string toStr() const override
    {
      return "(" + std::to_string(X()) + "|" + std::to_string(Y()) + ")";
    }

    // d)
    double length() const override
    {
      return std::sqrt(X()*X() + Y()*Y());
    }
  };

  class C3DPunkt :public C2DPunkt {
    double z;
  public:
    C3DPunkt(double x_, double y_, double z_) :C2DPunkt(x_, y_), z(z_) {  }
    void setzeZ(double z_) { z = z_; }
    double Z() const { return z; }

    std::string toStr() const override
    {
      return "(" + std::to_string(X()) + "|" + std::to_string(Y()) + "|" + std::to_string(z) + ")";
    }

    // d)
    double length() const override
    {
      return std::sqrt(X()*X() + Y()*Y() + z*z);
    }
  };

  // b)
  void show(TextBox^ tb, C1DPunkt& p)
  {
    tb->AppendText(rk1::to_String(p.toStr()) + "\r\n");
  };


  void testVirtuelleFunktionen(TextBox^ tb)
  {
    // a)
    tb->AppendText("toStr() \r\n");
    C1DPunkt* p1 = new C1DPunkt(1);
    tb->AppendText(rk1::to_String(p1->toStr()) + "\r\n");
    p1 = new C2DPunkt(2, 3);
    tb->AppendText(rk1::to_String(p1->toStr()) + "\r\n");
    p1 = new C3DPunkt(4, 5, 6);
    tb->AppendText(rk1::to_String(p1->toStr()) + "\r\n");

    // b)
    tb->AppendText("show \r\n");
    C1DPunkt q1(7);
    C2DPunkt q2(8, 9);
    C3DPunkt q3(10, 11, 12);
    show(tb, q1); // C1DPunkt::toStr
    show(tb, q2); // C2DPunkt::toStr
    show(tb, q3); // C3DPunkt::toStr

    // c)
    tb->AppendText("anzeigen\r\n");
    q1.anzeigen(tb); // C1DPunkt::toStr
    q2.anzeigen(tb); // C2DPunkt::toStr
    q3.anzeigen(tb); // C3DPunkt::toStr

    // d)
    tb->AppendText("length() \r\n");
    p1 = new C1DPunkt(1);
    double l1 = p1->length();
    tb->AppendText(rk1::to_String(std::to_string(l1)) + "\r\n");
    p1 = new C2DPunkt(3, 4);
    double l2 = p1->length(); // 5
    tb->AppendText(rk1::to_String(std::to_string(l2)) + "\r\n");
    p1 = new C3DPunkt(1, 2, 2);
    double l3 = p1->length(); // 3
    tb->AppendText(rk1::to_String(std::to_string(l3)) + "\r\n");
  }


  // --------------- Aufgabe 3 -------------------------------

  namespace N_Aufgabe_3
  {
    class C {
    public:
      virtual std::string f(int x)
      {
        return "C::f";
      }
    };
    class D :public C
    {
    public:
      virtual std::string f(int x)
      {
        return "D::f";
      }
    };


    void test(TextBox^ tb)       
    {
      C* pc = new D();
      tb->AppendText(rk1::to_String(pc->f(1)));
    }

  } // end of namespace N_Aufgabe_3




// *********** Kap. 9 Aufgabe 9.4.4

  // --------------- Aufgabe 1 -------------------------------

      // "Diese Funktionen können nicht virtuell definiert werden, da alle ihre "
      // "Parameterlisten verschieden sind.




  void test(TextBox^ tb)
  {
    testVirtuelleFunktionen(tb);
  }


} // end of namespace N_Loesungen_Polymorphie



