﻿// *********** Kap. 14 Lösungen Kapitel 14. Funktoren und Lambda-Ausdrücke




#include <string>
#include <iostream>
#include <ctime>
#include <vector>
#include <algorithm>
#include <functional>

namespace N_Loesungen_Funktoren {
  using namespace System::Windows::Forms;

// *********** Kap. 14 Aufgabe 14.1 ??? 8.2.13 aus OO - Funktionen als Objekte und ...
  // ??? Das ist die Aufgabe 9.2.13 aus dem Kap. OO
  namespace N_functional_Grundlagen {

    // globale Funktionen
    void g1() { };
    int g2(double d, std::string s) { return 0; }
    double g3(int x) { return 0; }
    std::string g4(int x) { return "g4"; }

    class C1 {
    public:
      // statische Elementfunktionen
      static void s1(void) {}
      static int s2(double x, std::string s) { return 0; }
      static double s3(int x) { return 1; }
      static std::string s4(int x) { return ""; }

      // gewöhnliche Elementfunktionen
      void f1(void) {}
      int f2(double x, std::string s) { return 0; }
      double f3(int x) { return 1; }
      std::string f4(int x) { return ""; }


      // ???

    };

    // Funktionszeiger

    void test_function_assign()
    {
      { // a) globale Funktion

        std::function<void(void)> g1o = g1;
        g1o();
        std::function<void()> g1o1 = g1;
        g1o1();
        auto g1o2 = g1;
        g1o2();
        std::function<int(double x, std::string y)> g2o = g2;
        std::function<double(int x)> g3o = g3;
        std::function<std::string(int x)> g4o = g4;
      }
      { // b) statische Elementfunktion

        std::function<void(void)> s1o = C1::s1;
        s1o();
        std::function<int(double, std::string)> s2o = C1::s2;
        int rb2 = s2o(3.14, "");
        std::function<double(int)> s23 = C1::s3;
        double rb3 = s23(1);
        std::function<std::string(int)> s24 = C1::s4;
        std::string rb4 = s24(1);
      }
      { // c) nicht statische Elementfunktion
        C1 c;
        std::function<void(void)> f1o = std::bind(&C1::f1, &c);
        f1o();
        std::function<int(double, std::string)> f2o = std::bind(&C1::f2, &c, std::placeholders::_1, std::placeholders::_2);
        int rb2 = f2o(3.14, "");
        // oder
        std::function<int(C1*, double, std::string)> f2o0 = std::mem_fn(&C1::f2);
        f2o0(&c, 3.14, "cc");
        using namespace std::placeholders;
        std::function<double(int)> f3o = std::bind(&C1::f3, &c, _1);
        double rb3 = f3o(1);
        std::function<std::string(int)> f4o = std::bind(&C1::f4, &c, _1);
        std::string rb4 = f4o(1);
      }
      { // d) Funktionszeiger
        void(*fp1)(void) = g1;
        fp1();
        int(*fp2)(double, std::string) = g2;
        int r2 = fp2(1, "");
        double(*fp3)(int) = g3;
        double r3 = fp3(1);
        std::string(*fp4)(int) = g4;
        std::string r4 = fp4(1);
      }
    }
  } // end of namespace N_functional_Grundlagen {


// *********** Kap. 14 Aufgabe 14.2 Prädikate und Vergleichsfunktionen

  // --------------- Aufgabe 1 -------------------------------

  // a)
  bool absteigend(int a, int b)
  {
    return a > b;
  }

  struct Absteigend {
    bool operator()(int a, int b)
    {
      return a > b;
    }
  };

  void zeige_Container(TextBox^ tb, std::vector<int> v)
  {
    for (auto i : v) // ab Visual Studio 2015, sonst gewöhnliche for-Schleife
      tb->AppendText(i.ToString() + " ");
    tb->AppendText("\r\n");
  }

  void Sortiere_1_a()
  {
    std::vector<int> v = { 3,1,5,1,7 };

    // a)
    // mit einer Funktion:
    std::sort(v.begin(), v.end(), absteigend); // v = { 7, 5, 3, 1, 1 }
    // mit einem Funktor:
    std::sort(v.begin(), v.end(), Absteigend());
    // mit einem vordefinierten Funktor:
    std::sort(v.begin(), v.end(), std::greater<int>());

    // greater_equal geht nicht:
    // std::sort(v.begin(), v.end(), std::greater_equal<int>()); // Debug-Fehler
  }

  // b)
  struct Absteigend_s {
    bool operator()(std::string a, std::string b)
    {
      return a > b;
    }
  };

  bool absteigend_s(std::string a, std::string b)
  { // eine überladene Funktion für int-Parameter geht nicht
    return a > b;
  }

  void Sortiere_1_b(TextBox^ tb)
  {
    tb->AppendText("Sortiere_1_b \r\n");
    std::vector<int> v = { 3,1,5,1,7 };

    std::vector<std::string> vs = { "de","abc","def" };
    std::sort(vs.begin(), vs.end()); // aufsteigend
    std::sort(vs.begin(), vs.end(), std::greater<std::string>());
    std::sort(vs.begin(), vs.end(), absteigend_s);
    std::sort(vs.begin(), vs.end(), Absteigend_s());

    for (auto i : v)
    {
      tb->AppendText(Convert::ToString(i) + " ");
    }
  }

  // c)
  struct FileInfo {
    std::string Name; // Name der Datei
    long long Length; // Dateigröße
  };

  // e)
  bool nach_Groesse_aufsteigend(const FileInfo& a, const FileInfo& b)
  {
    return a.Length < b.Length;
  }

  // f)
  struct nach_Groesse_Absteigend
  { // alternativ Funktor
    bool operator()(FileInfo a, FileInfo b)
    {
      return a.Length > b.Length;
    }
  };

  // g)
  bool nach_Name_aufsteigend(const FileInfo& a, const FileInfo& b)
  {
    return a.Name < b.Name;
  }

  // h)
  bool nach_Name_absteigend(const FileInfo& a, const FileInfo& b)
  {
    return a.Name < b.Name;
  }

  void sortiere_Dateien()
  {
    std::vector<FileInfo> vf = { { "config.sys",100 },{ "Windows.h",1000 },{ "small.h",10 } };
    // e)
    std::sort(vf.begin(), vf.end(), nach_Groesse_aufsteigend);
    // f)
    std::sort(vf.begin(), vf.end(), nach_Groesse_Absteigend());
    // g)
    std::sort(vf.begin(), vf.end(), nach_Name_aufsteigend);
    // h)
    std::sort(vf.begin(), vf.end(), nach_Name_absteigend);
    int br = 1;
  }

  // --------------- Aufgabe 2 -------------------------------

  bool Contains(const std::string& src, const std::string& pattern)
  {
    bool result = src.find(pattern) != std::string::npos;
    return result;
  }

  bool sortiereNachFehlerart(const std::string& s1, const std::string& s2)
  {
    if (Contains(s1, "Fehler") != Contains(s2, "Fehler"))
      return Contains(s1, "Fehler");
    if (Contains(s1, "Warnung") != Contains(s2, "Warnung"))
      return Contains(s1, "Warnung");
    if (Contains(s1, "Info") != Contains(s2, "Info"))
      return Contains(s1, "Fehler");
    return false;
  }

  void sortiere_Meldungen()
  {
    std::vector<std::string> Meldungen = {
      "2.12.2015, 2.15: Fehler 0815: Festplatte voll",
      "2.2.2016, 2.18: Warnung: LAN-Kabel abgezogen",
      "2.2.2016, 2.19: Info: Keine Internetverbindung",
      "2.2.2016, 3.18: Info: LAN-Verbindung neu aufgebaut",
      "3.4.2016, 20.25: Fehler 0816: Kein Strom",
      "12.6.2016, 3.32: Fehler 0715: CPU zu heiß",
      "12.6.2016, 4.08: Fehler 0716: CPU zu kalt"
    };
    std::sort(Meldungen.begin(), Meldungen.end(), sortiereNachFehlerart);
  }


// *********** Kap. 14 Aufgabe 14.4 Lambda-Ausdrücke
  // --------------- Aufgabe 1 -------------------------------

  void f(std::function<int(int)>) { };

  void A()
  {
    // a)
    std::function<void(void)> f1 = []() {};
    std::function<int(double x, std::string y)> f2 =
      [](double x, std::string y) {return x; };
    std::function<double(int x)> f3 = [](int x) { return 0.0; };
    std::function<std::string(int x)> f4 = [](int x) { return ""; };
    // Aufrufe:
    f1();
    int r2 = f2(3.1, "");
    double r3 = f3(1);
    std::string r4 = f4(1);

    // b)

    // f([](int x) { return x + 1}); // ; fehlt vor }
    f([](int x) { return x + 1; });
    // f([](int x) { return x + 1; };); // ; nach }
    // f([]() { return 3.14; });  // Parameter fehlt
    // f([] x{ return x + 1 }); // x 
    // f([]()->int { return 3.14; });
    // f([]->int { return 3.14; });
    // f([](int x) return x + 1; // Klammern um return fehlen

  }

  // --------------- Aufgabe 2 -------------------------------

  void sortiere_mit_Lambdas(std::vector<FileInfo> vf)
  {
    std::sort(vf.begin(), vf.end(), [](const FileInfo& a, const FileInfo& b)
    { return a.Length < b.Length; }); // nach_Groesse_aufsteigend

    std::sort(vf.begin(), vf.end(), [](const FileInfo& a, const FileInfo& b)
    { return a.Length > b.Length; }); // nach_Groesse_absteigend

    std::sort(vf.begin(), vf.end(), [](const FileInfo& a, const FileInfo& b)
    { return a.Name < b.Name; });    // nach_Name_aufsteigend

    std::sort(vf.begin(), vf.end(), [](const FileInfo& a, const FileInfo& b)
    { return a.Name < b.Name; });    // nach_Name_absteigend
  }

  void test(TextBox^ tb)
  {
    Sortiere_1_a();
    Sortiere_1_b(tb);
    sortiere_Dateien();
    sortiere_Meldungen();
    std::vector<FileInfo> vf = { {"",100},{"",10},{"",1000} };
    sortiere_mit_Lambdas(vf);
    A();
  }
  

  // --------------- Aufgabe 3 -------------------------------

  // ??? Klasse BenchmarkTimer hier oder bei Chrono

} // end of namespace N_Loesungen_Funktoren
